//**  ,     VCL Delphi.
//**  Vladimir Kladov, 2000-2010
//**
//**      .
//**     /     
//**  2          
//**   GNU,  Free Software Foundation.
//**
//**       ,    
//** ,       ,   
//**         
//**   .      
//**     GNU.
//**
//**          
//**   GNU.     ,     Free
//** Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//** MA 02111-1307, USA.
//******************************************************************************

{************************************************}
{                                                }
{    TNewQuery     SQL. }
{   Copyright (c) 2003 by Vladimir Kladov        }
{                                                }
{           05.08.2003         }
{                                                }
{************************************************}
{           18.02.2010         }
{************************************************}
unit AdoSqlUnit;
{*    TNewQuery,  TQuery,  
     .  :    
         SField, SFieldN, IField, IFieldN,
   FField, FFieldN  ..,      .  
         Q[ ' ' ] as String, 
      Q.SField[ ' ' ].   
        ,    NULL ( 
      "as " ,   
    invalid variant conversion    null). 
       ,     
        null (  null,   null 
      ,       
   ).      , , .
       TQuery = TNewQuery,  ,
        TQuery / TADOQuery   TNewQuery
         uses  ,  
       .

    :   Open  Execute  
          ()
      ,      
          , ,
      (.  utPhotoExc). }

interface

{$I VCL_VERSIONS.INC}

{$IFDEF BDE_DB}
{$DEFINE NOADO_NOODBC}
{$ENDIF}
{$IFDEF NOADO_NOODBC}
{$DEFINE BDE_DB}
{$IFDEF  ADO_DB}
{$UNDEF ADO_DB}
{$ENDIF}
{$IFDEF  ODBC_DIRECT}
{$UNDEF ODBC_DIRECT}
{$ENDIF}
{$ENDIF}
{$IFNDEF ODBC_DIRECT}
{$IFNDEF ADO_DB}
{$IFNDEF NOADO_NOODBC}
{$DEFINE ADO_DB}
{$ENDIF}
{$ENDIF}
{$ENDIF}

uses
    Windows, classes, Dialogs, Forms, Controls, DB, DBtables, SysUtils, comobj
    {$IFDEF ODBC_DIRECT}
    , ODBCQuery
    {$ENDIF}
    {$IFDEF ADO_DB}
    , ADODB
    {$ENDIF}
    {$IFDEF _D6orHigher}
    , Variants
    {$ENDIF}
    ;

{$IFNDEF ADO_DB}
{$IFNDEF ODBC_DIRECT}
{$DEFINE BDE_DB}
{$ENDIF}
{$ENDIF}

type
    TOnNeedReconnect = function(Sender: TObject): Boolean of object;

    {$IFDEF ADO_DB}
    TOldQuery = TADOQuery;
    {$ELSE}
    TOldQuery = TQuery;
    {$ENDIF}

    {$IFDEF ODBC_DIRECT}
    TBaseQuery = TODBCQuery;
    TCreateParent = Boolean;
    {$ELSE}
    {$IFDEF ADO_DB}
    TBaseQuery = TADOQuery;
    TCreateParent = TADOConnection;
    {$ELSE}
    TBaseQuery = TQuery;
    TCreateParent = TDataBase;
    {$ENDIF}
    {$ENDIF}

    TNewQuery = class(TBaseQuery)
        {*  TNewQuery    TQuery. ,   
                AD_DB }
    private
        FChangeSQLCursor: Boolean;
        function Get_FField(const Name: String): Double;
        function GetIField(const Name: String): Integer;
        function GetBoolField(const Name: String): Boolean;
        function GetSField(const Name: String): String;
        function GetDParam(const Name: String): TDateTime;

        {$IFNDEF BDE_DB}
        function Get_FFieldK(var K: Integer; const Name: String): Double;
        function GetIFieldK(var K: Integer; const Name: String): Integer;
        function GetSFieldK(var K: Integer; const Name: String): String;
        function Get_DFieldK(var K: Integer; const Name: String): TDateTime;
        function GetBFieldK(var K: Integer; const Name: String): TStream;
        {$ENDIF}

        function GetFParam(const Name: String): Double;
        function GetIParam(const Name: String): Integer;
        function GetSParam(const Name: String): String;
        function GetVParam(const Name: String): Variant;
        procedure SetDParam(const Name: String; const Value: TDateTime);
        procedure SetFParam(const Name: String; const Value: Double);
        procedure SetIParam(const Name: String; const Value: Integer);
        procedure SetSParam(const Name, Value: String);
        procedure SetVParam(const Name: String; const Value: Variant);
        function GetDFieldN(Idx: Integer): TDateTime;
        function Get_FFieldN(Idx: Integer): Double;
        function GetIFieldN(Idx: Integer): Integer;
        function GetBoolFieldN(Idx: Integer): Boolean;
        function GetSFieldN(Idx: Integer): String;
        function GetNullField(const Name: String): Boolean;
        {$IFNDEF BDE_DB}
        function GetNullFieldK(var K: Integer; const Name: String): Boolean;
        {$ENDIF BDE_DB}
        function GetBField(const Name: String): TStream;
        function GetBFieldN(Idx: Integer): TStream;
        procedure SetBParam(const Name: String; const Value: String);
        function Get_FieldNames(Idx: Integer): String;
        function GetFieldType(Idx: Integer): TFieldType;
        procedure SetChangeSQLCursor(const Value: Boolean);
        function GetSQLErrors: Boolean;
        procedure SetSQLErrors(const Value: Boolean);
    private
        function Get_DField(const Name: String): TDateTime;
        function GetNullFieldN(Idx: Integer): Boolean;
    protected
        FIsActive: Boolean;
    public
        property IsActive: Boolean read FIsActive;
    protected
        procedure SetNoActive;
        procedure DoBeforeOpen; {$IFNDEF ODBC_DIRECT} override; {$ENDIF}
        procedure DoAfterOpen; {$IFNDEF ODBC_DIRECT} override; {$ENDIF}
        function GetText: String;
        procedure SetText(const Value: String);
    public
        CanCancel: Boolean;
        {*   ,       
            (    , .  Cancel). }
        constructor Create(AOwner: TComponent{$IFNDEF ODBC_DIRECT}; AConn: TCreateParent = nil{$ENDIF});
        {$IFDEF ODBC_DIRECT} override;
        {$ELSE}
        reintroduce;
        {$ENDIF}
        destructor Destroy; override;
        {* . }
        procedure ExecSQL;
        {*    . }
        procedure Open;
        {*        ( 
           )   . }
        procedure Close;
        {*  ,  RecordSet   
              . }
        function Cancel: Boolean; reintroduce;
        {*    .   ,   CanCancel
            FALSE (   TRUE). }
        property IField[const Name: String]: Integer read GetIField;
        {*        Integer (). }
        property BoolField[const Name: String]: Boolean read GetBoolField;
        {*        Boolean (). }
        property SField[const Name: String]: String read GetSField;
        {*        String ( ANSI). }
        property FField[const Name: String]: Double read Get_FField;
        {*      Double (,     
               money / currency). }
        property DField[const Name: String]: TDateTime read Get_DField;
        {*        TDateTime (, ). }
        property BField[const Name: String]: TStream read GetBField;
        {*        blob-. }
        property IFieldN[Idx: Integer]: Integer read GetIFieldN;
        {*        Integer. }
        property BoolFieldN[Idx: Integer]: Boolean read GetBoolFieldN;
        {*        Boolean. }
        property SFieldN[Idx: Integer]: String read GetSFieldN;
        {*        String. }
        property FFieldN[Idx: Integer]: Double read Get_FFieldN;
        {*        Double. }
        property DFieldN[Idx: Integer]: TDateTime read GetDFieldN;
        {*        TDateTime. }
        property BFieldN[Idx: Integer]: TStream read GetBFieldN;
        {*        blob-.}

        {$IFNDEF BDE_DB}
        property IFieldK[var K: Integer; const Name: String]: Integer read GetIFieldK;
        {*        Integer (). }
        property SFieldK[var K: Integer; const Name: String]: String read GetSFieldK;
        {*        String ( ANSI). }
        property FFieldK[var K: Integer; const Name: String]: Double read Get_FFieldK;
        {*      Double (,     
               money / currency). }
        property DFieldK[var K: Integer; const Name: String]: TDateTime read Get_DFieldK;
        {*        TDateTime (, ). }
        property BFieldK[var K: Integer; const Name: String]: TStream read GetBFieldK;
        {*        blob-. }
        {$ENDIF BDE_DB}

        property IParam[const Name: String]: Integer read GetIParam write SetIParam;
        {*   Integer-   . }
        property SParam[const Name: String]: String read GetSParam write SetSParam;
        {*   String-   . }
        property FParam[const Name: String]: Double read GetFParam write SetFParam;
        {*   Double-   . }
        property DParam[const Name: String]: TDateTime read GetDParam write SetDParam;
        {*   TDateTime-   . }
        property BParam[const Name: String]: String write SetBParam;
        {*   blob-   . }
        property VParam[const Name: String]: Variant read GetVParam write SetVParam;
        {* +++ *}
        property NullField[const Name: String]: Boolean read GetNullField;
        {*  ,        NULL.  }
        {$IFNDEF BDE_DB}
        property NullFieldK[var K: Integer; const Name: String]: Boolean read GetNullFieldK;
        {*  ,        NULL.  }
        {$ENDIF}
        property NullFieldN[Idx: Integer]: Boolean read GetNullFieldN;
        {*  ,        NULL.  }
        procedure NullParam(const Name: String; FieldType: TFieldType = ftUnknown);
        {*   NULL     .  
              .  }
        {$IFDEF ADO_DB}
        function ParamByName(const Name: String): Variant;
        {$ENDIF}
        property FieldNames[Idx: Integer]: String read Get_FieldNames;
        property Fieldtypes[Idx: Integer]: TFieldType read GetFieldType;
    protected
        Completed: Boolean;
        FSaveLog: Boolean;
        procedure EventAfterOpen(DataSet: TDataSet);
    published
        {$IFDEF ADO_DB}
        property CommandTimeout;
        {*    -   ADO.    
              ,   . }
        {$ENDIF}
        property SaveLog: Boolean read FSaveLog write FSaveLog;
        property Text: String read GetText write SetText;
        property ChangeSQLCursor: Boolean read FChangeSQLCursor write SetChangeSQLCursor;
        property SQLErrors: Boolean read GetSQLErrors write SetSQLErrors;
    public
        function FindField(const S: String): Integer;
    end;

type
    TQuery = TNewQuery;

var ExecutingQuery: TNewQuery;
    OnNeedReconnect: TOnNeedReconnect;
    //{$IFNDEF ODBC_DIRECT}
    {$IFDEF ADO_DB}
    DefaultConnection: TADOConnection;
    {$ELSE}
    DefaultDB: TDataBase;
    {$ENDIF}
    //{$ENDIF}
    DefaultDatabaseName: String;

var Query_raise_errors: Boolean = TRUE;

procedure Register;
function Check_Active_queries_count: Integer;

implementation

uses UtilsUnit, utTraceLog, syncobjs;

var Active_queries_list: TStringList;

procedure Register;
begin
    RegisterComponents('Kladov', [TNewQuery]);
end;

var Crit_sec: _RTL_CRITICAL_SECTION;

function Check_Active_queries_count: Integer;
begin
    EnterCriticalSection(Crit_sec);
    try
        Result := Active_queries_list.Count;
    finally
        LeaveCriticalSection(Crit_sec);
    end;
end;

{ TNewQuery }

function TNewQuery.Cancel: Boolean;
begin
    Result := FALSE;
    {$IFDEF ODBC_DIRECT}
    if not CanCancel then Exit;
    inherited Cancel;
    Screen.Cursor := crDefault;
    Result := TRUE;
    {$ELSE}
    if not CanCancel then Exit;
    inherited Cancel;
    Screen.Cursor := crDefault;
    Result := TRUE;
    {$ENDIF}
    SetNoActive;
end;

constructor TNewQuery.Create(AOwner: TComponent
    {$IFNDEF ODBC_DIRECT}; AConn: TCreateParent = nil{$ENDIF});
begin
    {$IFDEF ODBC_DIRECT}
    inherited Create(AOwner);
    CanCancel := TRUE;
    {$ELSE}
    {$IFDEF ADO_DB}
    inherited Create(AOwner);
    if AConn = nil then
        AConn := DefaultConnection;
    if AConn <> nil then
        Connection := AConn;
    CanCancel := TRUE;
    CommandTimeout := 300;
    CacheSize := 2000;
    {$ELSE}
    inherited Create(AOwner);
    if AConn = nil then
        AConn := DefaultDB;
    if AConn <> nil then
        DatabaseName := AConn.DatabaseName
    else
        if DefaultDatabaseName <> '' then
            DatabaseName := DefaultDatabaseName;
    CanCancel := TRUE;
    {$ENDIF}
    {$ENDIF}
    FSaveLog := TRUE;
    if Active_queries_list = nil then
    begin
        Active_queries_list := TStringList.Create;
        InitializeCriticalSection(Crit_sec);
    end;
end;

function TNewQuery.Get_FieldNames(Idx: Integer): String;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited FieldNames[Idx];
    {$ELSE}
    Result := FieldDefList[Idx].Name;
    {$ENDIF}
end;

function TNewQuery.GetFieldType(Idx: Integer): TFieldType;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited FieldTypes[Idx];
    {$ELSE}
    Result := FieldDefList[Idx].DataType;
    {$ENDIF}
end;

destructor TNewQuery.Destroy;
begin
    TRY
        Close;
    EXCEPT on E: EOLEException do
        begin
            if E.ErrorCode <> -2146825267 then raise;
            {ShowMessage( '   TNewQuery, : ' +
                         E.ClassName + ' : ' + E.Message );}
            {raise;}
        end
    else raise;
    END;
    SetNoActive;
    inherited;
end;

procedure TNewQuery.DoAfterOpen;
begin
    Completed := TRUE;
    if ChangeSQLCursor and (Screen.Cursor = crSQLWait) then
        Screen.Cursor := crDefault;
    if ExecutingQuery = Self then
        ExecutingQuery := nil;
    inherited;
end;

procedure TNewQuery.DoBeforeOpen;
begin
    if ChangeSQLCursor then
        Screen.Cursor := crSQLWait;
    ExecutingQuery := Self;
    inherited;
    if not SaveLog then Exit;
    {$IFDEF ODBC_DIRECT}
    AddToTraceLog(Name + '.Open: '#13#10 + SQL.Text, nil);
    {$ELSE}
    {$IFDEF ADO_DB}
    AddToTraceLog(Name + '.Open: '#13#10 + SQL.Text, PSGetParams);
    {$ELSE}
    AddToTraceLog(Name + '.Open: '#13#10 + SQL.Text, Params);
    {$ENDIF}
    {$ENDIF}
    if not FIsActive then
    begin
        EnterCriticalSection(Crit_sec);
        try
            FIsActive := TRUE;
            Active_queries_list.AddObject(SQL.Text, Self);
        finally
            LeaveCriticalSection(Crit_sec);
        end;
    end;
end;

function IsConnectionFailedError(const s: String): Boolean;
begin
    Result := Copy(s, 1, 6) = '08S01 ';
end;

procedure TNewQuery.ExecSQL;
var WasExecutingQuery: TNewQuery;
var TryCount: Integer;
    TryAgain: Boolean;
begin
    WasExecutingQuery := ExecutingQuery;
    ExecutingQuery := Self;
    TRY
        if SaveLog then
        begin
            {$IFDEF ODBC_DIRECT}
            AddToTraceLog(Name + '.ExecSQL: '#13#10 + SQL.Text, nil);
            {$ELSE}
            {$IFDEF ADO_DB}
            AddToTraceLog(Name + '.ExecSQL: '#13#10 + SQL.Text, PSGetParams);
            {$ELSE}
            AddToTraceLog(Name + '.ExecSQL: '#13#10 + SQL.Text, Params);
            {$ENDIF}
            {$ENDIF}
        end;
        if not FIsActive then
        begin
            EnterCriticalSection(Crit_sec);
            try
                FIsActive := true;
                Active_queries_list.AddObject(SQL.Text, Self);
            finally
                LeaveCriticalSection(Crit_sec);
            end;
        end;
        {ExecuteOptions := [ eoAsyncExecute ];
        Completed := FALSE;
        OnFetchComplete := FetchComplete;}
        TryCount := 0;
        TryAgain := FALSE;
        if ChangeSQLCursor then
            Screen.Cursor := crSQLWait;
        while TRUE do
        begin
            TRY
                inherited ExecSQL;
            EXCEPT on E: Exception do
                begin
                    if IsConnectionFailedError(E.Message) then
                    begin
                        inc(TryCount);
                        if TryCount < 3 then
                            if Assigned(OnNeedReconnect) then
                                if OnNeedReconnect(Self) then
                                    TryAgain := True;
                        if not TryAgain then
                            if Query_raise_errors then
                                raise;
                    end else
                        if Query_raise_errors then
                            raise;
                end;
            END;
            if not TryAgain then break;
        end;
        {while not Completed do
          Application.ProcessMessages;}
    FINALLY
        ExecutingQuery := WasExecutingQuery;
        if ChangeSQLCursor and (Screen.Cursor = crSQLWait) then
            Screen.Cursor := crDefault;
    END;
end;

function TNewQuery.GetBField(const Name: String): TStream;
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery     ');
    {$ELSE}
    Result := TBlobStream.Create(FieldByName(Name) as TBlobField, bmRead);
    {$ENDIF}
end;

{$IFNDEF BDE_DB}

function TNewQuery.GetBFieldK(var K: Integer; const Name: String): TStream;
begin
    {$IFDEF ODBC_DIRECT}
    //Result := nil;
    if K < 0 then
    begin
        K := fColumns.IndexOf(Name);
        if K < 0 then
            raise Exception.Create('Field ' + Name + ' could not be found');
    end;
    Result := BFieldN[K];
    {$ELSE}Result := nil;
    {$ENDIF}
end;
{$ENDIF}

function TNewQuery.GetBFieldN(Idx: Integer): TStream;
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery     ');
    {$ELSE}
    Result := TBlobStream.Create(Fields[Idx] as TBlobField, bmRead);
    {$ENDIF}
end;

function TNewQuery.Get_DField(const Name: String): TDateTime;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited DField[Name];
    {$ELSE}
    Result := FieldByName(Name).AsDateTime;
    {$ENDIF}
end;

{$IFNDEF BDE_DB}

function TNewQuery.Get_DFieldK(var K: Integer; const Name: String): TDateTime;
begin
    {$IFDEF ODBC_DIRECT}
    //Result := 0;
    if K < 0 then
    begin
        K := fColumns.IndexOf(Name);
        if K < 0 then
            raise Exception.Create('Field ' + Name + ' could not be found');
    end;
    Result := DFieldN[K];
    {$ELSE}Result := 0;
    {$ENDIF}
end;
{$ENDIF}

function TNewQuery.GetDFieldN(Idx: Integer): TDateTime;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited DFieldN[Idx];
    {$ELSE}
    Result := Fields[Idx].AsDateTime;
    {$ENDIF}
end;

function TNewQuery.GetDParam(const Name: String): TDateTime;
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ');
    {$ELSE}
    {$IFDEF ADO_DB}
    Result := Parameters.ParamValues[Name].AsDateTime;
    {$ELSE}
    Result := ParamByName(Name).AsDateTime;
    {$ENDIF}
    {$ENDIF}
end;

function TNewQuery.Get_FField(const Name: String): Double;
begin
    TRY
        {$IFDEF ODBC_DIRECT}
        Result := inherited FField[Name];
        {$ELSE}

        {  TFieldType = (ftUnknown, ftString, ftSmallint, ftInteger, ftWord,
        ftBoolean, ftFloat, ftCurrency, ftBCD, ftDate, ftTime, ftDateTime,
        ftBytes, ftVarBytes, ftAutoInc, ftBlob, ftMemo, ftGraphic, ftFmtMemo,
        ftParadoxOle, ftDBaseOle, ftTypedBinary, ftCursor, ftFixedChar, ftWideString,
        ftLargeint, ftADT, ftArray, ftReference, ftDataSet, ftOraBlob, ftOraClob,
        ftVariant, ftInterface, ftIDispatch, ftGuid);
    }

        if FieldByName(Name).AsString <> '' then
            if FieldByName(Name).DataType in [ftFloat, ftCurrency, ftBCD,
                ftSmallint, ftInteger, ftDate, ftTime, ftDateTime, ftAutoInc, ftLargeint] then
                Result := FieldByName(Name).AsFloat
            else
                Result := StrToFloat(FieldByName(Name).AsString)
        else
            Result := 0;
        {$ENDIF}
    EXCEPT
        {$IFDEF ODBC_DIRECT}
        raise;
        {$ELSE}
        Result := FieldByName(Name).AsVariant;
        {$ENDIF}
    END;
end;

{$IFNDEF BDE_DB}

function TNewQuery.Get_FFieldK(var K: Integer; const Name: String): Double;
begin
    {$IFDEF ODBC_DIRECT}
    if K < 0 then
    begin
        K := fColumns.IndexOf(Name);
        if K < 0 then
            raise Exception.Create('Field ' + Name + ' could not be found');
    end;
    Result := FFieldN[K];
    {$ELSE}Result := 0;
    {$ENDIF}
end;
{$ENDIF}

function TNewQuery.Get_FFieldN(Idx: Integer): Double;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited FFieldN[Idx];
    {$ELSE}
    Result := Fields[Idx].AsFloat;
    {$ENDIF}
end;

function TNewQuery.GetFParam(const Name: String): Double;
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ');
    {$ELSE}
    Result := ParamByName(Name).AsFloat;
    {$ENDIF}
end;

function TNewQuery.GetIField(const Name: String): Integer;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited IField[Name];
    {$ELSE}
    Result := FieldByName(Name).AsInteger;
    {$ENDIF}
end;

function TNewQuery.GetBoolField(const Name: String): Boolean;
begin
    {$IFDEF ODBC_DIRECT}
    Result := FALSE; // inherited BoolField[ Name ];
    {$ELSE}
    Result := FieldByName(Name).AsBoolean;
    {$ENDIF}
end;

{$IFNDEF BDE_DB}

function TNewQuery.GetIFieldK(var K: Integer; const Name: String): Integer;
begin
    {$IFDEF ODBC_DIRECT}
    if K < 0 then
    begin
        K := fColumns.IndexOf(Name);
        if K < 0 then
            raise Exception.Create('Field ' + Name + ' could not be found');
    end;
    Result := IFieldN[K];
    {$ELSE}Result := -1;
    {$ENDIF}
end;
{$ENDIF BDE_DB}

function TNewQuery.GetIFieldN(Idx: Integer): Integer;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited IFieldN[Idx];
    {$ELSE}
    Result := Fields[Idx].AsInteger;
    {$ENDIF}
end;

function TNewQuery.GetBoolFieldN(Idx: Integer): Boolean;
begin
    {$IFDEF ODBC_DIRECT}
    Result := FALSE; //inherited BoolFieldN[ Idx ];
    {$ELSE}
    Result := Fields[Idx].AsBoolean;
    {$ENDIF}
end;

function TNewQuery.GetIParam(const Name: String): Integer;
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ');
    {$ELSE}
    {$IFDEF ADO_DB}
    Result := Parameters.ParamByName(Name).Value;
    {$ELSE}
    Result := ParamByName(Name).AsInteger;
    {$ENDIF}
    {$ENDIF}
end;

function TNewQuery.GetNullField(const Name: String): Boolean;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited NullField[Name];
    {$ELSE}
    Result := FieldByName(Name).IsNull;
    {$ENDIF}
end;

{$IFNDEF BDE_DB}

function TNewQuery.GetNullFieldK(var K: Integer; const Name: String): Boolean;
begin
    {$IFDEF ODBC_DIRECT}
    if K < 0 then
    begin
        K := fColumns.IndexOf(Name);
        if K < 0 then
            raise Exception.Create('Field ' + Name + ' could not be found');
    end;
    Result := NullFieldN[K];
    {$ELSE}Result := FALSE;
    {$ENDIF}
end;
{$ENDIF}

function TNewQuery.GetNullFieldN(Idx: Integer): Boolean;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited NullFieldN[Idx];
    {$ELSE}
    Result := Fields[Idx].IsNull;
    {$ENDIF}
end;

function TNewQuery.GetSField(const Name: String): String;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited SField[Name];
    {$ELSE}
    Result := FieldByName(Name).AsString;
    {$ENDIF}
end;

{$IFNDEF BDE_DB}

function TNewQuery.GetSFieldK(var K: Integer; const Name: String): String;
begin
    {$IFDEF ODBC_DIRECT}
    Result := '';
    if K < 0 then
    begin
        K := fColumns.IndexOf(Name);
        if K < 0 then
            raise Exception.Create('Field ' + Name + ' could not be found');
    end;
    Result := SFieldN[K];
    {$ENDIF}
end;
{$ENDIF}

function TNewQuery.GetSFieldN(Idx: Integer): String;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited SFieldN[Idx];
    {$ELSE}
    Result := Fields[Idx].AsString;
    {$ENDIF}
end;

function TNewQuery.GetSParam(const Name: String): String;
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ');
    {$ELSE}
    Result := ParamByName(Name).AsString;
    {$ENDIF}
end;

function TNewQuery.GetVParam(const Name: String): Variant;
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ');
    {$ELSE}
    {$IFDEF BDE_DB}
    raise Exception.Create(' BDE TNewQuery   ');
    {$ELSE}
    Result := ParamByName(Name).AsVariant;
    {$ENDIF}
    {$ENDIF}
end;

procedure TNewQuery.NullParam(const Name: String; FieldType: TFieldType);
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ');
    {$ELSE}
    {$IFDEF ADO_DB}
    with Parameters.FindParam(Name) do
    begin
        Value := Unassigned;
        DataType := FieldType;
    end;
    {$ELSE}
    TRY
        ParamByName(Name).Clear;
        if FieldType <> ftUnknown then
            ParamByName(Name).DataType := FieldType;
    EXCEPT
    END;
    {$ENDIF}
    {$ENDIF}
end;

procedure TNewQuery.Open;
var TryCount: Integer;
    TryAgain: Boolean;
begin
    TRY
        {$IFDEF ADO_DB}
        CacheSize := 1000;
        //<>//
        {$ENDIF}
        //ExecuteOptions := [ eoAsyncExecute, eoAsyncFetch ];
        Completed := FALSE;
        //OnFetchComplete := FetchComplete;
        {$IFDEF ODBC_DIRECT}
        DoBeforeOpen;
        {$ELSE}
        AfterOpen := EventAfterOpen;
        {$ENDIF}
        TryAgain := FALSE;
        TryCount := 0;
        while TRUE do
        begin
            TRY
                inherited;
            EXCEPT on E: Exception do
                begin
                    if IsConnectionFailedError(E.Message) then
                    begin
                        inc(TryCount);
                        if TryCount < 3 then
                            if Assigned(OnNeedReconnect) then
                                if OnNeedReconnect(Self) then
                                    TryAgain := True;
                        if not TryAgain then
                            raise;
                    end
                    else raise;
                end;
            END;
            if not TryAgain then break;
        end;
        //while not Completed do
        //  Application.ProcessMessages;
        {$IFDEF ODBC_DIRECT}
        DoAfterOpen;
        {$ENDIF}
    EXCEPT
        SetNoActive;
        if ChangeSQLCursor then
            Screen.Cursor := crDefault;
        raise;
    END;
end;

{$IFDEF ADO_DB}

function TNewQuery.ParamByName(const Name: String): Variant;
begin
    Result := Parameters.ParamValues[Name];
end;
{$ENDIF}

procedure TNewQuery.SetBParam(const Name: String; const Value: String);
{$IFNDEF ODBC_DIRECT}
{$ELSE}
var N: Integer;
    {$ENDIF}
begin
    {$IFDEF ODBC_DIRECT}
    N := StrToInt(Name);
    if N = 1 then
        Prepare;
    inherited BParam[N] := Value;
    {$ELSE}
    {$IFDEF ADO_DB}
    ParamByName(Name).FieldType := ftBlob;
    {$ENDIF}
    ParamByName(Name).AsBlob := Value;
    {$ENDIF}
end;

procedure TNewQuery.SetDParam(const Name: String; const Value: TDateTime);
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ')
        {$ELSE}
    {$IFDEF ADO_DB}
    Parameters.ParamByName(Name).DataType := ftDateTime;
    Parameters.ParamByName(Name).Value := Value;
    {$ELSE}
    ParamByName(Name).AsDateTime := Value;
    {$ENDIF}
    {$ENDIF}
end;

procedure TNewQuery.SetFParam(const Name: String; const Value: Double);
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ')
        {$ELSE}
    {$IFDEF ADO_DB}
    Parameters.ParamByName(Name).DataType := ftFloat;
    Parameters.ParamByName(Name).Value := Value;
    {$ELSE}
    ParamByName(Name).AsFloat := Value;
    {$ENDIF}
    {$ENDIF}
end;

procedure TNewQuery.SetIParam(const Name: String; const Value: Integer);
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ')
        {$ELSE}
    {$IFDEF ADO_DB}
    Parameters.ParamByName(Name).DataType := ftInteger;
    Parameters.ParamByName(Name).Value := Value;
    {$ELSE}
    ParamByName(Name).AsInteger := Value;
    {$ENDIF}
    {$ENDIF}
end;

procedure TNewQuery.SetSParam(const Name, Value: String);
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ')
        {$ELSE}
    {$IFDEF ADO_DB}
    Parameters.ParamByName(Name).DataType := ftString;
    Parameters.ParamByName(Name).Value := Value;
    {$ELSE}
    ParamByName(Name).AsString := Value;
    {$ENDIF}
    {$ENDIF}
end;

procedure TNewQuery.SetVParam(const Name: String; const Value: Variant);
begin
    {$IFDEF ODBC_DIRECT}
    raise Exception.Create('TODBCQuery   ');
    {$ELSE}
    {$IFDEF ADO_DB}
    Parameters.ParamByName(Name).DataType := ftString;
    Parameters.ParamByName(Name).Value := Value;
    {$ELSE}
    {$IFDEF BDE_DB}
    raise Exception.Create(' BDE TNewQuery    VARIANT');
    {$ELSE}
    ParamByName(Name).AsVariant := Value;
    {$ENDIF}
    {$ENDIF}
    {$ENDIF}
end;

procedure TNewQuery.Close;
begin
    {$IFDEF ADO_DB}
    if RecordSet <> nil then
        RecordSet.Close;
    {$ENDIF ADO_DB}
    inherited Close;
    SetNoActive;
end;

procedure TNewQuery.EventAfterOpen(DataSet: TDataSet);
begin
    Completed := TRUE;
end;

function TNewQuery.GetText: String;
begin
    Result := SQL.Text;
end;

procedure TNewQuery.SetText(const Value: String);
var s: String;
    i: Integer;
begin
    s := Value;
    for i := 1 to Length(s) do
        if s[i] = '!' then
            s[i] := #13;
    SQL.Text := s;
end;

function TNewQuery.FindField(const S: String): Integer;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited FindFieldIndex(S);
    {$ELSE}
    Result := -1;
    {$ENDIF}
end;

procedure TNewQuery.SetNoActive;
var i: Integer;
begin
    if not FIsActive then Exit;
    EnterCriticalSection(Crit_sec);
    try
        FIsActive := FALSE;
        for i := 0 to Active_queries_list.Count - 1 do
        begin
            if Active_queries_list.Objects[i] = Self then
            begin
                Active_queries_list.Delete(i);
                break;
            end;
        end;
    finally
        LeaveCriticalSection(Crit_sec);
    end;
end;

procedure TNewQuery.SetChangeSQLCursor(const Value: Boolean);
begin
    FChangeSQLCursor := Value;
end;

function TNewQuery.GetSQLErrors: Boolean;
begin
    {$IFDEF ODBC_DIRECT}
    Result := inherited SQLErrors;
    {$ELSE}
    Result := TRUE;
    {$ENDIF}
end;

procedure TNewQuery.SetSQLErrors(const Value: Boolean);
begin
    {$IFDEF ODBC_DIRECT}
    inherited SQLErrors := Value;
    {$ENDIF}
end;

initialization

finalization
    if Active_queries_list <> nil then
    begin
        DeleteCriticalSection(Crit_sec);
        FreeAndNil(Active_queries_list);
    end;

end.
