unit BringFront_Reg;

interface

{$I KOLDEF.inc}

uses
  SysUtils, Classes, Controls, Dialogs, Forms,
     {$IFDEF _D6orHigher}                       //
     DesignIntf, DesignEditors, DesignConst,    //
     Variants                                   //
     {$ELSE}                                    //
     DsgnIntf                                   //
     {$ENDIF};

type
  TBringFrontAction = class( TComponentEditor )
  private
  protected
    function LinkedComponentName: String;
  public
    procedure Edit; override;
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure Register;

implementation

uses BringFront;

procedure Register;
begin
  RegisterComponents('Kladov', [TBringFront]);
  RegisterComponentEditor( TBringFront, TBringFrontAction );
end;

{ TBringFrontAction }

procedure TBringFrontAction.Edit;
begin
  inherited;
  if Component = nil then Exit;
  if not(Component is TBringFront) then Exit;
  (Component as TBringFront).DoBringFront;
end;

procedure TBringFrontAction.ExecuteVerb(Index: Integer);
begin
  inherited;
  case Index of
  0: if Component <> nil then
     if Component is TBringFront then
     TRY
       (Component as TBringFront).DoBringFront;
     EXCEPT on E: Exception do
             ShowMessage(
             {$IFDEF RUSSIAN_LANGUAGE} '   TBringFront: '
             {$ELSE}                   'Exception in TBringFront component: '
             {$ENDIF} + E.Message);
     END;
  end;
end;

function TBringFrontAction.GetVerb(Index: Integer): string;
var s: String;
begin
  Result := '';
  s := LinkedComponentName;
  case Index of
  0: if  s <> '' then
         Result := {$IFDEF RUSSIAN_LANGUAGE} '   : '
                   {$ELSE}                   'Bring to Front: '
                   {$ENDIF} + s
     else
         Result := {$IFDEF RUSSIAN_LANGUAGE} '  '
                   {$ELSE} 'There is no linked component'
                   {$ENDIF};
  end;
end;

function TBringFrontAction.GetVerbCount: Integer;
begin
    Result := 1;
end;

function TBringFrontAction.LinkedComponentName: String;
begin
    if  (Component <> nil) and (Component is TBringFront) then
        Result := (Component as TBringFront).LinkedPanelName
    else
        Result := '';
end;



end.
