unit ImgShow;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, ExtCtrls, Graphics;

type
  TImgShow = class(TCustomPanel)
  private
    FImage_Idx: Integer;
    FImageList: TImageList;
    FPrintViaBitmap: Boolean;
    procedure SetImage_Idx(const Value: Integer);
    procedure SetImageList(const Value: TImageList);
    procedure SetPrintViaBitmap(const Value: Boolean);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure Paint; override;
  published
    { Published declarations }
    property PrintViaBitmap: Boolean read FPrintViaBitmap write SetPrintViaBitmap;
    constructor Create( AOwner: TComponent ); override;
    property ImageList: TImageList read FImageList write SetImageList;
    property Image_Idx: Integer read FImage_Idx write SetImage_Idx;
  end;

procedure Register;

implementation

{$R *.dcr}

procedure Register;
begin
  RegisterComponents('Kladov', [TImgShow]);
end;

{ TImgShow }

procedure TImgShow.Paint;
var B: TBitmap;
begin
  inherited;
  if  PrintViaBitmap then
  begin
      if  ImageList <> nil then
      begin
          B := TBitmap.Create;
          TRY
              B.Width := Width;
              B.Height := Height;
              B.Canvas.Brush.Color := clWhite;
              B.Canvas.FillRect( Rect( 0, 0, B.Width, B.Height ) );
              ImageList.Draw( B.Canvas, 0, 0, Image_Idx );
              Canvas.CopyRect( Rect( 0, 0, B.Width, B.Height ),
                               B.Canvas,
                               Rect( 0, 0, B.Width, B.Height ) );
          FINALLY
              B.Free;
          END;
      end;
  end else
  begin
      if  ImageList <> nil then
          ImageList.Draw( Canvas, 0, 0, Image_Idx );
  end;
  if  csDesigning in ComponentState then
  begin
      Canvas.Brush.Color := clBlue;
      Canvas.FrameRect( ClientRect );
  end;
end;

procedure TImgShow.SetImage_Idx(const Value: Integer);
begin
  FImage_Idx := Value;
  Invalidate;
end;

procedure TImgShow.SetImageList(const Value: TImageList);
begin
  FImageList := Value;
  if Value <> nil then
  begin
    Width := Value.Width;
    Height := Value.Height;
  end;
  Invalidate;
end;

constructor TImgShow.Create(AOwner: TComponent);
begin
  inherited;
  Color := clWhite;
  BevelOuter := bvNone;
  BevelInner := bvNone;
  PrintViaBitmap := TRUE;
end;

procedure TImgShow.SetPrintViaBitmap(const Value: Boolean);
begin
  FPrintViaBitmap := Value;
end;

end.
