//**  ,     VCL Delphi.
//**  Vladimir Kladov, 2000-2010
//**
//**      .
//**     /     
//**  2          
//**   GNU,  Free Software Foundation.
//**
//**       ,    
//** ,       ,   
//**         
//**   .      
//**     GNU.
//**
//**          
//**   GNU.     ,     Free
//** Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//** MA 02111-1307, USA.
//******************************************************************************

unit NormalRange;

interface

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, Buttons, Knopka;

type
    TfmNormalRange = class(TForm)
        Label1: TLabel;
        Label2: TLabel;
        Label3: TLabel;
        Edit1: TEdit;
        Edit2: TEdit;
        Edit3: TEdit;
        Button2: TKnopka;
        Bck1: TKnopka;
        Fwd1: TKnopka;
        Bck2: TKnopka;
        Fwd2: TKnopka;
        Bck3: TKnopka;
        Fwd3: TKnopka;
        Button1: TKnopka;
        procedure Edit1KeyPress(Sender: TObject; var Key: Char);
        procedure Edit1Change(Sender: TObject);
        procedure FormShow(Sender: TObject);
        procedure Edit3Change(Sender: TObject);
        procedure Bck1Click(Sender: TObject);
        procedure Fwd1Click(Sender: TObject);
    private
        { Private declarations }
    public
        { Public declarations }
        TotalPages: Integer;
        procedure Enable;
    end;

var
    fmNormalRange: TfmNormalRange;

implementation

{$R *.DFM}

procedure TfmNormalRange.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
    CASE Key OF
        '0'..'9', #8: ;
    else begin
            MessageBeep(DWORD(-1));
            Key := #0;
        end;
    END;
end;

procedure TfmNormalRange.Edit1Change(Sender: TObject);
var n1, n2: Integer;
begin
    Enable;
    TRY
        n1 := StrToInt(Edit1.Text);
        n2 := StrToInt(Edit2.Text);
        if (n1 < 1) or (n2 < 1) then Exit;
        if Sender = Edit1 then
        begin
            if n2 < n1 then
                Edit2.Text := IntToStr(n1);
        end
        else
        begin
            if n1 > n2 then
                Edit1.Text := IntToStr(n2);
        end;
        Edit3.Text := IntToStr(StrToInt(Edit2.Text) - StrToInt(Edit1.Text) + 1);
    EXCEPT
    END;
end;

procedure TfmNormalRange.FormShow(Sender: TObject);
begin
    Enable;
end;

procedure TfmNormalRange.Enable;
var From, _To_: Integer;
begin
    TRY
        From := StrToInt(Edit1.Text);
        _To_ := StrToInt(Edit2.Text);
        Button1.Enabled := (From > 0) and (From <= TotalPages) and
            (_To_ >= From) and (_To_ <= TotalPages);
        Bck1.Enabled := From > 1;
        Fwd1.Enabled := From < TotalPages;
        Bck2.Enabled := _To_ > From;
        Fwd2.Enabled := _To_ < TotalPages;
    EXCEPT
        Button1.Enabled := FALSE;
    END;
end;

procedure TfmNormalRange.Edit3Change(Sender: TObject);
var ok: Boolean;
begin
    TRY
        Edit2.Text := IntToStr(StrToInt(Edit1.Text) + StrToInt(Edit3.Text) - 1);
        ok := TRUE;
    EXCEPT
        ok := FALSE;
    END;
    if ok then
        Enable
    else Button1.Enabled := FALSE;
end;

procedure TfmNormalRange.Bck1Click(Sender: TObject);
var Edit: TEdit;
    n: Integer;
begin
    Edit := FindComponent('Edit' + IntToStr(TControl(Sender).Tag)) as TEdit;
    TRY
        n := StrToInt(Edit.Text);
    EXCEPT
        n := 0;
    END;
    if n > TotalPages then
        n := TotalPages + 1;
    if n > 0 then
        Edit.Text := IntToStr(n - 1);
    Enable;
end;

procedure TfmNormalRange.Fwd1Click(Sender: TObject);
var Edit: TEdit;
    n: Integer;
begin
    Edit := FindComponent('Edit' + IntToStr(TControl(Sender).Tag)) as TEdit;
    TRY
        n := StrToInt(Edit.Text);
    EXCEPT
        n := 0;
    END;
    if n < TotalPages then
        Edit.Text := IntToStr(n + 1);
    Enable;
end;

end.
