//**  ,     VCL Delphi.
//**  Vladimir Kladov, 2000-2010
//**
//**      .
//**     /     
//**  2          
//**   GNU,  Free Software Foundation.
//**
//**       ,    
//** ,       ,   
//**         
//**   .      
//**     GNU.
//**
//**          
//**   GNU.     ,     Free
//** Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//** MA 02111-1307, USA.
//******************************************************************************

unit RotBmp;

interface

uses Windows, Graphics;

procedure RotateBmpLeft( var Bmp: TBitmap );
procedure RotateBmpRight( var Bmp: TBitmap );

implementation

procedure _RotateBitmap2432bit( var DstBmp: TBitmap; SrcBmp: TBitmap );
var X, Y, Wwords, BytesPerDstLine, IncW: Integer;
    Src, Dst, Dst1: PDWord;
    Tmp: DWord;
begin

  DstBmp := TBitmap.Create;
  DstBmp.Width := SrcBmp.Height;
  DstBmp.Height := SrcBmp.Width;
  DstBmp.PixelFormat := SrcBmp.PixelFormat;

  // Calculate ones:
  IncW := 4;
  if DstBmp.PixelFormat = pf24bit then
  begin
     IncW := 3;
     Wwords := SrcBmp.Width;
     Dst := DstBmp.ScanLine[ 0 ];
     BytesPerDstLine := Integer( DstBmp.ScanLine[ 1 ]) - Integer( Dst );

     Inc( PByte(Dst), (DstBmp.Width - 1) * IncW );

     // Rotating bits:
     for Y := 0 to SrcBmp.Height - 1 do
     begin
       Src := SrcBmp.ScanLine[ Y ];
       Dst1 := Dst;
       for X := Wwords downto 1 do
       begin
         Tmp := Src^ and $FFFFFF;
         Inc( PByte(Src), IncW );
         Dst1^ := Tmp;
         Inc( PByte(Dst1), BytesPerDstLine );
       end;
       Dec( PByte(Dst), IncW );
     end;
  end else
  begin
     Wwords := SrcBmp.Width;
     Dst := DstBmp.ScanLine[ 0 ];
     BytesPerDstLine := Integer( DstBmp.ScanLine[ 1 ]) - Integer( Dst );

     Inc( PByte(Dst), (DstBmp.Width - 1) * IncW );

     // Rotating bits:
     for Y := 0 to SrcBmp.Height - 1 do
     begin
       Src := SrcBmp.ScanLine[ Y ];
       Dst1 := Dst;
       for X := Wwords downto 1 do
       begin
         Tmp := Src^; // and $FFFFFF;
         inc( Src); //Inc( PByte(Src), IncW );
         Dst1^ := Tmp;
         Inc( PByte(Dst1), BytesPerDstLine );
         //inc( Dst );
       end;
       Dec( PByte(Dst), IncW );
     end;
  end;

end;

procedure _RotateBitmap2432bitLeft( var DstBmp: TBitmap; SrcBmp: TBitmap );
var X, Y, Wwords, BytesPerDstLine, IncW: Integer;
    Src, Dst, Dst1: PDWord;
    Tmp: DWord;
begin

  DstBmp := TBitmap.Create;
  DstBmp.Width := SrcBmp.Height;
  DstBmp.Height := SrcBmp.Width;
  DstBmp.PixelFormat := SrcBmp.PixelFormat;

  // Calculate ones:
  IncW := 4;
  if DstBmp.PixelFormat = pf24bit then
  begin
     IncW := 3;
     Wwords := SrcBmp.Width;
     Dst := DstBmp.ScanLine[ DstBmp.Height-1 ];
     BytesPerDstLine := Integer( DstBmp.ScanLine[ 1 ]) - Integer( DstBmp.ScanLine[ 0 ] );

     //Inc( PByte(Dst), (DstBmp.Width - 1) * IncW );

     // Rotating bits:
     for Y := 0 to SrcBmp.Height - 1 do
     begin
       Src := SrcBmp.ScanLine[ Y ];
       Dst1 := Dst;
       for X := Wwords downto 1 do
       begin
         Tmp := Src^ and $FFFFFF;
         Inc( PByte(Src), IncW );
         Dst1^ := Tmp;
         Dec( PByte(Dst1), BytesPerDstLine );
       end;
       Inc( PByte(Dst), IncW );
     end;
  end else
  begin
     Wwords := SrcBmp.Width;
     Dst := DstBmp.ScanLine[ DstBmp.Height-1 ];
     BytesPerDstLine := Integer( DstBmp.ScanLine[ 1 ]) - Integer( DstBmp.ScanLine[ 0 ] );

     //Inc( PByte(Dst), (DstBmp.Width - 1) * IncW );

     // Rotating bits:
     for Y := 0 to SrcBmp.Height - 1 do
     begin
       Src := SrcBmp.ScanLine[ Y ];
       Dst1 := Dst;
       for X := Wwords downto 1 do
       begin
         Tmp := Src^; // and $FFFFFF;
         inc( Src); //Inc( PByte(Src), IncW );
         Dst1^ := Tmp;
         Dec( PByte(Dst1), BytesPerDstLine );
         //inc( Dst );
       end;
       Inc( PByte(Dst), IncW );
     end;
  end;

end;

procedure RotateBmpLeft( var Bmp: TBitmap );
var OldBmp: TBitmap;
begin
  {RotateBmpRight( Bmp );
  RotateBmpRight( Bmp );
  RotateBmpRight( Bmp );}
  OldBmp := Bmp;
  _RotateBitmap2432bitLeft( Bmp, OldBmp );
  OldBmp.Free;
end;

procedure RotateBmpRight( var Bmp: TBitmap );
var OldBmp: TBitmap;
begin
  OldBmp := Bmp;
  _RotateBitmap2432bit( Bmp, OldBmp );
  OldBmp.Free;
end;

end.









