//**  ,     VCL Delphi.
//**  Vladimir Kladov, 2000-2010
//**
//**      .
//**     /     
//**  2          
//**   GNU,  Free Software Foundation.
//**
//**       ,    
//** ,       ,   
//**         
//**   .      
//**     GNU.
//**
//**          
//**   GNU.     ,     Free
//** Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//** MA 02111-1307, USA.
//******************************************************************************

unit StackUnit;

{$I VCL_VERSIONS.INC}
{$IFDEF _D6orHigher}
        {$WARN SYMBOL_PLATFORM OFF}
{$ENDIF}

interface

//{$DEFINE REMOVE_ENTRY_CALLS} // ,      entry(...

uses Windows, SysUtils, classes, Forms;

procedure enter( FunctionName: PChar );

type
    TFunctionEntry = record
        fun_name: PChar;
        stackVal: DWORD;
    end;

var FunStack: array[ 0..1, 0..100000 ] of TFunctionEntry;
    CurFunStack: array[0..1] of Integer;
    ThreadStackRanges: array[ 0..1, 0..1 ] of DWORD;

//        ,    
// ,    .  uses    
//  StackUnits,      .
procedure ModifySources_AddingEnterCall( const directory: String );

//     -     ,
//     
procedure DefineThreadStack( idx: Integer );

implementation //    !
               //     
               //   entry( )     
               // 

var Added: Integer;
    Remove: Integer;

  procedure
  enter( FunctionName: PChar );
  var sV: DWORD;
      i: Integer;
  begin
    asm
        mov [sV], ESP
    end;
    if  (sV >= ThreadStackRanges[0, 0]) and (sV <= ThreadStackRanges[0, 1]) then
        i := 0
    else
    if  (sV >= ThreadStackRanges[1, 0]) and (sV <= ThreadStackRanges[1, 1]) then
        i := 1
    else
        Exit;
    while CurFunStack[i] > 0 do
    begin
        if  FunStack[ i, CurFunStack[i] ].stackVal > sV then break;
        dec( CurFunStack[i] );
    end;
    FunStack[ i, CurFunStack[i] ].fun_name := FunctionName;
    FunStack[ i, CurFunStack[i] ].stackVal := sV;
    inc( CurFunStack[i] );
  end;

  procedure
  DefineThreadStack( idx: Integer );
  var sV: DWORD;
  begin
      asm
          mov [sV], ESP
      end;
      ThreadStackRanges[idx, 0] := sV - 1000000;
      ThreadStackRanges[idx, 1] := sV + 1000;
  end;


procedure ModifyUnit( const FilePath: String );
var SL: TStringList;
    i, j, n_spaces, n_changes: Integer;
    s, fun_name, unit_name, search_begin: String;
    implementation_found: Boolean;
begin
    unit_name := ExtractFileName( FilePath );
    delete( unit_name, Length( unit_name ) - 3, 4 );
    SL := TStringList.Create;
    n_changes := 0;
    implementation_found := FALSE;
    TRY
        SL.LoadFromFile( FilePath );
        for i := 0 to SL.Count-1 do
        begin
            s := LowerCase( Trim(SL[i]) );
            if  not implementation_found then
            begin
                if  s <> 'implementation' then continue;
                implementation_found := TRUE;
            end;
            if  (Copy( s, 1, 8 ) = 'function') or
                (Copy( s, 1, 9 ) = 'procedure') then
            begin
                s := SL[i];
                n_spaces := 0;
                for j := 1 to Length( s ) do
                    if  s[j] = ' ' then inc( n_spaces )
                    else break;
                Delete( s, 1, n_spaces );
                for j := 1 to Length( s ) do
                    if  s[j] <= ' ' then
                    begin
                        Delete( s, 1, j );
                        break;
                    end;
                fun_name := '';
                for j := 1 to Length( s )+1 do
                    if  (j > Length(s))
                    or  (s[j] in [ '(', ';', ':' ]) then
                    begin
                        fun_name := Copy( s, 1, j-1 );
                        break;
                    end;
                if  fun_name <> '' then
                begin
                    search_begin := '';
                    for j := 1 to n_spaces do
                        search_begin := search_begin + ' ';
                    search_begin := search_begin + 'begin';
                    for j := i+1 to SL.Count-1 do
                    begin
                        s := SL[j];
                        if  Copy( s, 1, Length(search_begin) ) = search_begin then
                        begin
                            //   begin
                            Delete( s, 1, Length( search_begin ) );
                            s := Trim( s );
                            if  s <> '' then
                            begin
                                if  (Added = 0) and (Remove = 0) then
                                begin
                                    //  ,  ,    enter,
                                    //           
                                    //  (  ),   ,  
                                    //  "",     , 
                                    //    .
                                    {$IFDEF REMOVE_ENTRY_CALLS}
                                    if  Application.MessageBox( '   enter?',
                                        'StackUnit', MB_YESNO ) = ID_YES then
                                        Remove := 1
                                    else
                                        Remove := -1;
                                    {$ENDIF}
                                end;
                                if  Remove > 0 then
                                begin
                                    if  copy( s, 1, 6 ) = 'enter(' then
                                    begin
                                        SL[j] := search_begin;
                                        inc( n_changes );
                                    end;
                                end;
                                break;
                            end
                            else
                            if  Remove <= 0 then
                            begin
                                s := search_begin + ' enter(''' + unit_name + ':' +
                                     fun_name + ''');';
                                SL[j] := s;
                                inc( n_changes );
                                inc( Added );
                                Remove := -1;
                                break;
                            end;
                        end;
                    end;
                end;
            end;
        end;
        if  n_changes > 0 then
            SL.SaveToFile( FilePath );
    FINALLY
        SL.Free;
    END;
end;

procedure ModifySources_AddingEnterCall( const directory: String );
var Find: TSearchRec;
    s: String;
begin
    s := directory;
    if  s[Length(s)] <> '\' then s := s + '\';
    s := s + '*.pas';
    if FindFirst( s, faArchive, Find ) = 0 then
    begin
        TRY
            REPEAT
                s := directory;
                if  s[Length(s)] <> '\' then s := s + '\';
                s := s + Find.Name;
                ModifyUnit( s );
            UNTIL FindNext( Find ) <> 0;
        FINALLY
            FindClose( Find );
        END;
    end
      else  FindClose( Find );
end;

initialization
    DefineThreadStack( 0 );

end.


