unit StackUnit;

interface

uses Windows, SysUtils, classes;

procedure enter( FunctionName: PChar );

type
    TFunctionEntry = record
        fun_name: PChar;
        stackVal: DWORD;
    end;

var FunStack: array[ 0..100000 ] of TFunctionEntry;
    CurFunStack: Integer;

procedure ModifySources_AddingEnterCall( const directory: String );

implementation

procedure enter( FunctionName: PChar );
var sV: DWORD;
begin
    asm
        mov [sV], ESP
    end;
    while CurFunStack > 0 do
    begin
        if  FunStack[ CurFunStack ].stackVal > sV then break;
        dec( CurFunStack );
    end;
    FunStack[ CurFunStack ].fun_name := FunctionName;
    FunStack[ CurFunStack ].stackVal := sV;
    inc( CurFunStack );
end;

procedure ModifyUnit( const FilePath: String );
var SL: TStringList;
    i, j, n_spaces, n_changes: Integer;
    s, fun_name, unit_name, search_begin: String;
begin
    unit_name := ExtractFileName( FilePath );
    SL := TStringList.Create;
    n_changes := 0;
    TRY
        SL.LoadFromFile( FilePath );
        for i := 0 to SL.Count-1 do
        begin
            s := LowerCase( Trim(SL[i]) );
            if  (Copy( s, 1, 8 ) = 'function') or
                (Copy( s, 1, 9 ) = 'procedure') then
            begin
                s := SL[i];
                n_spaces := 0;
                for j := 1 to Length( s ) do
                    if  s[j] = ' ' then inc( n_spaces )
                    else break;
                Delete( s, 1, n_spaces );
                for j := 1 to Length( s ) do
                    if  s[j] <= ' ' then
                    begin
                        Delete( s, 1, j );
                        break;
                    end;
                fun_name := '';
                for j := 1 to Length( s )+1 do
                    if  (j > Length(s))
                    or  (s[j] in [ '(', ';', ':' ]) then
                    begin
                        fun_name := Copy( s, 1, j-1 );
                        break;
                    end;
                if  fun_name <> '' then
                begin
                    search_begin := '';
                    for j := 1 to n_spaces do
                        search_begin := search_begin + ' ';
                    search_begin := search_begin + 'begin';
                    for j := i+1 to SL.Count-1 do
                    begin
                        s := SL[j];
                        if  Copy( s, 1, Length(search_begin) ) = search_begin then
                        begin
                            //   begin
                            Delete( s, 1, Length( search_begin ) );
                            s := Trim( s );
                            if  s <> '' then break
                            else
                            begin
                                s := search_begin + ' entry(''' + unit_name + ':' +
                                     fun_name + ''');';
                                SL[j] := s;
                                inc( n_changes );
                                break;
                            end;
                        end;
                    end;
                end;
            end;
        end;
        if  n_changes > 0 then
            SL.SaveToFile( FilePath );
    FINALLY
        SL.Free;
    END;
end;

procedure ModifySources_AddingEnterCall( const directory: String );
var Find: TSearchRec;
    s: String;
begin
    s := directory;
    if  s[Length(s)] <> '\' then s := s + '\';
    s := s + '*.pas';
    if FindFirst( s, faArchive, Find ) = 0 then
    begin
        TRY
            s := {directory;
            if  s[Length(s)] <> '\' then s := s + '\';
            s := s +} Find.Name;
            ModifyUnit( s );
        FINALLY
            FindClose( Find );
        END;
    end
      else  FindClose( Find );
end;

end.
