//**  ,     VCL Delphi.
//**  Vladimir Kladov, 2000-2010
//**
//**      .
//**     /     
//**  2          
//**   GNU,  Free Software Foundation.
//**
//**       ,    
//** ,       ,   
//**         
//**   .      
//**     GNU.
//**
//**          
//**   GNU.     ,     Free
//** Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//** MA 02111-1307, USA.
//******************************************************************************

unit StdImgSelectIcon;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Knopka, ComCtrls, UniPic, ImgList;

type
  TfmSelectIcon = class(TForm)
    Panel1: TPanel;
    ListIcons: TListView;
    bOK: TPnKnopka;
    PnKnopka2: TPnKnopka;
    ImageList1: TImageList;
    Panel2: TPanel;
    UniPic1: TUniPic;
    procedure FormCreate(Sender: TObject);
    procedure ListIconsSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListIconsDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Value: TStdImage;
  end;

var
  fmSelectIcon: TfmSelectIcon;

implementation

type
    TUniPic1 = class( TUniPic );

{$R *.DFM}

procedure TfmSelectIcon.FormCreate(Sender: TObject);
var IL: TImageList;
    II: Integer;
    IB: Boolean;
    p: TStdImage;
    B, B1: TBitmap;
    i: Integer;
    LI: TListItem;
begin
    UniPic1.StdImgSmall := TRUE;
    TRY
        for p := Low(p) to High(p) do
        begin
            UniPic1.StdImage := p;
            TUniPic1( UniPic1 ).PrepareStdImageList( IL, II, IB );
            B := TBitmap.Create;
            TRY
                B.Width := IL.Width;
                B.Height := IL.Height;
                B.PixelFormat := pf32bit;
                B.Canvas.Brush.Color := clWindow;
                B.Canvas.FillRect( Rect( 0, 0, B.Width, B.Height ) );
                IL.DrawingStyle := dsTransparent;
                IL.Draw( B.Canvas, 0, 0, II, TRUE );
                if  (B.Width <> 16) or (B.Height <> 16) or IB then
                begin
                    B1 := B;
                    B := TBitmap.Create;
                    TRY
                        B.Width := 16;
                        B.Height := 16;
                        B.PixelFormat := pf32bit;
                        SetStretchBltMode( B.Canvas.Handle, HALFTONE );
                        B1.TransparentColor := clBlack;
                        B.Canvas.StretchDraw( Rect( 0, 0, 16, 16 ), B1 );
                    FINALLY
                        B.Free;
                        B := B1;
                    END;
                end;
                i := ImageList1.Add( B, nil );
                LI := ListIcons.Items.Add;
                LI.ImageIndex := i;
                LI.Caption := StdImageNames[ p ];
            FINALLY
                B.Free;
            END;
        end;
    FINALLY
        UniPic1.StdImgSmall := FALSE;
    END;
end;

procedure TfmSelectIcon.ListIconsSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
    if  Item = nil then Exit;
    Value := TStdImage( Item.Index );
    UniPic1.StdImage := Value;
end;

procedure TfmSelectIcon.ListIconsDblClick(Sender: TObject);
begin
    if  ListIcons.Selected <> nil then
        bOK.Click;
end;

end.
