//**  ,     VCL Delphi.
//**  Vladimir Kladov, 2000-2010
//**
//**      .
//**     /     
//**  2          
//**   GNU,  Free Software Foundation.
//**
//**       ,    
//** ,       ,   
//**         
//**   .      
//**     GNU.
//**
//**          
//**   GNU.     ,     Free
//** Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//** MA 02111-1307, USA.
//******************************************************************************

{************************************************}
{                                                }
{     TUniEdit  TUniSource     }
{   " "                     }
{   Copyright (c) 2000-2003 by Vladimir Kladov   }
{                                                }
{           21.08.2003         }
{                                                }
{************************************************}
{           04.08.2003         }
{        OnDropDown, OnCloseUp - }
{     Kind=ekCombo.           }
{************************************************}
{           13.08.2003         }
{        TUniSource     }
{   TUniEdit  TFastListView.                    }
{************************************************}
{           14.08.2003         }
{        ekEditPeriod,      }
{   KindPeriod.                                  }
{************************************************}
{           15.08.2003         }
{            TUniEdit     }
{ (Kind=ekEditPeriod)           }
{ 0..50, 100..899 (2000..2050,2100..2899)     }
{ 51..99, 900..999 (1951..1999, 1900..1999)      }
{************************************************}
{           15.08.2003         }
{        TUniEdit.QueryUpdate,      }
{   TUniEdit.QueryInsert (  }
{ WhereConditions  ).          }
{************************************************}
{           27.08.2003         }
{        MaxLength, }
{  Kind = ekEdit, EditNum, EditCurrency,      }
{ EditCombo    .        }
{************************************************}
{           17.09.2003         }
{                    }
{    ekEditFloat           }
{************************************************}
{           25.09.2003         }
{        QueryInsert_Str            }
{************************************************}
{           09.03.2004         }
{         OnChange       }
{   TUniEdit,  Kind = ekEditPeriod,    }
{     ,   1    }
{   .                                         }
{************************************************}
{           26.08.2010         }
{                 }
{                                 }
{************************************************}

{------------------------------------------------------------
         TUniEdit " "
       :  ..

       : 2 ()
       : 
-------------------------------------------------------------
}
unit UniEdit;

interface

{$I VCL_VERSIONS.INC}
//{$DEFINE INNER_BUTTONS} //- define to provide old style inner ellipsis and arrow
//                          buttons (with themes on, looking ugly)

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, ExtCtrls, ComCtrls, UniPic, buttons, FastListview, Commctrl,
    {$IFDEF _D6orHigher}designintf, Variants{$ELSE}dsgnintf{$ENDIF},
    {$IFDEF _D7}{$IFDEF IN_PACKAGE}VCLEditors, DesignEditors, {$ENDIF}{$ENDIF}
    {$IFDEF USE_NEWQUERY}ADOSQLUnit{$ELSE}dbtables{$ENDIF}, db,
    UniKnopka, Knopka, clipbrd;

const
    WM_INVALIDATE_FRAME = WM_USER + 114;
    WM_USER_SETFOCUS = WM_USER + 155;
var DisableFrameAroundFocusedUniEdit: Boolean = TRUE;


type
    TPeriodKind = (pkMonth, pkDay, pkDecade, pkQuarter, pkYear, pkQuarterYear);

    TLabelPosition = (lpLeft, lpTop);
    TOnOutbound = procedure(Sender: TObject; const OldText: String) of object;

    TCtlPanel = class(TPanel)
        procedure WMPaint(var Msg: TWMPaint); message WM_PAINT;
        //procedure WMErase( var Msg: TWMPaint ); message WM_ERASEBKGND;
    end;

    TTitle = class(TLabel)
    protected
        Handling_Mouse: Boolean;
        procedure WndProc(var M: TMessage); override;
    end;

    TUniEdit = class;

    TEditAny = class(TEdit)
    private
        AOnChange: TNotifyEvent;
        FPreventFocus: Boolean;
        function FUniEdit: TUniEdit;
    protected
        TextWhenEnter: String;
        Need_InvalidateFrame: Boolean;
        FRedrawingFrame: Boolean;
        procedure WMLeave(var M: TWMKillFocus); message WM_KILLFOCUS;
        procedure WMEnter(var M: TWMSetFocus); message WM_SETFOCUS;
        procedure WMKeyDown(var M: TWMKey); message WM_KEYDOWN;
        procedure WMKeyUp(var M: TWMKey); message WM_KEYUP;
        procedure WMKeyPress(var M: TWMChar); message WM_CHAR;
        procedure WMLButton(var M: TWMLButtonDown); message WM_LBUTTONDOWN;
        procedure WMRButton(var M: TWMRButtonDown); message WM_RBUTTONDOWN;
        procedure WMLUp(var M: TWMLButtonUp); message WM_LBUTTONUP;
        procedure WMRUp(var M: TWMRButtonUp); message WM_RBUTTONUP;
        procedure WMLDbl(var M: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
        procedure WMRDbl(var M: TWMRButtonDblClk); message WM_RBUTTONDBLCLK;
        procedure WMEnableFocus(var M: TMessage); message WM_USER + 7;
        procedure WMNCPaint(var M: TMessage); message WM_NCPAINT;
        procedure WMPaint(var M: TMessage); message WM_PAINT;
        //procedure WMErase( var M: TMessage ); message WM_ERASEBKGND;
        procedure WMInvalidateFrame(var M: TMessage); message WM_INVALIDATE_FRAME;
        procedure CMInvalidate(var M: TMessage); message CM_INVALIDATE;
        procedure DoChange(Sender: TObject);
        procedure InvalidateFrame(regioned: Boolean = FALSE);
        procedure ValidateFrame(regioned: Boolean = FALSE);
    public
        function CanFocus: Boolean; override;
        constructor Create(AOwner: TComponent); override;
        property OnChange: TNotifyEvent read AOnChange write AOnChange;
        property SelStart;
        property SelLength;
    end;

    TEditNum = class(TEditAny)
    private
    protected
        procedure WMEditNum(var M: TWMChar); message WM_CHAR;
        procedure WMPaint(var M: TWMPaint); message WM_PAINT;
        procedure WMPaste(var M: TMessage); message WM_PASTE;
    public
    end;

    TEditFloat = class(TEditAny)
    private
    protected
        procedure WMEditFloat(var M: TWMChar); message WM_CHAR;
        procedure WMPaint(var M: TWMPaint); message WM_PAINT;
    public
    end;

    TEditCurrency = class(TEditAny)
    private
    protected
        procedure WMEditCurrency(var M: TWMChar); message WM_CHAR;
        procedure WMPaint(var M: TWMPaint); message WM_PAINT;
        procedure WMLeave(var M: TWMKillFocus); message WM_KILLFOCUS;
    public
    end;

    TEditCheck = class(TCheckBox)
    private
    protected
        procedure SetChecked(Value: Boolean); override;
        procedure DoClick;
    public
    end;

    TEditCombo = class(TCombobox)
    private
        FPreventFocus: Boolean;
        AOnChange: TNotifyEvent;
        FEntering: Boolean;
        FOnCloseUp: TNotifyEvent;
        FIsFocused: Boolean;
        Need_InvalidateFrame: Boolean;
        function FUniEdit: TUniEdit;
    protected
        procedure WMLeave(var M: TWMKillFocus); message WM_KILLFOCUS;
        procedure WMEnter(var M: TWMSetFocus); message WM_SETFOCUS;
        procedure WMKeyDown(var M: TWMKey); message WM_KEYDOWN;
        procedure WMKeyUp(var M: TWMKey); message WM_KEYUP;
        procedure WMKeyPress(var M: TWMChar); message WM_CHAR;
        procedure WMLButton(var M: TWMLButtonDown); message WM_LBUTTONDOWN;
        procedure WMRButton(var M: TWMRButtonDown); message WM_RBUTTONDOWN;
        procedure WMLUp(var M: TWMLButtonUp); message WM_LBUTTONUP;
        procedure WMRUp(var M: TWMRButtonUp); message WM_RBUTTONUP;
        procedure WMLDbl(var M: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
        procedure WMRDbl(var M: TWMRButtonDblClk); message WM_RBUTTONDBLCLK;
        procedure WMEnableFocus(var M: TMessage); message WM_USER + 7;
        procedure WMCloseUp(var M: TMessage); message CN_COMMAND;
        procedure WMPaint(var M: TMessage); message WM_PAINT;
        procedure DoChange(Sender: TObject);
        function OwnerUniEdit: TUniEdit;
        procedure DoLeave(Sender: TObject);
        procedure InvalidateFrame;
        procedure ComboWndProc(var Message: TMessage; ComboWnd: HWnd;
            ComboProc: Pointer); override;
    public
        constructor Create(AOwner: TComponent); override;
        property OnChange: TNotifyEvent read AOnChange write AOnChange;
        property SelStart;
        property SelLength;
        function IsFocused: Boolean;
    end;

    TDateCheck = class(TCheckBox)
    private
        FPreventFocus: Boolean;
        procedure WMKeyDown(var M: TWMKey); message WM_KEYDOWN;
        procedure WMKeyUp(var M: TWMKey); message WM_KEYUP;
        procedure WMKeyPress(var M: TWMChar); message WM_CHAR;
    protected
        procedure SetChecked(Value: Boolean); override;
        procedure DoClick(Sender: TObject);
        procedure WMPaint(var M: TWMPaint); message WM_PAINT;
        procedure WMSetFocus(var M: TWMSetFocus); message WM_SETFOCUS;
        procedure WMKillFocus(var M: TWMKillFocus); message WM_KILLFOCUS;
        procedure WMEnableFocus(var M: TMessage); message WM_USER + 7;
    public
        constructor Create(AOwner: TComponent); override;
    end;

    TOnDefaultDate = procedure(Sender: TObject; var D: TDateTime) of object;

    TDatePicker = class(TDateTimePicker)
    private
        fPreventFocus: Boolean;
        fHideTextPane: TPanel;
        fOnDefaultDate: TOnDefaultDate;
        function FUniEdit: TUniEdit;
    protected
        FSecondPaint: Boolean;
        procedure WMKillFocus(var M: TWMKillFocus); message WM_KILLFOCUS;
        procedure WMEnter(var M: TWMSetFocus); message WM_SETFOCUS;
        procedure WMEnableFocus(var M: TMessage); message WM_USER + 7;
        procedure CheckValidDate(Value: TDate); override;
        procedure Hide_Text;
        procedure Show_Text;
        procedure AdjustHideText;
        procedure WMSize(var M: TMessage); message WM_SIZE;
        procedure WM_KeyDown(var M: TWMKey); message WM_KeyDown;
        procedure WMNCPaint(var M: TMessage); message WM_NCPAINT;
        procedure WMPaint(var M: TMessage); message WM_PAINT;
    protected
        FvalBeforeDrop: TDateTime;
        procedure CNNotify(var Message: TWMNotify); message CN_NOTIFY;
    public
        constructor Create(AOwner: TComponent); override;
        property OnDefaultDate: TOnDefaultDate read fOnDefaultDate write fOnDefaultDate;
    end;

    TEditPeriod = class(TEditAny)
    private
        FDateTime: TDateTime;
        procedure SetDateTime(const Value: TDateTime);
        function FUniEdit: TUniEdit;
        procedure WM_KeyDown(var M: TWMKey); message WM_KeyDown;
    protected
        property DateTime: TDateTime read FDateTime write SetDateTime;
        procedure CreateParams(var Params: TCreateParams); override;
    public
    end;

    TComboItems = class(TStringList)
    private
    protected
    public
    end;

    TEllipsisButton = (ebNone, ebNormal, ebSpeed, ebHidden);

    TUniSource = class;

    TUniEdit = class(TCustomPanel)
    private
        FKind: TEditKind;
        FControl: TWinControl;
        FCtlPanel: TPanel;
        FEllipBtn: TControl;
        FArrowBtns: array[1..4] of TControl;
        FTitle: TLabel;
        FLayout: TLabelPosition;
        FTitleWidth: Integer;
        FAutoSize: Boolean;
        FFitAligned: Boolean;
        FTitleAlign: TAlignment;
        FDisableAdjust: Integer;
        FMaxValue: Double;
        FMinValue: Double;
        FComboStyle: TComboBoxStyle;
        FComboItems: TComboItems;
        FOnOutbound: TOnOutbound;
        fOnChange: TNotifyEvent;
        fOnLeave: TNotifyEvent;
        FDateTimeCheckbox: Boolean;
        FDTCheck: TDateCheck;
        FHidePanel: TPanel;
        FChecked: Boolean;
        FUniPic: TUniPic;
        FPicAutoFit: Boolean;
        FDateFormat: TDTDateFormat;
        fGettingControl: Boolean;
        FPicCenterVertical: Boolean;
        fAutoAdjust: Boolean;
        fLoaded: Boolean;
        fForceAdjust: Boolean;
        FDigits: Integer;
        FEllipsisButton: TEllipsisButton;
        FOnEllipsis: TNotifyEvent;
        FReadOnly: Boolean;
        FGrayReadOnly: Boolean;
        fColor2Set: TColor;
        FOnDropDown: TNotifyEvent;
        FOnCloseUp: TNotifyEvent;
        FListSource: TUniSource;
        FListField: String;
        FListSourcePresent: Boolean;
        FKindPeriod: TPeriodKind;
        FCurrencyCommaChar: Char;
        FMaxLength: Integer;
        FExitOnMaxLenExceed: Boolean;
        FOldComboWidthAdjust: Boolean;
        FDroppedWidth: Integer;
        FStdImgShowSize: Integer;
        F_TabStop: Boolean;
        FTitleFont: TFont;
        FFont: TFont;
        FTitleFontParent: Boolean;
        FControlFontParent: Boolean;
        procedure SetKind(const Value: TEditKind);
        function GetControl: TWinControl;
        function GetText: String;
        procedure SetText(const Value: String);
        procedure WMSize(var Mesg: TWMSize); message WM_SIZE;
        function Get_TabStop: Boolean;
        procedure Set_TabStop(const Value: Boolean);
        procedure SetFont(const Value: TFont);
        procedure SetTitleFont(const Value: TFont);
        procedure SetControlFontParent(const Value: Boolean);
        procedure SetTitleFontParent(const Value: Boolean);
    protected
        FInvalidating: Boolean;
        procedure CMInvalidate(var M: TMessage); message CM_INVALIDATE;
        procedure WMSetFocus(var M: TWMsetFocus); message WM_SETFOCUS;
        procedure WMUserSetFocus(var M: TMessage); message WM_USER_SETFOCUS;
        procedure CM_VISIBLE(var M: TMessage); message CM_VISIBLECHANGED;
        function GetTitle: String;
        procedure SetTitle(const Value: String);
        procedure SetLayout(const Value: TLabelPosition);
        procedure SetTitleWidth(const Value: Integer);
        procedure Set_Autosize(const Value: Boolean);
        procedure SetFitAligned(const Value: Boolean);
        function GetBorderWidth1: Integer;
        procedure SetBorderWidth1(const Value: Integer);
        procedure SetTitleAlign(const Value: TAlignment);
        procedure SetMaxValue(const Value: Double);
        procedure SetMinValue(const Value: Double);
        procedure SetComboStyle(const Value: TComboBoxStyle);
        procedure SetComboItems(const Value: TComboItems);
        procedure SetOnOutbound(const Value: TOnOutbound);
        procedure SetChecked(const Value: Boolean);
        function GetValue: Double;
        procedure SetValue(const Value: Double);
        function GetInteger: Integer;
        procedure SetInteger(const Val: Integer);
        procedure SetDateTimeCheckbox(const Value: Boolean);
        procedure DateChanged(Sender: TObject);
        procedure DateKeyPress(Sender: TObject; var Key: Char);
        procedure DateKeyDown(Sender: TObject; var Key: Word; State: TShiftState);
        procedure DateKeyUp(Sender: TObject; var Key: Word; State: TShiftState);
        procedure CheckClick(Sender: TObject);
        procedure ComboChanged(Sender: TObject);
        procedure ComboKeyDown(Sender: TObject; var Key: Word; State: TShiftState);
        procedure ComboKeyPress(Sender: TObject; var Key: Char);
        procedure ComboKeyUp(Sender: TObject; var Key: Word; State: TShiftState);
        function GetPicture: TPicture;
        procedure SetPicture(const Value: TPicture);
        function GetPicImgList: TImageList;
        procedure SetPicImgList(const Value: TImageList);
        function GetPicImageIndex: Integer;
        procedure SetPicImageIndex(const Value: Integer);
        function GetPicStretch: Boolean;
        procedure SetPicStretch(const Value: Boolean);
        function GetPicHeight: Integer;
        function GetPicWidth: Integer;
        procedure SetPicHeight(const Value: Integer);
        procedure SetPicWidth(const Value: Integer);
        function GetPicTransparent: Boolean;
        procedure SetPictransparent(const Value: Boolean);
        function GetPicAutosize: Boolean;
        procedure SetPicAutosize(const Value: Boolean);
        procedure SetPicAutoFit(const Value: Boolean);
        function GetDateTime: TDateTime;
        procedure SetDateTime(const Val: TDateTime);
        procedure SetDateFormat(const Value: TDTDateFormat);
        procedure SetPicCenterVertical(const Value: Boolean);
        function Get_SelLength: Integer;
        function Get_SelStart: Integer;
        procedure Set_SelLength(const Value: Integer);
        procedure Set_SelStart(const Value: Integer);
        function GetDroppedDown: Boolean;
        procedure SetDroppedDown(const Value: Boolean);
        function GetItemIndex: Integer;
        procedure SetItemIndex(const Value: Integer);
        procedure SetDigits(const Val: Integer);
        function GetChecked: Boolean;
        procedure SetEllipsisButton(const Value: TEllipsisButton);
        procedure SetReadOnly(const Value: Boolean);
        procedure SetGrayReadOnly(const Value: Boolean);
        function GetColor: TColor;
        procedure SetColor(const Value: TColor);
        procedure SetOnCloseUp(const Value: TNotifyEvent);
        procedure SetOnDropDown(const Value: TNotifyEvent);
        procedure SetListSource(const Value: TUniSource);
        procedure SetListField(const Value: String);
        procedure SetListSourcePresent(const Value: Boolean);
        function GetListSource: TUniSource;
        procedure SetKindPeriod(const Value: TPeriodKind);
        procedure SetCurrencyCommaChar(const Value: Char);
        procedure SetMaxLength(const Value: Integer);
        procedure SetExitOnMaxLenExceed(const Value: Boolean);
        function GetFontColor: TColor;
        procedure SetFontColor(const Value: TColor);
        procedure SetOldComboWidthAdjust(const Value: Boolean);
        procedure SetDroppedWidth(const Value: Integer);
        function GetOnDefaultDate: TOnDefaultDate;
        procedure SetOnDefaultDate(const Value: TOnDefaultDate);
        function GetStdImage: TStdImage;
        procedure SetStdImage(const Value: TStdImage);
        procedure SetStdImgShowSize(const Value: Integer);
        function GetDoubleBuffered1: Boolean;
        procedure SetDoubleBuffered1(const Value: Boolean);
        function GetVis1: Boolean;
        procedure SetVis1(const Value: Boolean);
        { Private declarations }
    protected
        { Protected declarations }
        procedure Adjust;
        procedure RemoveHidePanel;
        procedure InstallHidePanel;
        procedure InstallDTCheck;
        procedure Loaded; override;
        procedure RptDebg(const What: String);
        procedure EllipsisButtonClick(Sender: TObject);
        procedure SetReadOnly4Ctl(Value: Boolean);
        procedure SetCtlColor(Color: TColor);
        procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
        procedure DropDownCombobox(Sender: TObject);
        procedure CloseUpCombobox(Sender: TObject);
        function BevelGap(Pn: TPanel): Integer;
        //procedure WMErase( var M: TMessage ); message WM_ERASEBKGND;
        //procedure WMPaint( var M: TMessage ); message WM_PAINT;
        procedure Paint; override;
    public
        { Public declarations }
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        procedure SetName(const Value: TComponentName); override;
        property Control: TWinControl read GetControl;
        procedure ComboItemsChanged(Sender: TObject);
        property AsInteger: Integer read GetInteger write SetInteger;
        property DateTime: TDateTime read GetDateTime write SetDateTime;
        function TitleHeight: Integer;
        property SelStart: Integer read Get_SelStart write Set_SelStart;
        property SelLength: Integer read Get_SelLength write Set_SelLength;
        property DroppedDown: Boolean read GetDroppedDown write SetDroppedDown;
        property ItemIndex: Integer read GetItemIndex write SetItemIndex;
        procedure FocusEllipsisButton;
        property Canvas;
        function CanFocus: Boolean; override;
        procedure WndProc(var M: TMessage); override;
    published
        { Published declarations }
        property Kind: TEditKind read FKind write SetKind;
        property Text: String read GetText write SetText;
        property Title: String read GetTitle write SetTitle;
        property Layout: TLabelPosition read FLayout write SetLayout;
        property TitleWidth: Integer read FTitleWidth write SetTitleWidth;
        property AutoSize: Boolean read FAutoSize write Set_Autosize;
        property FitAligned: Boolean read FFitAligned write SetFitAligned;
        property TitleAlign: TAlignment read FTitleAlign write SetTitleAlign;
        property MinValue: Double read FMinValue write SetMinValue;
        property MaxValue: Double read FMaxValue write SetMaxValue;
        property Digits: Integer read FDigits write SetDigits;
        property ComboStyle: TComboBoxStyle read FComboStyle write SetComboStyle;
        property Items: TComboItems read FComboItems write SetComboItems;
        property OnOutbound: TOnOutbound read FOnOutbound write SetOnOutbound;
        property Checked: Boolean read GetChecked write SetChecked;
        property Value: Double read GetValue write SetValue;
        property DateTimeCheckbox: Boolean read FDateTimeCheckbox write SetDateTimeCheckbox;
        property PicPicture: TPicture read GetPicture write SetPicture;
        property PicImageList: TImageList read GetPicImgList write SetPicImgList;
        property PicImageIndex: Integer read GetPicImageIndex write SetPicImageIndex;
        property PicStretch: Boolean read GetPicStretch write SetPicStretch;
        property PicTransparent: Boolean read GetPicTransparent write SetPictransparent;
        property PicWidth: Integer read GetPicWidth write setPicWidth;
        property PicHeight: Integer read GetPicHeight write SetPicHeight;
        property PicAutoSize: Boolean read GetPicAutosize write SetPicAutosize;
        property PicAutoFit: Boolean read FPicAutoFit write SetPicAutoFit;
        property PicCenterVertical: Boolean read FPicCenterVertical write SetPicCenterVertical;
        property Enabled;
        property DateFormat: TDTDateFormat read FDateFormat write SetDateFormat;
        property BevelInner;
        property BevelOuter;
        property BevelWidth;
        property BorderWidth: Integer read GetBorderWidth1 write SetBorderWidth1;
        property Align;
        property Visible: Boolean read GetVis1 write SetVis1;
        property OnChange: TNotifyEvent read fOnChange write fOnChange;
        property OnKeyDown;
        property OnKeyPress;
        property OnKeyUp;
        property OnMouseDown;
        Property OnMouseMove;
        property OnMouseUp;
        property OnEnter;
        property OnLeave: TNotifyEvent read fOnLeave write fOnLeave;
        property TabStop: Boolean read Get_TabStop write Set_TabStop;
        property TabOrder;
        property Anchors;
        property Constraints;
        property EllipsisButton: TEllipsisButton read FEllipsisButton write SetEllipsisButton;
        property OnEllipsis: TNotifyEvent read FOnEllipsis write FOnEllipsis;
        property ReadOnly: Boolean read FReadOnly write SetReadOnly;
        property GrayReadOnly: Boolean read FGrayReadOnly write SetGrayReadOnly;
        property Color: TColor read GetColor write SetColor;
        property OnDropDown: TNotifyEvent read FOnDropDown write SetOnDropDown;
        property OnCloseUp: TNotifyEvent read FOnCloseUp write SetOnCloseUp;
        property DroppedWidth: Integer read FDroppedWidth write SetDroppedWidth;

    protected
        property ListSourcePresent: Boolean read FListSourcePresent write SetListSourcePresent;
    published
        property ListSource: TUniSource read GetListSource write SetListSource;
        property ListField: String read FListField write SetListField;

    published
        property KindPeriod: TPeriodKind read FKindPeriod write SetKindPeriod;
        property CurrencyCommaChar: Char read FCurrencyCommaChar write SetCurrencyCommaChar;
        property MaxLength: Integer read FMaxLength write SetMaxLength;
        property ExitOnMaxLenExceed: Boolean read FExitOnMaxLenExceed write SetExitOnMaxLenExceed;
        property OldComboWidthAdjust: Boolean read FOldComboWidthAdjust write SetOldComboWidthAdjust;
    protected
        procedure PeriodChanged(Sender: TObject);
        procedure PeriodKeyPress(Sender: TObject; var Key: Char);
        procedure PeriodKeyDown(Sender: TObject; var Key: Word; State: TShiftState);
        procedure PeriodKeyUp(Sender: TObject; var Key: Word; State: TShiftState);
        procedure PeriodClick(Sender: TObject);
        procedure PeriodExit(Sender: TObject);
        function Period_Position2Field(CharPos: Integer): Integer;
        function Period_FieldPosition(FieldIdx: Integer; S: String = '@'): Integer;
        function Period_FieldLength(FieldIdx: Integer; S: String = '@'): Integer;
        function Period_FieldCount: Integer;
        function Period_IsFieldValid(FieldIdx: Integer; S: String = '@'): Integer;
        procedure ArrowBtn1Click(Sender: TObject);
        procedure ArrowBtn2Click(Sender: TObject);
        procedure ArrowBtn3Click(Sender: TObject);
        procedure ArrowBtn4Click(Sender: TObject);
    public
        procedure Invalidate; override;
        function EllipsisButtonControl: TControl;
    published
        property FontColor: TColor read GetFontColor write SetFontColor;
        property OnDefaultDate: TOnDefaultDate read GetOnDefaultDate write SetOnDefaultDate;
        property StdImage: TStdImage read GetStdImage write SetStdImage;
        property StdImgShowSize: Integer read FStdImgShowSize write SetStdImgShowSize;
        property DoubleBuffered: Boolean read GetDoubleBuffered1 write SetDoubleBuffered1;
        property ControlFont: TFont read FFont write SetFont;
        property ControlFontParent: Boolean read FControlFontParent write SetControlFontParent
            default TRUE;
        property TitleFont: TFont read FTitleFont write SetTitleFont;
        property TitleFontParent: Boolean read FTitleFontParent write SetTitleFontParent
            default TRUE;
    protected
        function ParentForm: TCustomForm;
    end;

    TUniSource = class(TComponent)
    private
        FFastListView: TFastListView;
        FFastListViewExists: Boolean;
        procedure SetFastListView(const Value: TFastListView);
        function GetLinkedUniEditControls(Idx: Integer): TUniEdit;
        function GetUniEditCount: Integer;
        procedure SetFastListViewExists(const Value: Boolean);
        function GetFastListView: TFastListView;
    protected
        FUniEditList: TList;
    public
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        property LinkedUniEditCount: Integer read GetUniEditCount;
        property LinkedUniEditControls[Idx: Integer]: TUniEdit read GetLinkedUniEditControls;
        procedure AddUniEdit(UE: TUniEdit);
        procedure RemoveUniEdit(UE: TUniEdit);
        function FieldExists(const AFieldName: String): Boolean;
        property FastListViewExists: Boolean read FFastListViewExists write SetFastListViewExists;
    PUBLIC
        procedure ListItemBeginEdit(LI: TFastListItem);
        procedure ListItemEndEdit(LI: TFastListItem);

        {$IFDEF USE_NEWQUERY}
        function QueryInsert(const TableName: String;
            const MoreValues: Array of Variant;
            const MoreFields: String = ''; MoreParams: String = '';
            const DoBefore: String = '';
            const WhereConditions: String = ''): Integer; overload;

        function QueryInsert_Str(const TableName: String;
            const MoreValues: String = '';
            const MoreFields: String = '';
            const DoBefore: String = '';
            const WhereConditions: String = '';
            NeedIdentity: Boolean = TRUE): Integer;

        function QueryUpdate(const TableName: String;
            const MoreValues: array of Variant; MoreFields: String;
            MoreParams: String; const DoBefore, WhereConditions: String): Boolean;
        function QueryUpdate_Str(const TableName: String;
            const MoreValues: array of Variant; MoreFields: String;
            MoreParams: String; const DoBefore, WhereConditions: String): Boolean;
        {$ENDIF USE_NEWQUERY}
    published
        property FastListView: TFastListView read GetFastListView write SetFastListView;
    end;

    {$IFDEF _D6orHigher}
    {$ELSE}
    {$IFDEF IN_PACKAGE}
    TUniSourceEditField = class(TStringProperty)
        function GetAttributes: TPropertyAttributes; override;
        procedure GetValues(Proc: TGetStrProc); override;
    end;
    {$ENDIF}
    {$ENDIF}

    {$IFDEF IN_PACKAGE}
procedure Register;
{$ENDIF}

procedure AdjustRestrictions(UniSource: TUniSource; const TableName: String);


//{$R uniedit.dcr}

implementation

//{$DEFINE DEBG}

{$IFDEF IN_PACKAGE}

procedure Register;
begin
    RegisterComponents('Kladov', [TUniEdit, TUniSource]);
    {$IFDEF _D6orHigher}
    {$ELSE}
    RegisterPropertyEditor(TypeInfo(String), TUniEdit, 'ListField',
        TUnisourceEditField);
    {$ENDIF}
end;
{$ENDIF}

function MakeShiftState: TShiftState;
begin
    Result := [];
    if GetKeyState(VK_SHIFT) < 0 then
        Result := [ssShift];
    if GetKeyState(VK_CONTROL) < 0 then
        Result := Result + [ssCtrl];
    if GetKeyState(VK_MENU) < 0 then
        Result := Result + [ssAlt];
    if GetKeyState(VK_LBUTTON) < 0 then
        Result := Result + [ssLeft];
    if GetKeyState(VK_RBUTTON) < 0 then
        Result := Result + [ssRight];
end;

function HelpFloat2Str(D: Double): String;
var I: Integer;
begin
    //Result := format( '%.9f', [ D ] );
    Result := FloatToStrF(D, ffFixed, 12, 8);
    for I := Length(Result) downto 2 do
    begin
        if (Result[I] = '0') and not (Result[I - 1] in [',', '.', '-']) then
            Delete(Result, Length(Result), 1)
        else
            break;
    end;
end;

function Float2Str(D: Double): String;
//var S: String;
begin
    Result := HelpFloat2Str(D);
    {
    S := HelpFloat2Str( D + 0.00000001 );
    if Length( S ) < Length( Result ) then
      Result := S;
    S := HelpFloat2Str( D - 0.00000001 );
    if Length( S ) < Length( Result ) then
      Result := S;
    }
end;

function Str2Int(const S: String): Integer;
begin
    if S = '' then Result := 0
    else Result := StrToInt(S);
end;

function Str2Float(const S: String): Double;
begin
    if S = '' then Result := 0.0
    else Result := StrToFloat(S);
end;

function Date2Str(D: TDateTime): String;
var ST: TSystemTime;
begin
    DateTimeToSystemTime(D, ST);
    Result := Format('%.2d.%.2d.%d', [ST.wDay, ST.wMonth, ST.wYear]);
end;

function StrToSQL(S: String): String;
var I: Integer;
begin
    for I := Length(S) downto 1 do
        if S[I] = '''' then
            S := Copy(S, 1, I) + '''' + Copy(S, I + 1, Length(S) - I);
    Result := '''' + S + '''';
end;

function IsInteger(const S: String): Boolean;
var I: Integer;
begin
    Result := True;
    if S = '' then Exit;
    I := 1;
    if S[1] = '-' then
    begin
        Inc(I);
    end;
    for I := I to Length(S) do
        if not (S[I] in ['0'..'9']) then
        begin
            Result := False;
            break;
        end;
end;

function IsFloat(const S: String): Boolean;
var I: Integer;
    PointFound: Boolean;
begin
    Result := True;
    PointFound := False;
    if S = '' then Exit;
    if S = '-' then Exit;
    I := 1;
    if S[1] = '-' then
    begin
        Inc(I);
    end;
    for I := I to Length(S) do
        if not (S[I] in ['0'..'9']) then
        begin
            if (S[I] = DecimalSeparator) and not PointFound then
            begin
                PointFound := True;
                continue;
            end;
            Result := False;
            break;
        end;
end;

function IsCurrency(const S: String): Boolean;
var SepFound: Boolean;
    I: Integer;
begin
    Result := True;
    SepFound := False;
    if S = '' then exit;
    for I := 1 to Length(S) do
    begin
        if not (S[I] in ['0'..'9']) then
        begin
            if (S[I] in ['-', ',', '.']) and not SepFound then
            begin
                SepFound := True;
                if Length(S) - I > 2 then
                begin
                    Result := False;
                    break;
                end;
                continue;
            end;
            Result := False;
            break;
        end;
    end;
end;

function IsRome(const S: String): Boolean;
var U: String;
begin
    U := UpperCase(S);
    Result := (U = 'I') or (U = 'II') or (U = 'III') or (U = 'IV');
end;

function Rome2Int(const S: String): Integer;
var U: String;
begin
    U := UpperCase(S);
    if U = 'I' then Result := 1
    else if U = 'II' then Result := 2
    else if U = 'III' then Result := 3
    else if U = 'IV' then Result := 4
    else Result := 0;
end;

function Year(D: TDateTime): Integer;
var Y, M, D1: Word;
begin
    DecodeDate(D, Y, M, D1);
    Result := Y;
end;

function Month(D: TDateTime): Integer;
var Y, M, D1: Word;
begin
    DecodeDate(D, Y, M, D1);
    Result := M;
end;

{$R Period_Buttons.res}
var PeriodButtons: array[1..4] of TBitmap;

function GetPeriodButton(Idx: Integer): TBitmap;
begin
    Assert((Idx >= 1) and (Idx <= 4),
        'Incorrect period button index: ' + IntToStr(Idx));
    if PeriodButtons[Idx] = nil then
    begin
        PeriodButtons[Idx] := TBitmap.Create;
        PeriodButtons[Idx].LoadFromResourceName(hInstance,
            'PERIODBUTTON' + IntToStr(Idx));
    end;
    Result := PeriodButtons[Idx];
end;

function IntToRome(I: Integer): String;
begin
    Assert((I >= 1) and (I <= 4), '     ' +
        '   : ' + IntToStr(I));
    CASE I OF
        1: Result := 'I';
        2: Result := 'II';
        3: Result := 'III';
        4: Result := 'IV';
    END;
end;

function CalcYear(Y: Integer): Integer;
begin
    if Y < 1000 then
    begin
        if Y < 50 then // 0..50
            Inc(Y, 2000) // -> 2000..2050
        else
            if Y < 100 then // 51..99
                Inc(Y, 1900) // -> 1951..1999
            else
                if Y < 900 then // 100..899
                    Inc(Y, 2000) // -> 2100..2899
                else // 900..999
                    Inc(Y, 1000); // -> 1900..1999
    end;
    Result := Y;
end;

{ TUniEdit }

procedure TUniEdit.RptDebg(const What: String);
var F: Integer;
    W: DWORD;
begin
    F := CreateFile('c:\ooo.txt', GENERIC_WRITE, 0, nil, OPEN_ALWAYS,
        FILE_ATTRIBUTE_NORMAL, 0);
    SetfilePointer(F, 0, nil, 2);
    WriteFile(F, PChar(Name + ': ')^, Length(Name) + 2, W, nil);
    WriteFile(F, What[1], Length(What), W, nil);
    WriteFile(F, '' + #13#10, 2, W, nil);
    CloseHandle(F);
end;

procedure TUniEdit.Adjust;
    function Max(A, B: Integer): Integer;
    asm
    CMP EAX, EDX
    JGE @@exit
    XCHG EAX, EDX
    @@exit:
    end;
var L, W, H, L2: Integer;
begin
    if csLoading in ComponentState then Exit;
    {$IFDEF DEBG}
    if csDesigning in ComponentState then
        RptDebg('Enter to Adjust, DesignTime')
    else
        RptDebg('Enter to Adjust');
    {$ENDIF}

    //if not (csDesigning in ComponentState) then
    if not fLoaded then Exit;
    //ShowMessage( 'Enter to Adjust' );
    if FDisableAdjust > 0 then Exit;
    inc(FDisableAdjust);
    TRY
        if FTitle = nil then Exit;
        if FControl = nil then Exit;
        if FUniPic = nil then Exit;
        if Control = nil then Exit;

        {$IFDEF DEBG}
        if csDesigning in ComponentState then
            RptDebg('Adjust, DesignTime')
        else
            RptDebg('Adjust');
        {$ENDIF}

        //ShowMessage( 'StartingAdjust' );
        FTitle.Left := BorderWidth;
        FUniPic.Visible := not FUniPic.Empty or (StdImgShowSize > 0);
        if not FUniPic.Visible then
        begin
            FUniPic.Top := 1000;
            FUniPic.Left := 3000;
            FUniPic.Width := 0;
            FUniPic.Height := 0;
        end;
        {$IFDEF DEBG}
        if csDesigning in ComponentState then
            RptDebg('FUniPic.Visible = ' + IntToStr(Integer(FUniPic.Visible)) + ', DesignTime')
        else
            RptDebg('FUniPic.Visible = ' + IntToStr(Integer(FUniPic.Visible)));
        {$ENDIF}
        case FLayout of
            lpLeft:
                begin
                    if FTitleWidth = 0 then
                    begin
                        FTitle.AutoSize := False;
                        FTitle.AutoSize := True;
                    end
                    else
                    begin
                        FTitle.AutoSize := False;
                        FTitle.Width := FTitleWidth;
                    end;
                    FCtlPanel.Top := BorderWidth;
                    if not FCtlPanel.Visible then
                        Control.Top := BorderWidth;
                    {$IFDEF INNER_BUTTONS}
                    FCtlPanel.Height := Control.Height + FCtlPanel.BevelWidth * 2;
                    {$ELSE}
                    FCtlPanel.Height := Control.Height + BevelGap(FCtlPanel) * 2;
                    Control.Height := FCtlPanel.Height - BevelGap(FCtlPanel) * 2;
                    {$ENDIF}
                    FTitle.Top := FCtlPanel.Top + (FCtlPanel.Height - TitleHeight) div 2;
                    L := BorderWidth;
                    if FUniPic.Visible then
                    begin
                        FUniPic.Left := BorderWidth;
                        FUniPic.Top := BorderWidth;
                        L := BorderWidth + FUniPic.Width + BorderWidth;
                        if PicAutoFit then
                        begin
                            FUniPic.Height := Height - BorderWidth * 2;
                            //SetPicAutoFit( PicAutoFit );
                        end;
                    end;
                    FTitle.Left := L;
                    if (FTitle.Caption <> '') or (FTitleWidth > 0) then
                        L := FTitle.Left + FTitle.Width + BorderWidth
                    else
                        L := FTitle.Left;
                    if FDTCheck <> nil then
                    begin
                        FDTCheck.Top := FCtlPanel.Top;
                        FDTCheck.Height := FCtlPanel.Height;
                        FDTCheck.Left := L;
                        FDTCheck.Width := FDTCheck.Height;
                        L := L + FDTCheck.Width + (BorderWidth + 1) div 2;
                    end;
                    FCtlPanel.Left := L;
                    if not FCtlPanel.Visible then
                        Control.Left := L;
                    if not Autosize or FitAligned
                        {and (Align in [alTop, alRight, alClient])}
                    //and not( (Kind = ekEditDate) and DateTimeCheckbox)
                    then
                        FCtlPanel.Width := (ClientWidth - BorderWidth - L);
                    if FUniPic.Visible then
                        if FPicCenterVertical then
                            FUniPic.Top := (Height - FUniPic.Height) div 2;
                end;
            lpTop:
                begin
                    FTitle.AutoSize := False;
                    FTitle.AutoSize := True;
                    FTitle.Top := BorderWidth;
                    L := BorderWidth;
                    L2 := BorderWidth;
                    FCtlPanel.Top := FTitle.Top + TitleHeight + BorderWidth;
                    if not FCtlPanel.Visible then
                        Control.Top := FCtlPanel.Top;
                    if FUniPic.Visible then
                    begin
                        FUniPic.Left := L;
                        FUniPic.Top := BorderWidth;
                        L := L + FUniPic.Width + BorderWidth;
                        if PicAutoFit then
                        begin
                            FUniPic.Height := TitleHeight + BorderWidth + FCtlPanel.Height;
                            FUniPic.Stretch := True;
                            L2 := L;
                        end;
                    end;
                    FTitle.Left := L;
                    if FDTCheck <> nil then
                    begin
                        FDTCheck.Top := FCtlPanel.Top;
                        FDTCheck.Height := FCtlPanel.Height;
                        FDTCheck.Left := L2;
                        FDTCheck.Width := FDTCheck.Height;
                        L2 := L2 + FDTCheck.Width + (BorderWidth + 1) div 2;
                    end;
                    FCtlPanel.Left := L2;
                    if not FCtlPanel.Visible then
                        Control.Left := L2;
                    if (not Autosize or FitAligned) {and not ((Kind = ekEditDate) and DateTimeCheckbox)}
                    then
                    begin
                        fAutoAdjust := False;
                        if (FTitle.Caption <> '') or (FTitleWidth > 0) then
                            FTitle.Width := ClientWidth - BorderWidth - L;
                        FCtlPanel.Width := ClientWidth - BorderWidth - L2;
                        fAutoAdjust := True;
                    end;
                end;
        end;
        if FAutoSize then
        begin
            W := FCtlPanel.Width;
            if FDTCheck <> nil then
                W := W + FDTCheck.Width + (BorderWidth + 1) div 2;
            case FLayout of
                lpLeft:
                    begin
                        if not (Align in [alLeft, alRight, alClient]) then
                        begin
                            H := Max(FTitle.Top + TitleHeight + BorderWidth,
                                FCtlPanel.Top + FCtlPanel.Height + BorderWidth);
                            if FUniPic.Visible then
                                H := Max(H, FUniPic.Top + FUniPic.Height + BorderWidth);
                            Height := H + Height - ClientHeight;
                        end;
                        if not (Align in [alTop, alBottom, alClient]) then
                        begin
                            if (FTitle.Caption <> '') or (FTitleWidth > 0) then
                                W := BorderWidth * 3 + FTitle.Width + W
                            else
                                W := BorderWidth * 2 + W;
                            if FUniPic.Visible then
                                W := W + FUniPic.Width + BorderWidth;
                            Width := W;
                        end;
                    end;
                lpTop:
                    begin
                        if not (Align in [alLeft, alRight, alClient]) then
                            Height := BorderWidth * 3 + TitleHeight + FCtlPanel.Height;
                        if not (Align in [alTop, alBottom, alClient]) then
                        begin
                            if FUniPic.Visible and PicAutoFit then
                                if FUniPic.Width > 0 then
                                    W := W + FUniPic.Width + BorderWidth;
                            L := FTitle.Width;
                            if FUniPic.Visible then
                                if FUniPic.Width > 0 then
                                    L := L + FUniPic.Width + BorderWidth;
                            W := Max(L, W) + BorderWidth * 2
                                + Width - ClientWidth;
                            fAutoAdjust := False;
                            {if Width <> W then
                            begin
                              ShowMessage( 'OldWidth=' + IntToStr( Width ) + ', NewWidth=' + IntToStr( W ) );
                            end;}
                            Width := W;
                            fAutoAdjust := True;
                        end;
                    end;
            end;
        end;
        if FEllipBtn = nil then
        begin
            {$IFDEF INNER_BUTTONS}
            if (Kind = ekCombo) and not OldComboWidthAdjust then
                Control.Width := FCtlPanel.Width - FCtlPanel.BevelWidth * 2 + 3 - BorderDelta
                    //Control.Width := FCtlPanel.Width - BevelGap(FCtlPanel) * 2 + 3
            else
                Control.Width := FCtlPanel.Width - FCtlPanel.BevelWidth * 2 - BorderDelta;
            FCtlPanel.Height := Control.Height + FCtlPanel.BevelWidth * 2;
            Control.Height := FCtlPanel.Height - FCtlPanel.BevelWidth * 2;
            {$ELSE}
            Control.Width := FCtlPanel.Width - BevelGap(FCtlPanel) * 2;
            FCtlPanel.Height := Control.Height + BevelGap(FCtlPanel) * 2;
            Control.Height := FCtlPanel.Height - BevelGap(FCtlPanel) * 2;
            {$ENDIF}
        end
        else
        begin
            {$IFDEF INNER_BUTTONS}
            FCtlPanel.Height := Control.Height + FCtlPanel.BevelWidth * 2;
            if (Kind = ekCombo) and not OldComboWidthAdjust then
                Control.Width := FCtlPanel.Width - FCtlPanel.BevelWidth * 2 - FEllipBtn.Width + 2 - BorderDelta
            else
                Control.Width := FCtlPanel.Width - FCtlPanel.BevelWidth * 2 - FEllipBtn.Width - BorderDelta;
            Control.Height := FCtlPanel.Height - FCtlPanel.BevelWidth * 2;
            {$ELSE}
            FCtlPanel.Height := Control.Height + BevelGap(FCtlPanel) * 2;
            {if  (Kind = ekCombo) and not OldComboWidthAdjust then
                Control.Width := FCtlPanel.Width - BevelGap(FCtlPanel) * 2
                               - FEllipBtn.Width + 2
            else}
            Control.Width := FCtlPanel.Width - BevelGap(FCtlPanel) * 2
                - FEllipBtn.Width;
            Control.Height := FCtlPanel.Height - BevelGap(FCtlPanel) * 2;
            {$ENDIF}
            if Kind in [{$IFDEF INNER_BUTTONS}ekCombo, {$ENDIF}ekEditDate] then
            begin
                {$IFDEF INNER_BUTTONS}
                FEllipBtn.Height := Control.Height - 4;
                FEllipBtn.Top := 2 + FCtlPanel.Top;
                {$ELSE}
                FEllipBtn.Height := Control.Height - 1;
                FEllipBtn.Top := 0;
                {$ENDIF}
                FEllipBtn.Left := Control.Left + Control.Width;
            end
            else
            begin
                {$IFDEF INNER_BUTTONS}
                if Kind = ekCombo then
                    FEllipBtn.Height := Control.Height - 4
                else
                    FEllipBtn.Height := Control.Height;
                FEllipBtn.Height := Control.Height;
                FEllipBtn.Top := FCtlPanel.BevelWidth;
                FEllipBtn.Left := FCtlPanel.Width - FCtlPanel.BevelWidth - FEllipBtn.Width;
                {$ELSE}
                FEllipBtn.Height := Control.Height - 1;
                FEllipBtn.Top := 0;
                FEllipBtn.Left := FCtlPanel.Width - BevelGap(FCtlPanel) - FEllipBtn.Width;
                {$ENDIF}
            end;
        end;
        if Kind = ekEditPeriod then
        begin
            {$IFDEF INNER_BUTTONS}
            FControl.Left := FCtlPanel.BevelWidth + BorderLeft;
            FControl.Top := FCtlPanel.BevelWidth;
            FControl.Width := FCtlPanel.Width - 2 * FCtlPanel.BevelWidth - BorderDelta;
            FControl.Height := FCtlPanel.Height - 2 * FCtlPanel.BevelWidth;
            {$ELSE}
            FControl.Left := BevelGap(FCtlPanel);
            FControl.Top := BevelGap(FCtlPanel);
            FCtlPanel.Height := FControl.Height + 2 * BevelGap(FCtlPanel);
            FControl.Width := FCtlPanel.Width - 2 * BevelGap(FCtlPanel); //FCtlPanel.BevelWidth;
            FControl.Height := FCtlPanel.Height - 2 * BevelGap(FCtlPanel);
            {$ENDIF}
            if FArrowBtns[1] <> nil then
            begin
                FArrowBtns[1].Top := FControl.Top;
                FArrowBtns[1].Left := FControl.Left;
                FControl.Left := FControl.Left + FArrowBtns[1].Width;
                FControl.Width := FControl.Width - FArrowBtns[1].Width;
            end;
            if FArrowBtns[3] <> nil then
            begin
                FArrowBtns[3].Top := FControl.Top;
                FArrowBtns[3].Left := FControl.Left;
                FControl.Left := FControl.Left + FArrowBtns[3].Width;
                FControl.Width := FControl.Width - FArrowBtns[3].Width;
            end;
            if FArrowBtns[2] <> nil then
            begin
                FArrowBtns[2].Top := FControl.Top;
                FArrowBtns[2].Left := FControl.Left + FControl.Width - FArrowBtns[2].Width;
                FControl.Width := FControl.Width - FArrowBtns[2].Width;
            end;
            if FArrowBtns[4] <> nil then
            begin
                FArrowBtns[4].Top := FControl.Top;
                FArrowBtns[4].Left := FControl.Left + FControl.Width - FArrowBtns[4].Width;
                FControl.Width := FControl.Width - FArrowBtns[4].Width;
            end;
        end;
    FINALLY
        dec(FDisableAdjust);
        if not (csLoading in ComponentState) then
        begin
            Invalidate;
            if (FControl <> nil) and not FControl.Focused then
            begin
                FControl.Visible := FALSE;
                FControl.Visible := TRUE;
            end;
        end;
    END;
    {FCtlPanel.Invalidate;
    Control.Invalidate;}
    //Control.Update;
    {$IFDEF DEBG}
    RptDebg('Leave from Adjust');
    {$ENDIF}
end;

procedure TUniEdit.CheckClick(Sender: TObject);
begin
    {$IFDEF DEBG}
    RptDebg('CheckClick');
    {$ENDIF}
    (FControl as TEditCheck).DoClick;
end;

procedure TUniEdit.ComboChanged(Sender: TObject);
begin
    {$IFDEF DEBG}
    RptDebg('ComboChanged');
    {$ENDIF}
    if Assigned(OnChange) then
        OnChange(Self);
end;

procedure TUniEdit.ComboItemsChanged(Sender: TObject);
begin
    if csDesigning in ComponentState then Exit;
    if Kind = ekCombo then
        (FControl as TEditCombo).Items := FComboItems;
    if Assigned(OnChange) then
        OnChange(Self);
end;

constructor TUniEdit.Create(AOwner: TComponent);
begin
    inherited;
    {$IFDEF DEBG}
    RptDebg('Create');
    {$ENDIF}
    fColor2Set := clNone;
    FGrayReadOnly := TRUE;
    fAutoAdjust := True;
    FAutosize := True;
    FFitAligned := True;
    FComboItems := TComboItems.Create;
    FComboItems.OnChange := ComboItemsChanged;
    FUniPic := TUniPic.Create(Self);
    FUniPic.Parent := Self;
    FUniPic.Visible := False;
    FUniPic.MouseTransparent := TRUE;
    FDigits := -1;
    Self.BevelOuter := bvNone;
    Self.BorderWidth := 4;
    FTitle := TTitle.Create(Self);
    FTitle.Parent := Self;
    FPicCenterVertical := True;
    PicAutoSize := True;
    PicAutoFit := True;
    TabStop := True;
    FFont := TFont.Create;
    FControlFontParent := TRUE;
    FTitleFont := TFont.Create;
    FTitleFontParent := TRUE;
    {$IFDEF DEBG}
    RptDebg('Created');
    {$ENDIF}
    fLoaded := True;
    //Adjust;
    ControlStyle := ControlStyle - [csAcceptsControls];
    FullRepaint := FALSE;
end;

procedure TUniEdit.DateChanged(Sender: TObject);
begin
    if Assigned(OnChange) then
        OnChange(Self);
end;

destructor TUniEdit.Destroy;
begin
    {$IFDEF DEBG}
    RptDebg('Destroy');
    {$ENDIF}
    if ListSource <> nil then
        ListSource.RemoveUniEdit(Self);
    FComboItems.Free;
    inherited;
end;

function TUniEdit.GetBorderWidth1: Integer;
begin
    Result := inherited BorderWidth;
end;

function TUniEdit.GetControl: TWinControl;
var j: Integer;
begin
    Result := nil;
    if fGettingControl then Exit;

    {$IFDEF DEBG}
    RptDebg('GetControl');
    {$ENDIF}

    fGettingControl := True;
    TRY
        if (FEllipBtn <> nil) and (FEllipsisButton = ebNone) then
        begin
            FEllipBtn.Free;
            FEllipBtn := nil;
        end;

        if FControl = nil then
        begin

            if (FArrowBtns[1] <> nil) or (FArrowBtns[2] <> nil) or
                (FArrowBtns[3] <> nil) or (FArrowBtns[4] <> nil) then
            begin
                FreeAndNil(FArrowBtns[1]);
                FreeAndNil(FArrowBtns[2]);
                FreeAndNil(FArrowBtns[3]);
                FreeAndNil(FArrowBtns[4]);
            end;

            case FKind of
                ekEdit:
                    begin
                        FCtlPanel := TCtlPanel.Create(Self);
                        FCtlPanel.Parent := Self;
                        FCtlPanel.FullRepaint := FALSE;
                        FControl := TEditAny.Create(Self);
                        {$IFDEF INNER_BUTTONS}
                        FCtlPanel.BevelWidth := 2;
                        FCtlPanel.BevelOuter := bvLowered;
                        (FControl as TEditAny).BorderStyle := bsNone;
                        {$ELSE}
                        FCtlPanel.BevelOuter := bvNone;
                        {$ENDIF}
                        FControl.Parent := FCtlPanel;
                        (FControl as TEditAny).OnChange := ComboChanged;
                        if fColor2Set <> clNone then
                            (FControl as TEditAny).Color := fColor2Set;
                    end;
                ekEditFloat:
                    begin
                        FCtlPanel := TCtlPanel.Create(Self);
                        FCtlPanel.Parent := Self;
                        FCtlPanel.FullRepaint := FALSE;
                        {$IFDEF INNER_BUTTONS}
                        FCtlPanel.BevelWidth := 2;
                        FCtlPanel.BevelOuter := bvLowered;
                        FControl := TEditFloat.Create(Self);
                        (FControl as TEditAny).BorderStyle := bsNone;
                        {$ELSE}
                        FCtlPanel.BevelOuter := bvNone;
                        FControl := TEditFloat.Create(Self);
                        {$ENDIF}
                        FControl.Parent := FCtlPanel;
                        if fColor2Set <> clNone then
                            (FControl as TEditFloat).Color := fColor2Set;
                    end;
                ekEditCurrency:
                    begin
                        FCtlPanel := TCtlPanel.Create(Self);
                        FCtlPanel.Parent := Self;
                        FCtlPanel.FullRepaint := FALSE;
                        {$IFDEF INNER_BUTTONS}
                        FCtlPanel.BevelWidth := 2;
                        FCtlPanel.BevelOuter := bvLowered;
                        FControl := TEditCurrency.Create(Self);
                        (FControl as TEditAny).BorderStyle := bsNone;
                        {$ELSE}
                        FCtlPanel.BevelOuter := bvNone;
                        FControl := TEditCurrency.Create(Self);
                        {$ENDIF}
                        FControl.Parent := FCtlPanel;
                        if fColor2Set <> clNone then
                            (FControl as TEditAny).Color := fColor2Set;
                    end;
                ekEditNum:
                    begin
                        FCtlPanel := TCtlPanel.Create(Self);
                        FCtlPanel.Parent := Self;
                        FCtlPanel.FullRepaint := FALSE;
                        {$IFDEF INNER_BUTTONS}
                        FCtlPanel.BevelOuter := bvLowered;
                        FCtlPanel.BevelWidth := 2;
                        FControl := TEditNum.Create(Self);
                        (FControl as TEditNum).BorderStyle := bsNone;
                        {$ELSE}
                        FCtlPanel.BevelOuter := bvNone;
                        FControl := TEditNum.Create(Self);
                        {$ENDIF}
                        FControl.Parent := FCtlPanel;
                        if fColor2Set <> clNone then
                            (FControl as TEditNum).Color := fColor2Set;
                    end;
                ekEditDate:
                    begin
                        if DateTimeCheckBox then
                        begin
                            InstallDTCheck;
                            FDTCheck.Checked := Checked;
                        end;
                        FCtlPanel := TCtlPanel.Create(Self);
                        FCtlPanel.Parent := Self;
                        FCtlPanel.FullRepaint := FALSE;
                        FCtlPanel.BevelWidth := 1;
                        FCtlPanel.BevelOuter := bvNone;
                        {$IFDEF INNER_BUTTONS}
                        FCtlPanel.Visible := FALSE;
                        {$ENDIF}

                        FControl := TDatePicker.Create(Self);
                        FControl.Parent := {$IFDEF INNER_BUTTONS}Self{$ELSE}FCtlPanel{$ENDIF};
                        (FControl as TDatePicker).DateFormat := FDateFormat;
                        (FControl as TDatePicker).OnChange := DateChanged;
                        (FControl as TDatePicker).OnKeyPress := DateKeyPress;
                        (FControl as TDatePicker).OnKeyDown := DateKeyDown;
                        (FControl as TDatePicker).OnKeyUp := DateKeyUp;
                        if fColor2Set <> clNone then
                            (FControl as TDatePicker).Color := fColor2Set;
                    end;
                ekEditPeriod:
                    begin
                        FCtlPanel := TCtlPanel.Create(Self);
                        FCtlPanel.Parent := Self;
                        FCtlPanel.FullRepaint := FALSE;

                        FControl := TEditPeriod.Create(Self);
                        (FControl as TEditAny).OnClick := PeriodClick;
                        (FControl as TEditPeriod).OnExit := PeriodExit;
                        {$IFDEF INNER_BUTTONS}
                        FCtlPanel.BevelWidth := 2;
                        FCtlPanel.BevelOuter := bvLowered;
                        (FControl as TEditAny).BorderStyle := bsNone;
                        {$ELSE}
                        FCtlPanel.BevelOuter := bvNone;
                        {$ENDIF}
                        FControl.Parent := FCtlPanel;
                        Height := FControl.Height;
                        FCtlPanel.Height := Height;

                        (FControl as TEditPeriod).OnChange := PeriodChanged;
                        (FControl as TEditPeriod).OnKeyPress := PeriodKeyPress;
                        (FControl as TEditPeriod).OnKeyDown := PeriodKeyDown;
                        (FControl as TEditPeriod).OnKeyUp := PeriodKeyUp;
                        if fColor2Set <> clNone then
                            (FControl as TEditPeriod).Color := fColor2Set;

                        //if FEllipsisButton <> ebNone then
                        begin
                            if FArrowBtns[1] = nil then
                                CASE FEllipsisButton OF
                                    ebNormal: begin
                                            for j := 1 to 2 do
                                            begin
                                                {$IFDEF INNER_BUTTONS}
                                                FArrowBtns[j] := TBitKnopka.Create(Self);
                                                FArrowBtns[j].Parent := FCtlPanel;
                                                {$ELSE}
                                                FArrowBtns[j] := TBitKnopka.Create(FCtlPanel);
                                                FArrowBtns[j].Parent := FCtlPanel;
                                                {$ENDIF}
                                                (FArrowBtns[j] as TBitKnopka).AssignGlyph
                                                    (GetPeriodButton(j));
                                            end;
                                            (FArrowBtns[1] as TBitKnopka).OnClick := ArrowBtn1Click;
                                            (FArrowBtns[2] as TBitKnopka).OnClick := ArrowBtn2Click;
                                        end;
                                    ebNone,
                                        ebHidden,
                                        ebSpeed: begin
                                            for j := 1 to 2 do
                                            begin
                                                {$IFDEF INNER_BUTTONS}
                                                FArrowBtns[j] := TSpeedKnopka.Create(Self);
                                                FArrowBtns[j].Parent := FCtlPanel;
                                                {$ELSE}
                                                FArrowBtns[j] := TSpeedKnopka.Create(FCtlPanel);
                                                FArrowBtns[j].Parent := FCtlPanel;
                                                {$ENDIF}
                                                (FArrowBtns[j] as TSpeedKnopka).AssignGlyph
                                                    (GetPeriodButton(j));
                                                //FArrowBtns[ j ].Visible := FEllipsisButton <> ebHidden;
                                            end;
                                            (FArrowBtns[1] as TSpeedKnopka).OnClick := ArrowBtn1Click;
                                            (FArrowBtns[2] as TSpeedKnopka).OnClick := ArrowBtn2Click;
                                        end;
                                END;
                            //FArrowBtns[ 1 ].Parent := Self;
                            //FArrowBtns[ 2 ].Parent := Self;
                            FArrowBtns[1].Width := 17;
                            FArrowBtns[1].Height := FControl.Height;
                            FArrowBtns[2].Width := 17;
                            FArrowBtns[2].Height := FControl.Height;
                            if KindPeriod <> pkYear then
                            begin
                                if FArrowBtns[3] = nil then
                                    CASE FEllipsisButton OF
                                        ebNormal: begin
                                                for j := 3 to 4 do
                                                begin
                                                    {$IFDEF INNER_BUTTONS}
                                                    FArrowBtns[j] := TBitKnopka.Create(Self);
                                                    FArrowBtns[j].Parent := FCtlPanel;
                                                    {$ELSE}
                                                    FArrowBtns[j] := TBitKnopka.Create(FCtlPanel);
                                                    FArrowBtns[j].Parent := FCtlPanel;
                                                    {$ENDIF}
                                                    (FArrowBtns[j] as TBitKnopka).AssignGlyph
                                                        (GetPeriodButton(j));
                                                end;
                                                (FArrowBtns[3] as TBitKnopka).OnClick := ArrowBtn3Click;
                                                (FArrowBtns[4] as TBitKnopka).OnClick := ArrowBtn4Click;
                                            end;
                                        ebHidden,
                                            ebSpeed: begin
                                                for j := 3 to 4 do
                                                begin
                                                    FArrowBtns[j] := TSpeedKnopka.Create(FCtlPanel);
                                                    FArrowBtns[j].Parent := FCtlPanel;
                                                    (FArrowBtns[j] as TSpeedKnopka).AssignGlyph
                                                        (GetPeriodButton(j));
                                                    //FArrowBtns[ j ].Visible := FEllipsisButton <> ebHidden;
                                                end;
                                                (FArrowBtns[3] as TSpeedKnopka).OnClick := ArrowBtn3Click;
                                                (FArrowBtns[4] as TSpeedKnopka).OnClick := ArrowBtn4Click;
                                            end;
                                    END;
                                //FArrowBtns[ 3 ].Parent := Self;
                                //FArrowBtns[ 4 ].Parent := Self;
                                FArrowBtns[3].Width := 17;
                                FArrowBtns[3].Height := FControl.Height;
                                FArrowBtns[4].Width := 17;
                                FArrowBtns[4].Height := FControl.Height;
                            end;
                            for j := 1 to 4 do
                                if FArrowBtns[j] is TKnopka then
                                begin
                                    (FArrowBtns[j] as TKnopka).RepeatPress := TRUE;
                                    (FArrowBtns[j] as TKnopka).RepeatDelay := 50;
                                end
                                else
                                    if FArrowBtns[j] is TGrKnopka then
                                    begin
                                        (FArrowBtns[j] as TGrKnopka).RepeatPress := TRUE;
                                        (FArrowBtns[j] as TGrKnopka).RepeatDelay := 50;
                                    end;
                        end;
                    end;
                ekCombo:
                    begin
                        FCtlPanel := TCtlPanel.Create(Self);
                        FCtlPanel.Parent := Self;
                        FCtlPanel.BevelOuter := bvNone;
                        FCtlPanel.FullRepaint := FALSE;
                        {$IFDEF INNER_BUTTONS}
                        FCtlPanel.Visible := FALSE;
                        FControl := TEditCombo.Create(Self);
                        FControl.Parent := Self;
                        {$ELSE}
                        FControl := TEditCombo.Create(FCtlPanel);
                        FControl.Parent := FCtlPanel;
                        {$ENDIF}
                        (FControl as TEditCombo).OnChange := ComboChanged;
                        (FControl as TEditCombo).OnKeyDown := ComboKeyDown;
                        (FControl as TEditCombo).OnKeyPress := ComboKeyPress;
                        (FControl as TEditCombo).OnKeyUp := ComboKeyUp;
                        (FControl as TEditCombo).Style := FComboStyle;
                        if fColor2Set <> clNone then
                            (FControl as TEditCombo).Color := fColor2Set;
                    end;
                ekCheck:
                    begin
                        FCtlPanel := TCtlPanel.Create(Self);
                        FCtlPanel.Parent := Self;
                        FCtlPanel.BevelWidth := 2;
                        FCtlPanel.BevelOuter := bvNone;
                        FCtlPanel.FullRepaint := FALSE;
                        FControl := TEditCheck.Create(Self);
                        FControl.Parent := FCtlPanel;
                        (FControl as TEditcheck).OnClick := CheckClick;
                        if fColor2Set <> clNone then
                            (FControl as TEditCheck).Color := fColor2Set;
                    end;
            else
                begin
                    Result := nil;
                    Exit;
                end;
            end;

            if MaxLength > 0 then
            begin
                if FControl is TEdit then
                    (FControl as TEdit).MaxLength := MaxLength
                else
                    if FControl is TCombobox then
                        (FControl as TCombobox).MaxLength := MaxLength;
            end;

            FCtlPanel.FullRepaint := FALSE;
            if FCtlPanel.Visible then
            begin
                {$IFDEF INNER_BUTTONS}
                FControl.Left := FCtlPanel.BevelWidth + BorderLeft;
                FControl.Top := FCtlPanel.BevelWidth;
                {$ELSE}
                FControl.Left := BevelGap(FCtlPanel);
                FControl.Top := BevelGap(FCtlPanel);
                {$ENDIF}
            end
            else
            begin
                FControl.Left := FCtlPanel.Left;
                FControl.Top := FCtlPanel.Top;
            end;
            SetReadOnly4Ctl(FReadOnly);
            FControl.TabStop := TabStop;
        end;
        if (FEllipsisButton <> ebNone) and (Kind <> ekEditPeriod) then
            if FEllipBtn = nil then
            begin
                case FEllipsisButton of
                    ebNormal: FEllipBtn := TButton.Create(Self);
                    ebSpeed: FEllipBtn := TSpeedKnopka.Create(Self);
                    ebHidden: begin
                            FEllipBtn := TSpeedKnopka.Create(Self);
                            FEllipBtn.Visible := FALSE;
                        end;
                end;
                FEllipBtn.Width := 17;
                FEllipBtn.Height := 19;
                if Kind in [{$IFDEF INNER_BUTTONS}ekCombo, {$ENDIF}ekEditDate] then
                begin
                    {$IFDEF INNER_BUTTONS}
                    FEllipBtn.Parent := Self;
                    FEllipBtn.Top := FCtlPanel.Top + 1;
                    FEllipBtn.Left := FCtlPanel.Left + FCtlPanel.Width - FEllipBtn.Width;
                    {$ELSE}
                    FEllipBtn.Parent := FCtlPanel;
                    FEllipBtn.Top := FCtlPanel.Top + 1;
                    {$ENDIF}
                end
                else
                begin
                    FEllipBtn.Parent := FCtlPanel;
                    {$IFDEF INNER_BUTTONS}
                    FEllipBtn.Top := FCtlPanel.BevelWidth;
                    {$ELSE}
                    FEllipBtn.Top := BevelGap(FCtlPanel);
                    {$ENDIF}
                end;

                if FEllipBtn is TButton then
                begin
                    (FEllipBtn as TButton).Caption := '...';
                    (FEllipBtn as TButton).OnClick := EllipsisButtonClick;
                end
                else
                begin
                    (FEllipBtn as TSpeedKnopka).Caption := '...';
                    (FEllipBtn as TSpeedKnopka).OnClick := EllipsisButtonClick;
                end;
            end;
        if Assigned(FFont) and not FControlFontParent then
            ControlFont := FFont;
    FINALLY
        fGettingControl := FALSE;
    END;
    Result := FControl;
end;

function TUniEdit.GetInteger: Integer;
begin
    Result := Trunc(Value);
end;

function TUniEdit.GetPicAutosize: Boolean;
begin
    Result := FUniPic.Autosize;
end;

function TUniEdit.GetPicHeight: Integer;
begin
    Result := FUniPic.Height;
end;

function TUniEdit.GetPicImageIndex: Integer;
begin
    Result := FUniPic.ImageIndex;
end;

function TUniEdit.GetPicImgList: TImageList;
begin
    Result := FUniPic.ImageList;
end;

function TUniEdit.GetPicStretch: Boolean;
begin
    Result := FUniPic.Stretch;
end;

function TUniEdit.GetPicTransparent: Boolean;
begin
    Result := FUniPic.Transparent;
end;

function TUniEdit.GetPicture: TPicture;
begin
    Result := fUniPic.Picture;
end;

function TUniEdit.GetPicWidth: Integer;
begin
    Result := FUniPic.Width;
end;

function TUniEdit.GetText: String;
begin
    case FKind of
        ekEdit, ekEditNum, ekEditFloat, ekEditCurrency, ekEditPeriod:
            Result := (Control as TCustomEdit).Text;
        ekEditDate:
            Result := Date2Str((Control as TDatePicker).Date);
        ekCombo: Result := (Control as TEditCombo).Text;
        ekCheck: Result := (Control as TEditCheck).Caption;
    else Result := '';
    end;
    {$IFDEF DEBG}
    RptDebg('GetText: ' + Result);
    {$ENDIF}
end;

function TUniEdit.GetTitle: String;
begin
    Result := FTitle.Caption;
end;

function TUniEdit.GetValue: Double;
var S: String;
begin
    if Text = '' then Result := 0.0
    else
    begin
        Result := 0.0;
        case Kind of
            ekEdit, ekEditNum, ekEditFloat, ekCombo:
                begin
                    if IsFloat(Trim(Text)) then
                        Result := Str2Float(Trim(Text));
                end;
            ekEditCurrency:
                begin
                    S := Trim(Text);
                    //S1 := S;
                    if CurrencyCommaChar <> ' ' then
                    begin
                        if pos(CurrencyCommaChar, S) > 0 then
                            S[pos(CurrencyCommaChar, S)] := DecimalSeparator;
                    end;
                    StringReplace(S, '.', DecimalSeparator, [rfReplaceAll]);
                    StringReplace(S, ',', DecimalSeparator, [rfReplaceAll]);
                    if IsFloat(S) then
                        Result := Str2Float(S);
                    {ShowMessage( ' : ' + S1 + #13#10 +
                                 '  : ' + S + #13#13 +
                                 ': ' + Format( '%.2f', [ Result ] ) );}
                end;
            ekEditDate:
                begin
                    Result := (Control as TDatePicker).DateTime;
                end;
            ekEditPeriod:
                begin
                    Result := (Control as TEditPeriod).DateTime;
                end;
            ekCheck:
                if (FControl as TEditCheck).Checked then
                    Result := 1.0
                else
                    Result := 0.0;
        end;
    end;
end;

procedure TUniEdit.InstallDTCheck;
var W, H: Integer;
begin
    W := 0; H := 0;
    if FControl <> nil then
    begin
        W := FControl.Width;
        H := FControl.Height;
    end;
    FDTCheck := TDateCheck.Create(Self);
    FDTCheck.Parent := Self;
    if H <> 0 then
    begin
        FDTCheck.Height := H;
        FDTCheck.Width := H;
        FControl.Width := W - H - (BorderWidth + 1) div 2;
    end;
    //FDTCheck.OnClick := DateChanged;
end;

procedure TUniEdit.InstallHidePanel;
begin
    if FHidePanel <> nil then Exit;
    FHidePanel := TPanel.Create(Control);
    FHidePanel.parent := Control;
    FHidePanel.Align := alClient;
    FHidePanel.BevelOuter := bvNone;
end;

procedure TUniEdit.RemoveHidePanel;
begin
    if FHidePanel = nil then Exit;
    FHidePanel.Free;
    FHidePanel := nil;
end;

procedure TUniEdit.Set_Autosize(const Value: Boolean);
begin
    {$IFDEF DEBG}
    RptDebg('SetAutosize: ' + IntToStr(Integer(Value)));
    {$ENDIF}
    if FAutoSize = Value then Exit;
    FAutoSize := Value;
    Adjust;
end;

procedure TUniEdit.SetBorderWidth1(const Value: Integer);
begin
    {$IFDEF DEBG}
    RptDebg('SetBorderWidth1: ' + IntToStr(Value));
    {$ENDIF}
    inherited BorderWidth := Value;
    Adjust;
end;

procedure TUniEdit.SetChecked(const Value: Boolean);
begin
    {$IFDEF DEBG}
    RptDebg('SetChecked: ' + IntToStr(Integer(Value)) + ', OldValue: ' + IntToStr(Integer(Checked)));
    {$ENDIF}
    if Control = nil then Exit;
    FChecked := Value;
    if Kind = ekCheck then
        (FControl as TEditCheck).Checked := Value
    else
        if (Kind = ekEditDate) and DateTimeCheckbox then
        begin
            FDTCheck.Checked := Value;
            if Value then
            begin
                RemoveHidePanel;
                Control.Enabled := True;
            end
            else
            begin
                InstallHidePanel;
                Control.Enabled := False;
            end;
        end
        else
            ;
end;

procedure TUniEdit.SetComboItems(const Value: TComboItems);
begin
    {$IFDEF DEBG}
    RptDebg('SetComboItems: ' + Value.Text + #13#10);
    {$ENDIF}
    FComboItems.Assign(Value);
    if Kind = ekCheck then
        SetChecked(Checked);
end;

procedure TUniEdit.SetComboStyle(const Value: TComboBoxStyle);
begin
    {$IFDEF DEBG}
    RptDebg('SetComboStyle: ' + IntToStr(Ord(Value)));
    {$ENDIF}
    if FComboStyle = Value then Exit;
    FComboStyle := Value;
    if Kind <> ekCombo then Exit;
    (Control as TEditCombo).Style := FComboStyle;
end;

procedure TUniEdit.SetDateTimeCheckbox(const Value: Boolean);
var Chk: Boolean;
    CW: Integer;
    ASz: Boolean;
begin
    {$IFDEF DEBG}
    RptDebg('SetDateTimeCheckBox: ' + IntToStr(Integer(Value)) +
        ', OldValue: ' + IntToStr(Integer(DateTimeCheckBox)));
    {$ENDIF}
    if FDateTimeCheckbox = Value then Exit;
    FDateTimeCheckbox := Value;
    CW := Control.Width;
    ASz := AutoSize;
    if Kind = ekEditDate then
    begin
        if Value then
        begin
            if FDTCheck = nil then
            begin
                Inc(FDisableAdjust);
                FAutoSize := False;
                InstallDTCheck;
                Control.TabOrder := FDTCheck.TabOrder + 1;
                Dec(FDisableAdjust);
                FAutoSize := ASz;
            end;
            Chk := Checked;
            FDTCheck.Checked := not Chk;
            FDTCheck.Checked := Chk;
        end
        else
        begin
            if FDTCheck <> nil then
            begin
                Inc(FDisableAdjust);
                FAutoSize := False;
                CW := CW + FDTCheck.Width + (BorderWidth + 1) div 2;
                FDTCheck.Free;
                FDTCheck := nil;
                Control.Width := CW;
                Dec(FDisableAdjust);
                FAutoSize := ASz;
            end;
        end;
    end;
    Adjust;
end;

procedure TUniEdit.SetFitAligned(const Value: Boolean);
begin
    {$IFDEF DEBG}
    RptDebg('SetFitAligned: ' + IntToStr(Integer(Value)));
    {$ENDIF}
    if FFitAligned = Value then exit;
    FFitAligned := Value;
    Adjust;
end;

procedure TUniEdit.SetInteger(const Val: Integer);
begin
    {$IFDEF DEBG}
    RptDebg('SetInteger: ' + IntToStr(Val));
    {$ENDIF}
    Value := Val;
end;

procedure TUniEdit.SetKind(const Value: TEditKind);
var Txt: String;
begin
    {$IFDEF DEBG}
    RptDebg('SetKind ' + IntToStr(Ord(Value)));
    {$ENDIF}
    if FKind = Value then Exit;
    //Inc( FDisableAdjust );
    FDisableAdjust := 1;
    if FDTCheck <> nil then
    begin
        FDTCheck.Free;
        FDTCheck := nil;
    end;
    Txt := '';
    if FControl <> nil then
    begin
        FreeAndNil(FEllipBtn);
        FreeAndNil(FArrowBtns[1]);
        FreeAndNil(FArrowBtns[2]);
        FreeAndNil(FArrowBtns[3]);
        FreeAndNil(FArrowBtns[4]);
        Txt := Text;
        FControl.Free;
        FControl := nil;
    end;
    FreeAndNil(FCtlPanel);
    if Value = ekEditCurrency then
    begin
        if CurrencyCommaChar <> ' ' then
            if pos(DecimalSeparator, Txt) > 0 then
                Txt[pos(DecimalSeparator, Txt)] := CurrencyCommaChar;
    end;
    FKind := Value;
    {$IFDEF INNER_BUTTONS}
    {$ELSE}
    Adjust;
    {$ENDIF}
    Text := Txt;
    //Dec( FDisableAdjust );
    FDisableAdjust := 0;
    if (Value = ekEditPeriod) and (FEllipsisButton = ebNone) then
        FEllipsisButton := ebSpeed;
    Control;
    if FKind = ekCombo then
    begin
        (Control as TEditCombo).Style := FComboStyle;
        if FDroppedWidth <> 0 then
            (Control as TEditCombo).Perform(CB_SETDROPPEDWIDTH, FDroppedWidth, 0);
    end;
    Adjust;
end;

procedure TUniEdit.SetLayout(const Value: TLabelPosition);
begin
    {$IFDEF DEBG}
    RptDebg('SetLayOut: ' + IntToStr(Integer(Value)));
    {$ENDIF}
    if FLayout = Value then Exit;
    FLayout := Value;
    Adjust;
end;

procedure TUniEdit.SetMaxValue(const Value: Double);
begin
    {$IFDEF DEBG}
    RptDebg('SetMaxValue: ' + FloatToStr(Value));
    {$ENDIF}
    FMaxValue := Value;
end;

procedure TUniEdit.SetMinValue(const Value: Double);
begin
    {$IFDEF DEBG}
    RptDebg('SetMinValue: ' + FloatToStr(Value));
    {$ENDIF}
    FMinValue := Value;
end;

procedure TUniEdit.SetName(const Value: TComponentName);
begin
    {$IFDEF DEBG}
    RptDebg('SetName: ' + Value);
    {$ENDIF}
    inherited;
    if not (csLoading in ComponentState) then
    begin
        if Title = Name then
            Title := Value;
    end;
    inherited Caption := '';
end;

procedure TUniEdit.SetOnOutbound(const Value: TOnOutbound);
begin
    FOnOutbound := Value;
end;

procedure TUniEdit.SetPicAutoFit(const Value: Boolean);
begin
    {$IFDEF DEBG}
    RptDebg('SetPicAutoFit: ' + IntToStr(Integer(Value)));
    {$ENDIF}
    if Value then
        if Height <> FUniPic.Height then
            FUniPic.Height := Height - BorderWidth * 2;
    if FPicAutoFit <> Value then
        if not Value then
            FUniPic.Stretch := False
        else
            FUniPic.Stretch := True;
    FPicAutoFit := Value;
    Adjust;
end;

procedure TUniEdit.SetPicAutosize(const Value: Boolean);
begin
    {$IFDEF DEBG}
    RptDebg('SetPicAutosize: ' + IntToStr(Integer(Value)));
    {$ENDIF}
    FUniPic.Autosize := Value;
    Adjust;
end;

procedure TUniEdit.SetPicHeight(const Value: Integer);
begin
    {$IFDEF DEBG}
    RptDebg('SetPicHeight: ' + IntToStr(Value));
    {$ENDIF}
    FUniPic.Height := Value;
    Adjust;
end;

procedure TUniEdit.SetPicImageIndex(const Value: Integer);
begin
    {$IFDEF DEBG}
    RptDebg('SetPicImageIndex: ' + IntToStr(Value));
    {$ENDIF}
    FUniPic.ImageIndex := Value;
    FUniPic.Visible := TRUE;
    Adjust;
end;

procedure TUniEdit.SetPicImgList(const Value: TImageList);
begin
    {$IFDEF DEBG}
    RptDebg('SetPicImgList: ' + Value.Name);
    {$ENDIF}
    FUniPic.ImageList := Value;
    Adjust;
    //Invalidate;
end;

procedure TUniEdit.SetPicStretch(const Value: Boolean);
begin
    {$IFDEF DEBG}
    RptDebg('SetPicStretch: ' + IntToStr(Integer(Value)));
    {$ENDIF}
    FUniPic.Stretch := Value;
    Adjust;
    //Invalidate;
end;

procedure TUniEdit.SetPicTransparent(const Value: Boolean);
begin
    {$IFDEF DEBG}
    RptDebg('SetPicTransparent: ' + IntToStr(Integer(Value)));
    {$ENDIF}
    FUniPic.Transparent := Value;
    Adjust;
    Invalidate;
end;

procedure TUniEdit.SetPicture(const Value: TPicture);
begin
    {$IFDEF DEBG}
    RptDebg('SetPicture: ' + IntTosTr(Value.Width) + 'x' + IntToStr(Value.Height));
    {$ENDIF}
    fUniPic.Picture.Assign(Value);
    if PicAutoSize then
    begin
        fUniPic.Width := fUniPic.Picture.Width;
        fUniPic.Height := fUniPic.Picture.Height;
    end;
    Adjust;
    //Invalidate;
end;

procedure TUniEdit.SetPicWidth(const Value: Integer);
begin
    {$IFDEF DEBG}
    RptDebg('SetPicWidth: ' + IntToStr(Value));
    {$ENDIF}
    FUniPic.Width := Value;
    Adjust;
end;

procedure TUniEdit.SetText(const Value: String);
var S: String;
begin
    {$IFDEF DEBG}
    RptDebg('SetText: ' + Value);
    {$ENDIF}
    case FKind of
        ekEdit, ekEditNum, ekEditFloat, ekEditCurrency:
            begin
                S := Value;
                if CurrencyCommaChar <> ' ' then
                    S := StringReplace(Value, DecimalSeparator, CurrencyCommaChar, []);
                (Control as TCustomEdit).Text := S;
            end;
        ekEditDate: ;
        ekEditPeriod:
            begin
                Adjust;
                {if Assigned( OnChange ) then
                  OnChange( Self );}
                Exit;
            end;
        ekCombo: (Control as TEditCombo).Text := Value;
        ekCheck: (Control as TEditCheck).Caption := Value;
    end;
    Adjust;
end;

procedure TUniEdit.SetTitle(const Value: String);
begin
    {$IFDEF DEBG}
    RptDebg('SetTitle: ' + Value);
    {$ENDIF}

    FTitle.Caption := Value;
    Adjust;
end;

procedure TUniEdit.SetTitleAlign(const Value: TAlignment);
begin
    {$IFDEF DEBG}
    RptDebg('SetTitleAlign: ' + IntToStr(Ord(Value)));
    {$ENDIF}
    if FTitleAlign = Value then Exit;
    FTitleAlign := Value;
    FTitle.Alignment := Value;
    Adjust;
end;

procedure TUniEdit.SetTitleWidth(const Value: Integer);
begin
    {$IFDEF DEBG}
    RptDebg('SetTitleWidth: ' + IntToStr(Value));
    {$ENDIF}
    if FTitleWidth = Value then Exit;
    FTitleWidth := Value;
    Adjust;
end;

procedure TUniEdit.SetValue(const Value: Double);
var S: String;
begin
    {$IFDEF DEBG}
    RptDebg('SetValue: ' + FloatToStr(Value));
    {$ENDIF}
    S := Text;
    if Kind in [ekEdit, ekEditNum, ekEditFloat, ekEditCurrency,
        ekCombo] then
    begin
        if Kind = ekEditNum then
            S := IntToStr(Trunc(Value))
        else
            S := Float2Str(Value);
        if Kind = ekEditCurrency then
        begin
            S := Format('%.2f', [Value]);
            if CurrencyCommaChar <> ' ' then
                if pos(DecimalSeparator, S) > 0 then
                    S[pos(DecimalSeparator, S)] := CurrencyCommaChar;
        end;
        Text := S;
    end
    else
        if Kind = ekEditDate then
        begin
            if Control <> nil then
                (Control as TDateTimePicker).DateTime := Value;
            if Value < 1 then
            begin
                (Control as TDatePicker).Hide_Text;
            end
            else
                (Control as TDatePicker).Show_Text;
        end
        else
            if Kind = ekEditPeriod then
            begin
                if Control <> nil then
                    (Control as TEditPeriod).DateTime := Value;
                if Value <= 0 then
                    (Control as TEditPeriod).Font.Color := clWindow
                else
                    (Control as TEditPeriod).Font.Color := clWindowText;
            end;
end;

procedure TUniEdit.WMSize(var Mesg: TWMSize);
begin
    {$IFDEF DEBG}
    RptDebg('WMSize: ' + IntToStr(Width) + ', ' + IntToStr(Height));
    {$ENDIF}

    inherited;
    TRY
        Control;
        if fAutoAdjust then
        begin
            fAutoAdjust := False;
            Adjust;
            fAutoAdjust := True;
        end;
        Control;
        FCtlPanel.Invalidate;
        if FControl <> nil then
            FControl.Invalidate;
    EXCEPT
    END;
    Invalidate;
    {if FControl <> nil then
      PostMessage( Handle, CM_INVALIDATE, 0, 0 );
    }
end;

procedure TUniEdit.WMSetFocus(var M: TWMsetFocus);
var F: TCustomForm;
begin
    {$IFDEF DEBG}
    RptDebg('WMSetFocus');
    {$ENDIF}
    M.Result := 0;
    if (FDTCheck <> nil) then
    begin
        if FDTCheck.FPreventFocus then
        begin
            //inherited;
            //M.Result := 1;
            F := GetParentForm(Self);
            if F <> nil then
                PostMessage(F.Handle, WM_NEXTDLGCTL, 1, 0);
        end
        else
            Windows.SetFocus(FDTCheck.Handle);
    end
    else
    begin
        if (FControl is TEditAny) and ((FControl as TEditAny).FPreventFocus)
            or (FControl is TDatePicker) and ((FControl as TDatePicker).FPreventFocus)
            or (FControl is TEditCombo) and (((FControl as TEditCombo).FPreventFocus)
            or (GetKeyState(VK_SHIFT) < 0) and (GetKeyState(VK_TAB) < 0)) then
        begin
            F := GetParentform(Self);
            if F <> nil then
                PostMessage(F.Handle, WM_NEXTDLGCTL, 1, 0);
        end
        else
            if TabStop and (Control <> nil) and (Control.TabStop) then
                PostMessage(Handle, WM_USER_SETFOCUS, 0, 0);
        //Windows.SetFocus( FControl.Handle );
    end;
end;

function TUniEdit.GetDateTime: TDateTime;
begin
    Result := Value;
end;

procedure TUniEdit.SetDateTime(const Val: TDateTime);
var WasOnChange: TNotifyEvent;
begin
    {$IFDEF DEBG}
    RptDebg('SetDateTime: ' + DateToStr(Value));
    {$ENDIF}
    WasOnChange := OnChange;
    TRY
        //OnChange := nil;
        Value := Val;
    FINALLY
        OnChange := WasOnChange;
    END;

    CASE Kind OF
        ekEditDate:
            if Control <> nil then
            begin
                (Control as TDateTimePicker).DateTime := Value;
                if Value < 1 then
                    (Control as TDatePicker).Hide_Text
                else
                    (Control as TDatePicker).Show_Text;
            end;
        ekEditPeriod:
            if Control <> nil then
            begin
                (Control as TEditPeriod).DateTime := Value;
                if Value <= 0 then
                    (Control as TEditPeriod).Font.Color := clWindow
                else
                    (Control as TEditPeriod).Font.Color := clWindowText;
            end;
    else if not (csLoading in ComponentState) then
        raise Exception.Create('Attempt to set a value of TDateTime type to ' +
            'a control of another data type which is not compatible with date and ' +
            'time.');
    END;

end;

procedure TUniEdit.DateKeyDown(Sender: TObject; var Key: Word;
    State: TShiftState);
begin
    if Assigned(OnKeyDown) then
        OnKeydown(Self, Key, State);
end;

procedure TUniEdit.DateKeyPress(Sender: TObject; var Key: Char);
begin
    if Assigned(OnKeyPress) then
        OnKeyPress(Self, Key);
end;

procedure TUniEdit.DateKeyUp(Sender: TObject; var Key: Word;
    State: TShiftState);
begin
    if Assigned(OnKeyUp) then
        OnKeyUp(Self, Key, State);
end;

procedure TUniEdit.SetDateFormat(const Value: TDTDateFormat);
begin
    {$IFDEF DEBG}
    RptDebg('SetDateFormat: ' + IntToStr(Ord(Value)));
    {$ENDIF}
    if FDateFormat = Value then Exit;
    FDateFormat := Value;
    if Kind = ekEditDate then
    begin
        (Control as TDatePicker).DateFormat := FDateFormat;
    end;
end;

procedure TUniEdit.SetPicCenterVertical(const Value: Boolean);
begin
    {$IFDEF DEBG}
    RptDebg('SetPicCenterVertical: ' + IntToStr(Integer(Value)));
    {$ENDIF}
    if FPicCenterVertical = Value then Exit;
    FPicCenterVertical := Value;
    Adjust;
end;

procedure TUniEdit.Loaded;
begin
    inherited;
    {$IFDEF DEBG}
    RptDebg('Loaded');
    {$ENDIF}
    fLoaded := True;
    fForceAdjust := True;
    Adjust;
    fForceAdjust := False;
end;

function TUniEdit.TitleHeight: Integer;
begin
    {$IFDEF DEBG}
    RptDebg('TitleHeight?');
    {$ENDIF}
    Result := FTitle.Height;
    if Result = 0 then
        Result := FTitle.Canvas.TextHeight('Ap_^');
end;

function TUniEdit.Get_SelLength: Integer;
begin
    Result := 0;
    if FControl is TEditAny then
        Result := (FControl as TEditAny).SelLength
    else
        if FControl is TEditCombo then
            Result := (FControl as TEditCombo).SelLength;
end;

function TUniEdit.Get_SelStart: Integer;
begin
    Result := 0;
    if FControl is TEditAny then
        Result := (FControl as TEditAny).SelStart
    else
        if FControl is TEditCombo then
            Result := (FControl as TEditCombo).SelStart;
end;

procedure TUniEdit.Set_SelLength(const Value: Integer);
begin
    if FControl is TEditAny then
        (FControl as TEditAny).SelLength := Value
    else
        if FControl is TEditCombo then
            (FControl as TEditCombo).SelLength := Value;
end;

procedure TUniEdit.Set_SelStart(const Value: Integer);
begin
    if FControl is TEditAny then
        (FControl as TEditAny).SelStart := Value
    else
        if FControl is TEditCombo then
            (Fcontrol as TEditCombo).SelStart := Value;
end;

procedure TUniEdit.ComboKeyDown(Sender: TObject; var Key: Word;
    State: TShiftState);
begin
    if Assigned(OnKeyDown) then
        OnKeyDown(Self, Key, State);
end;

procedure TUniEdit.ComboKeyPress(Sender: TObject; var Key: Char);
begin
    if Assigned(OnKeyPress) then
        OnKeyPress(Self, Key);
end;

procedure TUniEdit.ComboKeyUp(Sender: TObject; var Key: Word;
    State: TShiftState);
begin
    if Assigned(OnKeyUp) then
        OnKeyUp(Self, Key, State);
end;

function TUniEdit.GetDroppedDown: Boolean;
begin
    Result := False;
    if Kind = ekCombo then
        Result := (Control as TEditCombo).DroppedDown
    else
        if Kind = ekEditDate then
            Result := (Control as TDatePicker).DroppedDown;
end;

procedure TUniEdit.SetDroppedDown(const Value: Boolean);
begin
    if Kind = ekCombo then
        (Control as TEditCombo).DroppedDown := Value;
    {
    else
    if Kind = ekEditDate then
    begin
      (Control as TDatePicker).DroppedDown := Value;
      if Value then
        (Control as TDatePicker).D
    end;
    }
end;

function TUniEdit.GetItemIndex: Integer;
begin
    Result := -1;
    if Kind = ekCombo then
        Result := (Control as TComboBox).ItemIndex;
end;

procedure TUniEdit.SetItemIndex(const Value: Integer);
var real_chg: Boolean;
begin
    if Kind = ekCombo then
    begin
        real_chg := (Control as TComboBox).ItemIndex <> Value;
        (Control as TComboBox).ItemIndex := Value;
        if Assigned(OnChange) then
            OnChange(Self);
        if real_chg then
            Invalidate;
    end;
end;

procedure TUniEdit.SetDigits(const Val: Integer);
begin
    FDigits := Val;
end;

function TUniEdit.GetChecked: Boolean;
begin
    {$IFDEF DEBG}
    RptDebg('GetChecked');
    {$ENDIF}
    Result := FChecked;
    if Control = nil then Exit;
    if Kind = ekCheck then
        Result := (FControl as TEditCheck).Checked
    else
        if (Kind = ekEditDate) and DateTimeCheckbox then
        begin
            Result := FDTCheck.Checked;
        end;
end;

procedure TUniEdit.SetEllipsisButton(const Value: TEllipsisButton);
begin
    if (Value = ebNone) and (Kind = ekEditPeriod) then
        // nothing - ignore
    else FEllipsisButton := Value;
    Adjust;
end;

procedure TUniEdit.EllipsisButtonClick(Sender: TObject);
var WasFocused: Boolean;
begin
    WasFocused := Control.Focused;
    if Assigned(OnEllipsis) then
        OnEllipsis(Self);
    SelStart := 0;
    SelLength := Length(Text);
    if WasFocused and Control.Enabled and Control.Visible
        and (GetParentForm(Self).Visible)
        and (GetParentForm(Self).Enabled) then
        Control.SetFocus;
end;

procedure TUniEdit.SetReadOnly(const Value: Boolean);
begin
    FReadOnly := Value;
    SetReadOnly4Ctl(Value);
end;

procedure TUniEdit.SetReadOnly4Ctl(Value: Boolean);
begin
    if FControl <> nil then
    begin
        if FControl is TEditAny then
            (FControl as TEditAny).ReadOnly := Value
        else if FControl is TCombobox then
        begin
            if Value then
                (FControl as TCombobox).Style := csDropDownList
                    {else
                  (Fcontrol as TCombobox).Style := csDropDown};
        end;
        if Value and GrayReadOnly then
            SetCtlColor(clBtnFace)
        else
            if GrayReadOnly then
                SetCtlColor(clWindow);
    end;
    Adjust;
end;

procedure TUniEdit.SetGrayReadOnly(const Value: Boolean);
begin
    FGrayReadOnly := Value;
    Adjust;
end;

procedure TUniEdit.SetCtlColor(Color: TColor);
begin
    case Kind of
        ekEdit, ekEditNum, ekEditFloat, ekEditCurrency, ekEditPeriod:
            (FControl as TEditAny).Color := Color;
        ekCombo: (FControl as TEditCombo).Color := Color;
        ekEditDate: (FControl as TDatePicker).Color := Color;
    end;
end;

procedure TUniEdit.FocusEllipsisButton;
begin
    if FEllipBtn <> nil then
    begin
        if FEllipBtn is TButton then
            (FEllipBtn as TButton).SetFocus;
    end
    else
        if (FArrowBtns[1] <> nil) then
        begin
            if FArrowBtns[1] is TButton then
                (FArrowBtns[1] as TButton).SetFocus;
        end;
end;

function TUniEdit.GetColor: TColor;
begin
    Result := clWindow;
    if FControl <> nil then
    begin
        case Kind of
            ekEdit, ekEditNum, ekEditFloat, ekEditCurrency, ekEditPeriod:
                Result := (FControl as TEdit).Color;
            ekEditDate:
                Result := (FControl as TDateTimePicker).Color;
            ekCombo:
                Result := (FControl as TComboBox).Color;
            ekcheck:
                Result := (FControl as TCheckBox).Color;
        else
            Result := inherited Color;
        end;
    end;
end;

procedure TUniEdit.SetColor(const Value: TColor);
begin
    fColor2Set := Value;
    if FControl <> nil then
    begin
        case Kind of
            ekEdit, ekEditNum, ekEditFloat, ekEditCurrency, ekEditPeriod:
                (FControl as TEdit).Color := Value;
            ekEditDate:
                (FControl as TDateTimePicker).Color := Value;
            ekCombo:
                (FControl as TComboBox).Color := Value;
            ekcheck:
                (FControl as TCheckBox).Color := Value;
        else
            inherited Color := Value;
        end;
    end;
end;

procedure TUniEdit.CMEnabledChanged(var Message: TMessage);
var i: Integer;
begin
    inherited;
    FControl.Enabled := Enabled;
    FTitle.Enabled := Enabled;
    if FDTCheck <> nil then
        FDTCheck.Enabled := Enabled;
    if FEllipBtn <> nil then
        FEllipBtn.Enabled := Enabled;
    for i := 1 to 4 do
        if FArrowBtns[i] <> nil then
            FArrowBtns[i].Enabled := Enabled;
    if Enabled then
        SetCtlColor(clWindow)
    else
        SetCtlColor(clBtnFace);
end;

procedure TUniEdit.SetOnCloseUp(const Value: TNotifyEvent);
begin
    FOnCloseUp := Value;
    Control;
    if Control is TEditCombo then
        (Control as TEditCombo).FOnCloseUp := CloseUpCombobox;
end;

procedure TUniEdit.SetOnDropDown(const Value: TNotifyEvent);
begin
    FOnDropDown := Value;
    Control;
    if Control is TCombobox then
        (Control as TCombobox).OnDropDown := DropDownCombobox;
end;

procedure TUniEdit.CloseUpCombobox(Sender: TObject);
begin
    if Assigned(OnCloseUp) then
        OnCloseUp(Self);
end;

procedure TUniEdit.DropDownCombobox(Sender: TObject);
begin
    if Assigned(OnDropDown) then
        OnDropDown(Self);
end;

procedure TUniEdit.SetListSource(const Value: TUniSource);
begin
    if ListSource <> nil then
        ListSource.RemoveUniEdit(Self);
    FListSource := Value;
    if Value <> nil then
        Value.AddUniEdit(Self);
    FListSourcePresent := Value <> nil;
end;

procedure TUniEdit.SetListField(const Value: String);
begin
    if ListSource <> nil then
        if not ListSource.FieldExists(Value) then
        begin
            FListField := '';
            Exit;
        end;
    FListField := Value;
end;

procedure TUniEdit.SetListSourcePresent(const Value: Boolean);
begin
    FListSourcePresent := Value;
end;

function TUniEdit.GetListSource: TUniSource;
begin
    Result := FListSource;
    if not ListSourcePresent then Result := nil;
end;

procedure TUniEdit.SetKindPeriod(const Value: TPeriodKind);
var j: Integer;
begin
    if FKindPeriod = Value then Exit;
    FKindPeriod := Value;
    if Kind = ekEditPeriod then
    begin
        for j := 1 to 4 do
            FreeAndNil(FArrowBtns[j]);
        FreeAndNil(FEllipBtn);
        FreeAndNil(FControl);
    end;
    if Control <> nil then
        if (Control is TEditPeriod) then
            (Control as TEditPeriod).DateTime := DateTime;
    Adjust;
end;

procedure TUniEdit.PeriodChanged(Sender: TObject);
var FldIdx: Integer;
begin
    if (Kind = ekEditPeriod) and not (Sender is TEditPeriod) then Exit;
    if Assigned(OnChange) then
        OnChange(Self);
    FldIdx := Period_Position2Field((Control as TEditAny).SelStart);
    (Control as TEditAny).SelStart := Period_FieldPosition(FldIdx);
    (Control as TEditAny).SelLength := Period_FieldLength(FldIdx);
end;

procedure TUniEdit.PeriodKeyDown(Sender: TObject; var Key: Word;
    State: TShiftState);
var FldIdx: Integer;
    Y, M, D: Word;
    C: Char;
begin
    if Assigned(OnKeyDown) then
        OnKeydown(Self, Key, State);
    CASE Key OF
        VK_LEFT: begin //       
                FldIdx := Period_Position2Field((Control as TEditAny).SelStart);
                DateTime := DateTime;
                if FldIdx = 0 then FldIdx := Period_FieldCount;
                Dec(FldIdx);
                (Control as TEditAny).SelStart := Period_FieldPosition(FldIdx);
                (Control as TEditAny).SelLength := Period_FieldLength(FldIdx);
                Key := 0;
            end;
        VK_RIGHT: begin //       
                FldIdx := Period_Position2Field((Control as TEditAny).SelStart);
                DateTime := DateTime;
                if FldIdx >= Period_FieldCount - 1 then FldIdx := 0
                else Inc(FldIdx);
                (Control as TEditAny).SelStart := Period_FieldPosition(FldIdx);
                (Control as TEditAny).SelLength := Period_FieldLength(FldIdx);
                Key := 0;
            end;
        VK_UP: begin //   ,      
                //(, , , , )
                if DateTime = 0 then DateTime := Now;
                DecodeDate(DateTime, Y, M, D);
                FldIdx := Period_Position2Field((Control as TEditAny).SelStart);
                CASE KindPeriod OF
                    pkDay: CASE FldIdx OF
                            0: DateTime := DateTime + 1;
                            1: DateTime := IncMonth(DateTime, 1);
                            2: DateTime := IncMonth(DateTime, 12);
                        END;
                    pkDecade:
                        CASE FldIdx OF
                            0: if D >= 21 then DateTime := DateTime + 12
                                else DateTime := DateTime + 12;
                            1: DateTime := IncMonth(DateTime, 1);
                            2: DateTime := IncMonth(DateTime, 12);
                        END;
                    pkMonth:
                        CASE FldIdx OF
                            0: DateTime := IncMonth(DateTime, 1);
                            1: DateTime := IncMonth(DateTime, 12);
                        END;
                    pkQuarter:
                        CASE FldIdx OF
                            0: DateTime := IncMonth(DateTime, 3);
                            1: DateTime := IncMonth(DateTime, 12);
                        END;
                    pkYear: DateTime := IncMonth(DateTime, 12);
                    pkQuarterYear:
                        CASE FldIdx OF
                            0: begin
                                    if (Month(DateTime) = 10) or (Month(DateTime) = 11) then
                                        DateTime := EncodeDate(Year(DateTime), 12, 1)
                                    else
                                        DateTime := IncMonth(DateTime, 3);
                                end;
                            1: begin
                                    DateTime := IncMonth(DateTime, 12);
                                end;
                        END;
                END;
                (Control as TEditAny).SelStart := Period_FieldPosition(FldIdx);
                (Control as TEditAny).SelLength := Period_FieldLength(FldIdx);
                Key := 0;
            end;
        VK_DOWN: begin //   ,      
                //  .
                if DateTime = 0 then DateTime := Now;
                DecodeDate(DateTime, Y, M, D);
                FldIdx := Period_Position2Field((Control as TEditAny).SelStart);
                CASE KindPeriod OF
                    pkDay: CASE FldIdx OF
                            0: DateTime := DateTime - 1;
                            1: DateTime := IncMonth(DateTime, -1);
                            2: DateTime := IncMonth(DateTime, -12);
                        END;
                    pkDecade:
                        CASE FldIdx OF
                            0: DateTime := DateTime - 10;
                            1: DateTime := IncMonth(DateTime, -1);
                            2: DateTime := IncMonth(DateTime, -12);
                        END;
                    pkMonth:
                        CASE FldIdx OF
                            0: DateTime := IncMonth(DateTime, -1);
                            1: DateTime := IncMonth(DateTime, -12);
                        END;
                    pkQuarter:
                        CASE FldIdx OF
                            0: DateTime := IncMonth(DateTime, -3);
                            1: DateTime := IncMonth(DateTime, -12);
                        END;
                    pkYear: DateTime := IncMonth(DateTime, -12);
                    pkQuarterYear:
                        CASE FldIdx OF
                            0: begin
                                    if (Month(DateTime) = 1) then
                                        DateTime := EncodeDate(Year(DateTime) - 1, 12, 1)
                                    else
                                        DateTime := IncMonth(DateTime, -3);
                                end;
                            1: begin
                                    DateTime := IncMonth(DateTime, -12);
                                end;
                        END;
                END;
                (Control as TEditAny).SelStart := Period_FieldPosition(FldIdx);
                (Control as TEditAny).SelLength := Period_FieldLength(FldIdx);
                Key := 0;
            end;
        VK_DELETE:
            begin
                C := #12;
                PeriodKeyPress(Sender, C);
                Key := 0;
            end;
    END;
end;

procedure TUniEdit.PeriodKeyPress(Sender: TObject; var Key: Char);
var FldIdx: Integer;
    S, S1: String;
    NewSelStart: Integer;
    NewText: String;
    Y, M, D: Word;
    IsFieldInteger: Boolean;
begin
    if Assigned(OnKeyPress) then
        OnKeyPress(Self, Key);
    CASE Key OF
        '0'..'9', #8, #12: ;
    else begin
            Beep;
            Key := #0;
            Exit;
        end;
    END;
    FldIdx := Period_Position2Field((Control as TEditAny).SelStart);
    if FldIdx >= Period_FieldCount then FldIdx := Period_FieldCount - 1;
    S := Text;
    S1 := Copy(Text, Period_FieldPosition(FldIdx) + 1, Period_FieldLength(FldIdx));
    DecodeDate(DateTime, Y, M, D);
    IsFieldInteger := IsInteger(S1) and (S1 <> '') or
        (S1 = '') and (Key in ['0'..'9']);
    if IsFieldInteger or (FldIdx = 0) or
        (FldIdx = 1) and (KindPeriod in [pkDay, pkDecade]) then
    begin
        CASE Key OF
            '0'..'9':
                begin S := Copy(S, 1, (Control as TEditAny).SelStart) + Key +
                    Copy(S, (Control as TEditAny).SelStart +
                        (Control as TEditAny).SelLength + 1,
                        MaxInt);
                    NewSelStart := (Control as TEditAny).SelStart + 1;
                end;
            #8:
                begin
                    if (Control as TEditAny).SelLength > 0 then
                        S := Copy(S, 1, (Control as TEditAny).SelStart) +
                            Copy(S, (Control as TEditAny).SelStart +
                            (Control as TEditAny).SelLength + 1,
                            MaxInt)
                    else
                        S := Copy(S, 1, (Control as TEditAny).SelStart - 1) +
                            Copy(S, (Control as TEditAny).SelStart + 1, MaxInt);
                    NewSelStart := (Control as TEditAny).SelStart - 1;
                end;
            #12:
                begin
                    if (Control as TEditAny).SelLength > 0 then
                        S := Copy(S, 1, (Control as TEditAny).SelStart) +
                            Copy(S, (Control as TEditAny).SelStart +
                            (Control as TEditAny).SelLength + 1,
                            MaxInt)
                    else
                        S := Copy(S, 1, (Control as TEditAny).SelStart) +
                            Copy(S, (Control as TEditAny).SelStart + 2, MaxInt);
                    NewSelStart := (Control as TEditAny).SelStart;
                end;
        else Exit;
        END;
        NewText := S;
        S1 := Copy(S, Period_FieldPosition(FldIdx, S) + 1,
            Period_FieldLength(FldIdx, S));
        if Period_IsFieldValid(FldIdx, S) > 0 then
        begin
            CASE KindPeriod OF
                pkDay: CASE FldIdx OF
                        0: D := StrToInt(S1);
                        1: M := StrToInt(S1);
                        2: Y := CalcYear(StrToInt(S1));
                    END;
                pkDecade:
                    CASE FldIdx OF
                        0: D := (StrToInt(S1) - 1) * 10 + 1;
                        1: M := StrToInt(S1);
                        2: Y := CalcYear(StrToInt(S1));
                    END;
                pkMonth:
                    CASE FldIdx OF
                        0: M := StrToInt(S1);
                        1: Y := CalcYear(StrToInt(S1));
                    END;
                pkQuarterYear,
                    pkQuarter:
                    CASE FldIdx OF
                        0: M := (StrToInt(S1) - 1) * 3 + 1;
                        1: Y := CalcYear(StrToInt(S1));
                    END;
                pkYear: Y := CalcYear(StrToInt(S1));
            END;
            //DateTime := EncodeDate( Y, M, D );
            (Control as TEditPeriod).FDateTime := EncodeDate(Y, M, D);
            (Control as TEditAny).Text := NewText;
            S := NewText;
            S := Copy(S, Period_FieldPosition(FldIdx, S) + 1, Period_FieldLength(FldIdx, S));
            if IsInteger(S) then
                (Control as TEditAny).SelStart := NewSelStart
            else
            begin
                (Control as TEditAny).SelStart := Period_FieldPosition(FldIdx);
                (Control as TEditAny).SelLength := Period_FieldLength(FldIdx);
            end;
        end
        else Beep;
        Key := #0;
    end;
end;

procedure TUniEdit.PeriodKeyUp(Sender: TObject; var Key: Word;
    State: TShiftState);
begin
    if Assigned(OnKeyUp) then
        OnKeyUp(Self, Key, State);
end;

procedure TUniEdit.ArrowBtn1Click(Sender: TObject);
var DT: TDateTime;
begin
    DT := DateTime; ;
    if DT < 1 then DT := Now;
    if KindPeriod in [pkYear, pkMonth, pkQuarter, pkQuarterYear] then
        DateTime := IncMonth(DT, -12)
    else
        DateTime := IncMonth(DT, -1);
end;

procedure TUniEdit.ArrowBtn2Click(Sender: TObject);
var DT: TDateTime;
begin
    DT := DateTime;
    if DT = 0 then DT := Now;
    if KindPeriod in [pkYear, pkMonth, pkQuarter, pkQuarterYear] then
        DateTime := IncMonth(DT, 12)
    else
        DateTime := IncMonth(DT, 1);
end;

procedure TUniEdit.ArrowBtn3Click(Sender: TObject);
var Delta: Integer;
    D: TDateTime;
begin
    D := DateTime; ;
    if D = 0 then D := Now;
    CASE KindPeriod OF
        pkQuarterYear: begin
                if Month(D) = 12 then Delta := 2 else
                    if Month(D) = 1 then Delta := 1
                    else Delta := 3;
            end;
        pkYear: Delta := 12;
        pkMonth: Delta := 1;
        pkQuarter: Delta := 3;
        pkDecade: begin
                DateTime := D - 10;
                Exit;
            end;
        pkDay: begin
                DateTime := D - 1;
                Exit;
            end;
    else Exit;
    END;
    DateTime := IncMonth(D, -Delta);
end;

procedure TUniEdit.ArrowBtn4Click(Sender: TObject);
var Delta: Integer;
    Y, M, D: Word;
    DT: TDateTime;
begin
    DT := DateTime;
    if DT = 0 then DT := Now;
    DecodeDate(DT, Y, M, D);
    CASE KindPeriod OF
        pkQuarterYear: begin
                if M = 10 then Delta := 2 else
                    if M = 11 then Delta := 1 else
                        if (M - 1) mod 3 = 0 then Delta := 3
                        else Delta := 3 - (M - 1) mod 3;
            end;
        pkYear: Delta := 12;
        pkMonth: Delta := 1;
        pkQuarter: Delta := 3;
        pkDecade: begin
                if DT >= 21 then Delta := 12 else Delta := 10;
                DateTime := DateTime + Delta;
                Exit;
            end;
        pkDay: begin
                DateTime := DateTime + 1;
                Exit;
            end;
    else Exit;
    END;
    DateTime := IncMonth(DT, Delta);
end;

function TUniEdit.Period_FieldCount: Integer;
begin
    CASE KindPeriod OF
        pkDay, pkDecade: Result := 3;
        pkMonth, pkQuarter, pkQuarterYear: Result := 2;
        pkYear: Result := 1;
    else Result := 0;
    END;
end;

function TUniEdit.Period_FieldLength(FieldIdx: Integer; S: String = '@'): Integer;
var I: Integer;
begin
    if S = '@' then S := Text;
    Result := 0;
    I := Period_FieldPosition(FieldIdx) + 1;
    while (I <= Length(S)) and not (S[I] in ['.', '/', ' ']) do
    begin
        Inc(Result); Inc(I);
    end;
end;

function TUniEdit.Period_FieldPosition(FieldIdx: Integer; S: String): Integer;
var I, N: Integer;
begin
    if S = '@' then S := Text;
    I := 1;
    N := 0;
    while (FieldIdx > 0) and (I <= Length(S)) do
    begin
        if S[I] in ['.', '/', ' '] then
        begin
            Inc(N);
            if not ((KindPeriod in [pkQuarter, pkDecade, pkQuarterYear]) and
                (N = 1) and (S[I] = ' ')) then
            begin
                Dec(FieldIdx);
                {while (I <= Length( S )) and (S[ I ] in [ '.', '/', ' ' ]) do Inc( I );
                Dec( I );}
            end;
        end;
        Inc(I);
    end;
    Result := I - 1;
end;

function TUniEdit.Period_Position2Field(CharPos: Integer): Integer;
var I: Integer;
begin
    Result := 0;
    for I := 0 to Period_FieldCount - 1 do
    begin
        if CharPos <= Period_FieldPosition(I) + Period_FieldLength(I) then
            Exit;
        Inc(Result);
    end;
end;

procedure TUniEdit.PeriodClick(Sender: TObject);
var FldIdx: Integer;
begin
    FldIdx := Period_Position2Field((Control as TEditAny).SelStart);
    if FldIdx >= Period_FieldCount then
        FldIdx := Period_FieldCount - 1;
    (Control as TEditAny).SelStart := Period_FieldPosition(FldIdx);
    (Control as TEditAny).SelLength := Period_FieldLength(FldIdx);
end;

function TUniEdit.Period_IsFieldValid(FieldIdx: Integer;
    S: String): Integer;
var Y, M, D: Word;
begin
    Result := 0;
    if S = '@' then S := Text;
    S := Copy(S, Period_FieldPosition(FieldIdx, S) + 1, Period_FieldLength(FieldIdx, S));
    if (Trim(S) <> '') and (IsInteger(S) or
        (KindPeriod in [pkQuarter, pkQuarterYear]) and IsRome(S)) or
        (KindPeriod in [pkQuarterYear]) and (Trim(S) = '') then
    begin
        DecodeDate(DateTime, Y, M, D);
        if IsInteger(S) then
            Result := StrToInt(S)
        else
            if IsRome(S) then
                Result := Rome2Int(S)
            else
                Result := 12;
        CASE KindPeriod OF
            pkDay: CASE FieldIdx OF
                    0: TRY EncodeDate(Y, M, Result);
                        except Result := 0;
                        end;
                    1: TRY EncodeDate(Y, Result, D);
                        except Result := 0;
                        end;
                    2: TRY EncodeDate(Result, M, D);
                        except Result := 0;
                        end;
                END;
            pkDecade: CASE FieldIdx OF
                    0: if (Result < 1) or (Result > 3) then Result := 0;
                    1: TRY EncodeDate(Y, Result, D);
                        except Result := 0;
                        end;
                    2: TRY EncodeDate(Result, M, D);
                        except Result := 0;
                        end;
                END;
            pkMonth: CASE FieldIdx OF
                    0: TRY EncodeDate(Y, Result, 1);
                        except Result := 0;
                        end;
                    1: TRY EncodeDate(Result, M, 1);
                        except Result := 0;
                        end;
                END;
            pkQuarter, pkQuarterYear:
                CASE FieldIdx OF
                    0: TRY EncodeDate(Y, (Result - 1) * 3 + 1, 1);
                        except Result := 0;
                        end;
                    1: TRY EncodeDate(Result, M, 1);
                        except Result := 0;
                        end;
                END;
            pkYear: TRY EncodeDate(Result, 1, 1);
                except Result := 0;
                end;
        END;
    end;
end;

procedure TUniEdit.PeriodExit(Sender: TObject);
begin
    if DateTime <> 0 then
        DateTime := DateTime;
end;

procedure TUniEdit.SetCurrencyCommaChar(const Value: Char);
begin
    FCurrencyCommaChar := Value;
    if Value = #0 then
        FCurrencyCommaChar := ' ';
end;

procedure TUniEdit.SetMaxLength(const Value: Integer);
begin
    FMaxLength := Value;
    if FControl <> nil then
    begin
        if FControl is TEdit then
            (FControl as TEdit).MaxLength := MaxLength
        else
            if FControl is TCombobox then
                (FControl as TCombobox).MaxLength := MaxLength;
    end;
end;

procedure TUniEdit.SetExitOnMaxLenExceed(const Value: Boolean);
begin
    FExitOnMaxLenExceed := Value;
end;

procedure TUniEdit.Invalidate;
var i: Integer;
begin
    inherited Invalidate;
    if FCtlPanel <> nil then
        FCtlPanel.Invalidate;
    if FControl <> nil then
        FControl.Invalidate;
    if FEllipBtn <> nil then
        FEllipBtn.Invalidate;
    if FTitle <> nil then
        FTitle.Invalidate;
    if FUniPic <> nil then
        FUniPic.Invalidate;
    for i := 1 to 4 do
        if FArrowBtns[i] <> nil then
            FArrowBtns[i].Invalidate;
end;

function TUniEdit.GetFontColor: TColor;
begin
    Result := clWindowText;
    CASE Kind OF
        ekEdit, ekEditNum, ekEditfloat, ekEditCurrency, ekEditPeriod:
            Result := (Control as TEdit).Font.Color;
        ekEditDate:
            Result := (Control as TDateTimePicker).Font.Color;
        ekCombo:
            Result := (Control as TCombobox).Font.Color;
        ekCheck:
            Result := (Control as TCheckBox).Font.Color;
    END;
end;

procedure TUniEdit.SetFontColor(const Value: TColor);
begin
    if Control = nil then Exit;
    CASE Kind OF
        ekEdit, ekEditNum, ekEditfloat, ekEditCurrency, ekEditPeriod:
            (Control as TEdit).Font.Color := Value;
        ekEditDate:
            (Control as TDateTimePicker).Font.Color := Value;
        ekCombo:
            (Control as TCombobox).Font.Color := Value;
        ekCheck:
            (Control as TCheckBox).Font.Color := Value;
    END;
end;

procedure TUniEdit.SetOldComboWidthAdjust(const Value: Boolean);
begin
    FOldComboWidthAdjust := Value;
end;

procedure TUniEdit.SetDroppedWidth(const Value: Integer);
begin
    if FDroppedWidth = Value then Exit;
    FDroppedWidth := Value;
    if Kind = ekCombo then
        (Control as TCombobox).Perform(CB_SETDROPPEDWIDTH, Value, 0);
end;

function TUniEdit.GetOnDefaultDate: TOnDefaultDate;
begin
    if Kind = ekEditDate then
        Result := (Control as TDatePicker).OnDefaultDate
    else
        Result := nil;
end;

procedure TUniEdit.SetOnDefaultDate(const Value: TOnDefaultDate);
begin
    if Kind = ekEditDate then
        (Control as TDatePicker).OnDefaultDate := Value;
end;

function TUniEdit.BevelGap(Pn: TPanel): Integer;
begin
    Result := 0;
    if Pn.BevelOuter <> bvNone then
        Result := Pn.BevelWidth;
end;

function TUniEdit.EllipsisButtonControl: TControl;
begin
    Result := FEllipBtn;
end;

function TUniEdit.GetStdImage: TStdImage;
begin
    Result := FUniPic.StdImage;
end;

procedure TUniEdit.SetStdImage(const Value: TStdImage);
begin
    FUniPic.StdImage := Value;
    if FUniPic.Empty then
    begin
        FUniPic.Width := StdImgShowSize;
        FUniPic.Height := StdImgShowSize;
        FUniPic.Visible := StdImgShowSize > 0;
    end;
    Adjust;
    Invalidate;
end;

procedure TUniEdit.SetStdImgShowSize(const Value: Integer);
begin
    FStdImgShowSize := Value;
    FUniPic.StdImgSmall := Value < 24;
    if FUniPic.Empty then
    begin
        FUniPic.Width := Value;
        FUniPic.Height := Value;
        FUniPic.Visible := Value > 0;
    end;
    Adjust;
    Invalidate;
end;

function TUniEdit.GetDoubleBuffered1: Boolean;
begin
    Result := inherited DoubleBuffered;
end;

procedure TUniEdit.SetDoubleBuffered1(const Value: Boolean);
begin
    inherited DoubleBuffered := Value;
    FCtlPanel.DoubleBuffered := Value;
    Control.DoubleBuffered := Value;
end;

procedure TUniEdit.CM_VISIBLE(var M: TMessage);
begin
    inherited;
    if Visible then
    begin
        Adjust;
        Invalidate;
    end;
end;

function TUniEdit.GetVis1: Boolean;
begin
    Result := inherited Visible;
end;

procedure TUniEdit.SetVis1(const Value: Boolean);
begin
    inherited Visible := Value;
    invalidate;
end;

procedure TUniEdit.CMInvalidate(var M: TMessage);
begin
    inherited;
    if FInvalidating then Exit;
    FInvalidating := TRUE;
    TRY
        if FControl <> nil then
            FControl.Invalidate;
        if FCtlPanel <> nil then
            FCtlPanel.Invalidate;
        if FEllipBtn <> nil then
            FEllipBtn.Invalidate;
    FINALLY
        FInvalidating := FALSE;
    END;
end;

procedure TUniEdit.WMUserSetFocus(var M: TMessage);
begin
    try
        if FControl.Visible and FControl.Enabled and not FControl.Focused
            and (ParentForm <> nil) and (ParentForm.Visible) then
            FControl.SetFocus;
    except
        asm
            nop
        end;
        //raise;
    end;
end;

{procedure TUniEdit.WMErase(var M: TMessage);
begin
    //inherited;
    //-----------------------------------------------M.Result := 1;
    //InvalidateRect( Handle, nil, FALSE );
    Exit;
end;}

procedure TUniEdit.Paint;
var Rgn, R2: HRgn;
    C: TControl;
    i: Integer;
begin
    Rgn := CreateRectRgn(0, 0, Width, Height);
    for i := 0 to ControlCount - 1 do
    begin
        C := Controls[i];
        if C is TWinControl then
        begin
            R2 := CreateRectRgn(C.Left, C.Top, C.Left + C.Width, C.Top + C.Height);
            CombineRgn(Rgn, Rgn, R2, RGN_DIFF);
            DeleteObject(R2);
        end;
    end;
    ExtSelectClipRgn(Canvas.Handle, Rgn, RGN_COPY);
    DeleteObject(Rgn);
    inherited;
    //ValidateRect( Handle, nil );
end;

function TUniEdit.Get_TabStop: Boolean;
begin
    Result := F_TabStop;
end;

procedure TUniEdit.Set_TabStop(const Value: Boolean);
begin
    F_TabStop := Value;
    inherited TabStop := Value;
end;

function TUniEdit.CanFocus: Boolean;
begin
    Result := inherited CanFocus;
end;

function TUniEdit.ParentForm: TCustomForm;
var C: TControl;
begin
    Result := nil;
    C := Self;
    while C <> nil do
    begin
        if C is TCustomForm then
        begin
            Result := C as TCustomForm;
            Exit;
        end;
        C := C.Parent;
    end;
end;

procedure TUniEdit.WndProc(var M: TMessage);
begin
    inherited;

end;

procedure TUniEdit.SetFont(const Value: TFont);
begin
    FFont := Value;
    if Control <> nil then
    begin
        if Control is TEditAny then
            (Control as TEditAny).Font := Value
        else
            if Control is TDatePicker then
                (Control as TDatePicker).Font := Value
            else
                if Control is TCheckBox then
                    (Control as TCheckBox).Font := Value
                else
                    if Control is TComboBox then
                        (Control as TComboBox).Font := Value;
    end;
end;

procedure TUniEdit.SetTitleFont(const Value: TFont);
begin
    FTitleFont := Value;
    if (FTitle <> nil) and not FTitleFontParent then
        FTitle.Font := Value;
end;

procedure TUniEdit.SetControlFontParent(const Value: Boolean);
begin
    FControlFontParent := Value;
    if (Control <> nil) and not FControlFontParent then
        ControlFont := FFont;
end;

procedure TUniEdit.SetTitleFontParent(const Value: Boolean);
begin
    FTitleFontParent := Value;
    if (FTitle <> nil) and not FTitleFontParent then
        FTitle.Font := FTitleFont;
end;

{ TEditNum }

procedure TEditNum.WMEditNum(var M: TWMChar);
var Txt: String;
    Pos: Integer;
    Sel: Integer;
    Min: Integer;
    Max: Integer;

begin
    Txt := Text;
    Pos := SelStart;
    Sel := SelLength;
    inherited;
    Min := Trunc((Owner as TUniEdit).MinValue);
    Max := Trunc((Owner as TUniEdit).MaxValue);
    if not IsInteger(Text) and (Text <> '-') then
    begin
        Text := Txt;
        SelStart := Pos;
        SelLength := Sel;
        Beep;
        Exit;
    end;
    if Text = '-' then Exit;
    TRY
        if ((Text <> '') and ((Min <> 0) or (Max <> 0)))
            and ((Str2Int(Text) < Min)
            or (Str2Int(Text) > Max)
            or (Length(Text) > Length(IntToStr(Max)))) then
        begin
            if Assigned((Owner as TUniEdit).OnOutBound) then
                (Owner as TUniEdit).OnOutBound(Owner, Txt)
            else
                raise Exception.Create('Incorrect input');
        end;
    EXCEPT
        Text := Txt;
        SelStart := Pos;
        SelLength := Sel;
        Beep;
    END;
end;

procedure TEditNum.WMPaint(var M: TWMPaint);
var C: TCanvas;
    W, H: Integer;
    R: TRect;
begin
    inherited;
    if Focused then Exit;
    C := TCanvas.Create;
    C.Handle := GetWindowDC(Handle);
    C.Font.Assign(Font);
    C.Brush.Assign(Brush);
    R := ClientRect;
    OffsetRect(R, (Width - R.Right) div 2,
        (Height - R.Bottom) div 2);
    C.FillRect(R);
    W := C.TextWidth(Text);
    H := C.TextHeight(Text);
    R.Left := R.Right - W - 2;
    R.Top := R.Top + (R.Bottom - R.Top - H) div 2;
    C.TextRect(R, R.Left, R.Top, Text);
    C.Free;
end;

procedure TEditNum.WMPaste(var M: TMessage);
var C: TClipboard;
    s: String;
    //N: Extended;
    OK: Boolean;
begin
    C := TClipboard.Create;
    OK := FALSE;
    try
        C.Open;
        if C.HasFormat(CF_TEXT) then
        begin
            s := Copy(Text, 1, SelStart) + C.AsText +
                Copy(Text, SelStart + SelLength, MaxInt);
            try
                {N :=}StrToFloat(s);
                OK := TRUE;
            except
            end;
        end;
        C.Close;
    finally
        C.Free;
    end;
    if OK then
        inherited
    else
        Beep;
end;

{ TEditFloat }

procedure TEditFloat.WMEditFloat(var M: TWMChar);
var Txt: String;
    Sta: Integer;
    Sel: Integer;
    Min, Max: Double;
    Dig: Integer;
begin
    Txt := Text;
    Sta := SelStart;
    Sel := SelLength;
    Min := (Owner as TUniEdit).MinValue;
    Max := (Owner as TUniEdit).MaxValue;
    Dig := (Owner as TUniEdit).Digits;
    if Char(M.CharCode) in ['.', ',', '', '', '', '', '<', '>'] then
        M.CharCode := Word(DecimalSeparator);
    inherited;
    if not Isfloat(Text) then
    begin
        Text := Txt;
        SelStart := Sta;
        SelLength := Sel;
        Beep;
        Exit;
    end;
    if (Text <> '-') AND (
        ((Text <> '') and ((Min <> 0) or (Max <> 0) or (Dig >= 0))
        and (((Min <> 0) or (Max <> 0)) and
        ((Str2Float(Text) < Min) or (Str2Float(Text) > Max))
        or (Dig >= 0) and (pos(DecimalSeparator, Text) > 0)
        and (Length(Text) - pos(DecimalSeparator, Text) > Dig)))
        ) then
    begin
        if Assigned((Owner as TUniEdit).OnOutBound) then
            (Owner as TUniEdit).OnOutBound(Owner, Txt)
        else
        begin
            Text := Txt;
            SelStart := Sta;
            SelLength := Sel;
            Beep;
        end;
    end;
end;

procedure TEditFloat.WMPaint(var M: TWMPaint);
var C: TCanvas;
    W, H: Integer;
    R: TRect;
begin
    inherited;
    if Focused then Exit;
    C := TCanvas.Create;
    C.Handle := GetWindowDC(Handle);
    C.Font.Assign(Font);
    C.Brush.Assign(Brush);
    R := ClientRect;
    OffsetRect(R, (Width - R.Right) div 2,
        (Height - R.Bottom) div 2);
    C.FillRect(R);
    W := C.TextWidth(Text);
    H := C.TextHeight(Text);
    R.Left := R.Right - W - 2;
    R.Top := R.Top + (R.Bottom - R.Top - H) div 2;
    C.TextRect(R, R.Left, R.Top, Text);
    C.Free;
end;

{ TEditcheck }

procedure TEditCheck.DoClick;
var UE: TUniEdit;
    Value: Boolean;
begin
    UE := Owner as TUniEdit;
    Value := Checked;
    if UE.FComboItems.Count > Integer(Value) then
        Caption := UE.FComboItems[Integer(Value)];
    if Assigned((Owner as TUniEdit).OnChange) then
        (Owner as TUniEdit).OnChange(Owner);
end;

procedure TEditcheck.SetChecked(Value: Boolean);
begin
    inherited;
    DoClick;
end;

{ TEditCurrency }

procedure TEditCurrency.WMEditCurrency(var M: TWMChar);
var Txt, S: String;
    P: Integer;
    Sel: Integer;
    Min, Max: Double;
begin
    Txt := Text;
    P := SelStart;
    Sel := SelLength;
    Min := (Owner as TUniEdit).MinValue;
    Max := (Owner as TUniEdit).MaxValue;
    if Char(M.CharCode) in ['.', ',', '', '', '', '', '<', '>'] then
    begin
        if (Owner as TUniEdit).CurrencyCommaChar <> ' ' then
            M.CharCode := Word((Owner as TUniEdit).CurrencyCommaChar)
        else
            M.CharCode := Word(DecimalSeparator);
    end;
    inherited;
    if not IsCurrency(Text) then
    begin
        Text := Txt;
        SelStart := P;
        SelLength := Sel;
        Beep;
        Exit;
    end;
    S := Text;
    if (Owner as TUniEdit).CurrencyCommaChar <> ' ' then
        if pos((Owner as TUniEdit).CurrencyCommaChar, S) > 1 then
            S[pos((Owner as TUniEdit).CurrencyCommaChar, S)] := DecimalSeparator;
    if ((S <> '') and ((Min <> 0) or (Max <> 0)))
        and ((Str2Float(S) < Min)
        or (Str2Float(S) > Max)) then
    begin
        if Assigned((Owner as TUniEdit).OnOutBound) then
            (Owner as TUniEdit).OnOutBound(Owner, Txt)
        else
        begin
            Text := Txt;
            SelStart := P;
            SelLength := Sel;
            Beep;
        end;
    end;
end;

procedure TEditCurrency.WMLeave(var M: TWMKillFocus);
var S: String;
    I: Integer;
begin
    inherited;
    S := Text;
    if S = '' then exit;
    if (Owner as TUniEdit).CurrencyCommaChar <> ' ' then
        I := pos((Owner as TUniEdit).CurrencyCommaChar, S)
    else
        I := pos(DecimalSeparator, S);
    if I <= 0 then
    begin
        if (Owner as TUniEdit).CurrencyCommaChar <> ' ' then
            S := S + (Owner as TUniEdit).CurrencyCommaChar
        else
            S := S + DecimalSeparator;
        I := Length(S);
    end;
    while Length(S) - I <= 1 do
    begin
        S := S + '0';
    end;
    Text := S;
end;

procedure TEditCurrency.WMPaint(var M: TWMPaint);
var C: TCanvas;
    W, H: Integer;
    R: TRect;
begin
    inherited;
    if Focused then Exit;
    C := TCanvas.Create;
    C.Handle := GetWindowDC(Handle);
    C.Font.Assign(Font);
    C.Brush.Assign(Brush);
    R := ClientRect;
    OffsetRect(R, (Width - R.Right) div 2,
        (Height - R.Bottom) div 2);
    C.FillRect(R);
    W := C.TextWidth(Text);
    H := C.TextHeight(Text);
    R.Left := R.Right - W - 2;
    R.Top := R.Top + (R.Bottom - R.Top - H) div 2;
    C.TextRect(R, R.Left, R.Top, Text);
    C.Free;
end;

{ TEditAny }

function TEditAny.CanFocus: Boolean;
var C: TWinControl;
begin
    Result := FALSE;
    C := FUniEdit;
    if not C.TabStop then Exit;
    while C <> nil do
    begin
        Result := C.Visible and C.Enabled;
        if not Result then Exit;
        if C is TCustomForm then Exit;
        C := C.Parent;
    end;
end;

procedure TEditAny.CMInvalidate(var M: TMessage);
begin
    inherited;
    InvalidateFrame;
    //RedrawWindow( Handle, nil, 0, RDW_ERASE or RDW_FRAME or RDW_INVALIDATE or RDW_UPDATENOW );
end;

constructor TEditAny.Create(AOwner: TComponent);
begin
    inherited;
    inherited OnChange := DoChange;
end;

procedure TEditAny.DoChange(Sender: TObject);
//var ichg: TNotifyEvent;
begin
    if Owner = nil then Exit;
    if Assigned((Owner as TUniEdit).OnChange) and (
        (Text <> TextWhenEnter)
        ) then
    begin
        (Owner as TUniEdit).OnChange(Owner);
        TextWhenEnter := Text;
    end;
    //ichg := inherited OnChange;
    //if Assigned( ichg ) then
    //  ichg( Self );
end;

function TEditAny.FUniEdit: TUniEdit;
var U: TComponent;
begin
    U := Owner;
    while U <> nil do
    begin
        if U is TUniEdit then
        begin
            Result := U as TUniEdit;
            Exit;
        end;
        U := U.Owner;
    end;
    Result := nil;
end;

procedure TEditAny.InvalidateFrame(regioned: Boolean = FALSE);
var R, R2: TRect;
    Rgn, Rgn2: HRgn;
begin
    if DisableFrameAroundFocusedUniEdit then
        Exit;
    if not HandleAllocated then
        Exit;
    R := BoundsRect;
    OffsetRect(R, -R.Left, -R.top);
    Rgn := CreateRectRgn(R.Left, R.Top, R.Right, R.Bottom);
    R2 := R;
    InflateRect(R2, -1, -1);
    Rgn2 := CreateRectRgn(R2.Left, R2.Top, R2.Right, R2.Bottom);
    CombineRgn(Rgn, Rgn, Rgn2, RGN_DIFF);
    DeleteObject(Rgn2);
    Windows.InvalidateRgn(Handle, Rgn, FALSE);
    if regioned then
        RedrawWindow(Handle, nil, Rgn, RDW_ERASE or RDW_FRAME or RDW_INVALIDATE) //or RDW_UPDATENOW ) //or RDW_INTERNALPAINT )
    else
        RedrawWindow(Handle, nil, 0, RDW_ERASE or RDW_FRAME or RDW_INVALIDATE); //or RDW_UPDATENOW ); // or RDW_INTERNALPAINT );
    DeleteObject(Rgn);
end;

procedure TEditAny.ValidateFrame(regioned: Boolean);
var R, R2: TRect;
    Rgn, Rgn2: HRgn;
begin
    if DisableFrameAroundFocusedUniEdit then
        Exit;
    R := BoundsRect;
    OffsetRect(R, -R.Left, -R.top);
    Rgn := CreateRectRgn(R.Left, R.Top, R.Right, R.Bottom);
    R2 := R;
    InflateRect(R2, -1, -1);
    Rgn2 := CreateRectRgn(R2.Left, R2.Top, R2.Right, R2.Bottom);
    CombineRgn(Rgn, Rgn, Rgn2, RGN_DIFF);
    DeleteObject(Rgn2);
    Windows.InvalidateRgn(Handle, Rgn, FALSE);
    {if  regioned then
        RedrawWindow( Handle, nil, Rgn, RDW_NOERASE or RDW_NOFRAME or RDW_VALIDATE or RDW_UPDATENOW or RDW_NOCHILDREN )
    else}
    RedrawWindow(Handle, nil, 0, RDW_NOERASE or RDW_NOFRAME or RDW_VALIDATE); // or RDW_UPDATENOW or RDW_NOCHILDREN );
    DeleteObject(Rgn);
end;

procedure TEditAny.WMEnableFocus(var M: TMessage);
begin
    FPreventFocus := False;
end;

procedure TEditAny.WMEnter(var M: TWMSetFocus);
begin
    inherited;
    if Assigned((Owner as TUniEdit).OnEnter) then
        (Owner as TUniEdit).OnEnter(Owner);
    TextWhenEnter := Text;
    Invalidate; //Frame;
    //Need_InvalidateFrame := TRUE;
end;

(*procedure TEditAny.WMErase(var M: TMessage);
begin
    {if  FRedrawingFrame then
    begin
        M.Result := 1;
        Exit;
    end;}
    inherited;
    //InvalidateFrame;
    {if  Focused then
    begin
        FRedrawingFrame := TRUE;
        try
            InvalidateFrame( TRUE );
            ValidateFrame( TRUE );
        finally
            FRedrawingFrame := FALSE;
        end;
    end;}
end;*)

procedure TEditAny.WMInvalidateFrame(var M: TMessage);
begin
    //RedrawWindow( Handle, nil, 0, RDW_ERASE or RDW_FRAME or RDW_INVALIDATE or RDW_UPDATENOW );
end;

procedure TEditAny.WMKeyDown(var M: TWMKey);
begin
    if Assigned((Owner as TUniEdit).OnKeyDown) then
        (Owner as TUniEdit).OnKeyDown(Owner, M.CharCode, MakeShiftState);
    if ((M.CharCode = VK_DOWN) or (M.CharCode = VK_UP))
        and not (FUniEdit.Kind in [ekEditDate, ekEditPeriod]) then
    begin
        PostMessage(GetParentForm(Self).Handle,
            WM_NEXTDLGCTL, Integer(M.CharCode = VK_UP), 0);
    end;
    inherited;
end;

procedure TEditAny.WMKeyPress(var M: TWMChar);
var L1, L2: Integer;
    C: TControl;
    UE: TUniEdit;
begin
    L1 := Length(Text);
    UE := FUniEdit;
    if Assigned(UE.OnKeyPress) then
        UE.OnKeyPress(UE, PChar(@M.CharCode)^);
    if (M.CharCode = 13)
        and (UE <> nil)
        and (UE.EllipsisButton in [ebNormal, ebSpeed])
        and (UE.FEllipBtn <> nil) then
    begin
        C := UE.FEllipBtn;
        if C <> nil then
            CASE UE.EllipsisButton OF
                ebNormal: (C as TButton).Click;
                ebSpeed: (C as TSpeedKnopka).Click;
            END;
    end
    else
        inherited;
    if UE.ExitOnMaxLenExceed then
    begin
        L2 := Length(Text);
        if (L1 < L2) and (L2 = (Owner as TUniEdit).MaxLength) then
        begin
            if UE.Owner is TForm then
                PostMessage((UE.Owner as TForm).Handle,
                    WM_NEXTDLGCTL, 0, 0);
        end;
    end;
end;

procedure TEditAny.WMKeyUp(var M: TWMKey);
begin
    if Assigned((Owner as TUniEdit).OnKeyUp) then
        (Owner as TUniEdit).OnKeyUp(Owner, M.CharCode, MakeShiftState);
    inherited;
end;

procedure TEditAny.WMLButton(var M: TWMLButtonDown);
begin
    if Assigned((Owner as TUniEdit).OnMouseDown) then
        (Owner as TUniEdit).OnMouseDown(Owner, mbLeft, MakeShiftState, M.XPos, M.YPos);
    inherited;
end;

procedure TEditAny.WMLDbl(var M: TWMLButtonDblClk);
begin
    if Assigned((Owner as TUniEdit).OnDblClick) then
        (Owner as TUniEdit).OnDblClick(Owner);
    inherited;
end;

procedure TEditAny.WMLeave(var M: TWMKillFocus);
begin
    //FPreventFocus := True;
    inherited;
    PostMessage(Handle, WM_USER + 7, 0, 0);
    if Assigned((Owner as TUniEdit).OnLeave) then
        (Owner as TUniEdit).OnLeave(Owner);
    //RedrawWindow( Handle, nil, 0, RDW_ERASE or RDW_FRAME or RDW_INVALIDATE or RDW_UPDATENOW );
    Invalidate; //Frame;
end;

procedure TEditAny.WMLUp(var M: TWMLButtonUp);
begin
    if Assigned((Owner as TUniEdit).OnMouseUp) then
        (Owner as TUniEdit).OnMouseUp(Owner, mbLeft, MakeShiftState, M.XPos, M.YPos);
    if ReadOnly and
        ((Owner as TUniEdit).EllipsisButton in [ebNormal, ebSpeed]) then
        if Assigned((Owner as TUniEdit).OnEllipsis) then
        begin
            (Owner as TUniEdit).OnEllipsis(Owner);
            if Enabled then
                GetParentForm(Self).ActiveControl := Self;
        end;
    inherited;
end;

procedure TEditAny.WMNCPaint(var M: TMessage);
var R, R2: TRect;
    dc: HDC;
    Br: TBrush;
    Rgn, Rgn2: HRgn;
begin
    inherited;
    if DisableFrameAroundFocusedUniEdit then
        Exit;
    if Focused then
    begin
        R := BoundsRect;

        OffsetRect(R, -R.Left, -R.top);
        dc := GetWindowDC(Handle);
        Br := TBrush.Create;
        try
            //Br.Color := clBtnFace;
            //Windows.FillRect( dc, R, Br.Handle );
            Try
                Rgn := CreateRectRgn(R.Left, R.Top, R.Right, R.Bottom);
                R2 := R;
                InflateRect(R2, -1, -1);
                Rgn2 := CreateRectRgn(R2.Left, R2.Top, R2.Right, R2.Bottom);
                CombineRgn(Rgn, Rgn, Rgn2, RGN_DIFF);
                DeleteObject(Rgn2);

                Br.Color := clBlue;
                Windows.FrameRect(dc, R, Br.Handle);

                //Windows.ValidateRgn( Handle, Rgn );
                DeleteObject(Rgn);

            Except
            end;
        finally
            ReleaseDC(Handle, dc);
            Br.Free;
        end;
    end
end;

procedure TEditAny.WMPaint(var M: TMessage);
{var R: TRect;
    dc: HDC;
    Br: TBrush;}
begin
    {if  FRedrawingFrame then
    begin
        M.Result := 0;
        Exit;
    end;}
    inherited;
    //PostMessage( Handle, WM_INVALIDATE_FRAME, 0, 0 );
    {if  Need_InvalidateFrame then
    begin
        Need_InvalidateFrame := FALSE;
        InvalidateFrame( FALSE );
    end;}
    {if  not DisableFrameAroundFocusedUniEdit then
    if  Focused then
    begin
        FRedrawingFrame := TRUE;
        try
            InvalidateFrame( TRUE );
            ValidateFrame( TRUE );
        finally
            FRedrawingFrame := FALSE;
        end;
    end;
    Windows.ValidateRect( Handle, nil );}
end;

procedure TEditAny.WMRButton(var M: TWMRButtonDown);
begin
    if Assigned((Owner as TUniEdit).OnMouseDown) then
        (Owner as TUniEdit).OnMouseDown(Owner, mbRight, MakeShiftState, M.XPos, M.YPos);
    inherited;
end;

procedure TEditAny.WMRDbl(var M: TWMRButtonDblClk);
begin
    if Assigned((Owner as TUniEdit).OnDblClick) then
        (Owner as TUniEdit).OnDblClick(Owner);
    inherited;
end;

procedure TEditAny.WMRUp(var M: TWMRButtonUp);
begin
    if Assigned((Owner as TUniEdit).OnMouseUp) then
        (Owner as TUniEdit).OnMouseUp(Owner, mbRight, MakeShiftState, M.XPos, M.YPos);
    inherited;
end;

{ TDateCheck }

constructor TDateCheck.Create(AOwner: TComponent);
begin
    inherited;
    OnClick := DoClick;
    TabStop := True;
end;

procedure TDateCheck.DoClick(Sender: TObject);
begin
    (Owner as TUniEdit).Checked := Checked;
    if Assigned((Owner as TUniEdit).OnChange) then
        (Owner as TUniEdit).OnChange(Owner);
    //Invalidate;
end;

procedure TDateCheck.SetChecked(Value: Boolean);
begin
    if Checked = Value then Exit;
    inherited;
    (Owner as TUniEdit).Checked := Value;
    if Assigned((Owner as TUniEdit).OnChange) then
        (Owner as TUniEdit).OnChange(Owner);
    //Invalidate;
    if Value and Focused then
        if ((Owner as TUniEdit).FControl.Enabled) then
            (Owner as TUniEdit).FControl.SetFocus;
end;

procedure TDateCheck.WMKillFocus(var M: TWMKillFocus);
begin
    FPreventFocus := True;
    inherited;
    //FPreventFocus := False;
    //Invalidate;
    PostMessage(Handle, WM_USER + 7, 0, 0);
end;

procedure TDateCheck.WMPaint(var M: TWMPaint);
const Sz = 14;
var DC: HDC;
    R, CR: TRect;
begin
    inherited;
    //if GetFocus = Handle then
    if Focused then
    begin
        DC := GetWindowDC(Handle);
        TRY

            R := BoundsRect;
            CR := ClientRect;
            OffsetRect(R, -R.Left - 1, -R.Top);
            R.Right := Sz;
            R.Top := (Height - Sz) div 2;
            R.Bottom := R.Top + Sz;
            Windows.DrawFocusRect(DC, R);

        FINALLY
            ReleaseDC(Handle, DC);
        END;
    end;
end;

procedure TDateCheck.WMSetFocus(var M: TWMSetFocus);
begin
    inherited;
    //Invalidate;
end;

procedure TDateCheck.WMKeyDown(var M: TWMKey);
begin
    if Assigned((Owner as TUniEdit).OnKeyDown) then
        (Owner as TUniEdit).OnKeyDown(Owner, M.CharCode, MakeShiftState);
    inherited;
end;

procedure TDateCheck.WMKeyPress(var M: TWMChar);
begin
    if Assigned((Owner as TUniEdit).OnKeyPress) then
        (Owner as TUniEdit).OnKeyPress(Owner, PChar(@M.CharCode)^);
    inherited;
end;

procedure TDateCheck.WMKeyUp(var M: TWMKey);
begin
    if Assigned((Owner as TUniEdit).OnKeyUp) then
        (Owner as TUniEdit).OnKeyUp(Owner, M.CharCode, MakeShiftState);
    inherited;
end;

procedure TDateCheck.WMEnableFocus(var M: TMessage);
begin
    FPreventFocus := False;
end;

{ TDatePicker }

procedure TDatePicker.AdjustHideText;
var R: TRect;
begin
    R := ClientRect;
    dec(R.Right, R.Bottom - R.Top);
    fHideTextPane.BoundsRect := R;
end;

procedure TDatePicker.CheckValidDate(Value: TDate);
begin
    inherited;
    if Value < 1 then
        Hide_Text
    else
        Show_Text;
end;

procedure TDatePicker.CNNotify(var Message: TWMNotify);
var MC: HWnd;
    ST: TSystemTime;
    SenderCtl: TControl;
begin
    with Message, NMHdr^ do
    begin
        case code of
            DTN_DROPDOWN:
                begin
                    FvalBeforeDrop := DateTime;
                    if FvalBeforeDrop <= 0 then
                    begin
                        if Assigned(fOnDefaultDate) then
                        begin
                            SenderCtl := Self;
                            if (Owner <> nil) and (Owner is TControl) then
                                SenderCtl := Owner as TControl;
                            FvalBeforeDrop := Now;
                            fOnDefaultDate(SenderCtl, FvalBeforeDrop);
                        end
                        else
                            FvalBeforeDrop := Now;
                        DateTime := FvalBeforeDrop;
                        MC := Perform(DTM_GETMONTHCAL, 0, 0);
                        DateTimeToSystemTime(FvalBeforeDrop, ST);
                        MonthCal_SetCurSel(MC, ST);
                        Show_Text;
                    end
                    else
                    begin
                        FvalBeforeDrop := 0;
                    end;
                end;
        end;
        inherited;
    end;
end;

constructor TDatePicker.Create(AOwner: TComponent);
begin
    inherited;
    fHideTextPane := TPanel.Create(Self);
    fHideTextPane.Parent := Self;
    fHideTextPane.Visible := FALSE;
    fHideTextPane.BevelInner := bvNone;
    fHideTextPane.BevelOuter := bvNone;
    fHideTextPane.Color := clWindow;
end;

function TDatePicker.FUniEdit: TUniEdit;
var U: TComponent;
begin
    U := Owner;
    while U <> nil do
    begin
        if U is TUniEdit then
        begin
            Result := U as TUniEdit;
            Exit;
        end;
        U := U.Owner;
    end;
    Result := nil;
end;

procedure TDatePicker.Hide_Text;
begin
    AdjustHideText;
    fHideTextPane.Visible := TRUE;
end;

procedure TDatePicker.Show_Text;
begin
    fHideTextPane.Visible := FALSE;
end;

procedure TDatePicker.WMEnableFocus(var M: TMessage);
begin
    FPreventFocus := FALSE;
end;

procedure TDatePicker.WMEnter(var M: TWMSetFocus);
begin
    inherited;
    if not DisableFrameAroundFocusedUniEdit then
    begin
        RedrawWindow(Handle, nil, 0, RDW_ERASE or RDW_FRAME or RDW_INVALIDATE);
        Invalidate;
        //RedrawWindow( Handle, nil, 0, RDW_UPDATENOW );
    end;
end;

procedure TDatePicker.WMKillFocus(var M: TWMKillFocus);
begin
    FPreventFocus := True;
    inherited;
    PostMessage(Handle, WM_USER + 7, 0, 0);
    if not DisableFrameAroundFocusedUniEdit then
        RedrawWindow(Handle, nil, 0, RDW_ERASE or RDW_FRAME or RDW_INVALIDATE or RDW_UPDATENOW);
end;

procedure TDatePicker.WMNCPaint(var M: TMessage);
var R: TRect;
    dc: HDC;
    Br: TBrush;
begin
    inherited;
    if Focused then
    begin
        R := BoundsRect;
        OffsetRect(R, -R.Left, -R.top);
        dc := GetDCEx(Handle, M.wParam, DCX_WINDOW or DCX_INTERSECTRGN or $10000);
        Br := TBrush.Create;
        try
            Try
                Br.Color := clBlue;
                Windows.FrameRect(dc, R, Br.Handle);
                //++++++++++++++++++++++++++++
                if not FSecondPaint then
                begin
                    FSecondPaint := TRUE;
                    R := ClientRect;
                    Windows.InvalidateRect(Handle, @R, TRUE);
                end;
                //++++++++++++++++++++++++++++
            Except
            end;
        finally
            ReleaseDC(Handle, dc);
            Br.Free;
        end;
    end
end;

procedure TDatePicker.WMPaint(var M: TMessage);
begin
    inherited;
    FSecondPaint := FALSE;
end;

procedure TDatePicker.WMSize(var M: TMessage);
begin
    inherited;
    AdjustHideText;
end;

procedure TDatePicker.WM_KeyDown(var M: TWMKey);
begin
    CASE M.CharCode OF
        VK_DELETE: begin
                DateTime := 0;
                Hide_Text;
                Change;
            end;
        VK_RETURN: begin
                if (FUniEdit <> nil) then
                    if (FUniEdit.EllipsisButton in [ebNormal, ebSpeed])
                        and (FUniEdit.FEllipBtn <> nil) then
                    begin
                        CASE FUniEdit.EllipsisButton OF
                            ebNormal: (FUniEdit.FEllipBtn as TBitKnopka).Click;
                            ebSpeed: (FUniEdit.FEllipBtn as TSpeedKnopka).Click;
                        END;
                    end
                    else
                    begin
                        M.CharCode := VK_F4;
                        inherited;
                    end;
            end;
    else
        inherited;
    END;
end;

{ TEditCombo }

procedure TEditCombo.ComboWndProc(var Message: TMessage; ComboWnd: HWnd;
    ComboProc: Pointer);
var R: TRect;
    dc: HDC;
    Br: TBrush;
begin
    inherited;
    if Message.Msg = WM_NCPAINT then
    begin
        if IsFocused then
        begin
            R := BoundsRect;
            OffsetRect(R, -R.Left, -R.top);
            dc := GetDCEx({GetComboControl}Handle, Message.wParam,
                DCX_WINDOW or DCX_INTERSECTRGN or $10000);
            Br := TBrush.Create;
            try
                Try
                    Br.Color := clBlue;
                    Windows.FrameRect(dc, R, Br.Handle);
                Except
                end;
            finally
                ReleaseDC(Handle, dc);
                Br.Free;
            end;
        end
    end;
end;

constructor TEditCombo.Create(AOwner: TComponent);
begin
    inherited;
    inherited OnChange := DoChange;
    inherited OnExit := DoLeave;
    Style := csDropDownList;
end;

procedure TEditCombo.DoChange(Sender: TObject);
begin
    if Owner = nil then Exit;
    if Assigned(OwnerUniEdit.OnChange) then
        OwnerUniEdit.OnChange(OwnerUniEdit);
    OwnerUniEdit.Invalidate;
end;

procedure TEditCombo.DoLeave(Sender: TObject);
begin
    FIsFocused := FALSE;
    InvalidateFrame;
    if Assigned(OwnerUniEdit.OnLeave) then
        OwnerUniEdit.OnLeave(OwnerUniEdit);
    PostMessage(Handle, WM_USER + 7, 0, 0);
end;

function TEditCombo.FUniEdit: TUniEdit;
var U: TComponent;
begin
    U := Owner;
    while U <> nil do
    begin
        if U is TUniEdit then
        begin
            Result := U as TUniEdit;
            Exit;
        end;
        U := U.Owner;
    end;
    Result := nil;
end;

procedure TEditCombo.InvalidateFrame;
//var W: HWnd;
begin
    Invalidate;
    {W := GetComboControl;
    if  W = 0 then
        W := Handle;
    RedrawWindow( W, nil, 0,
      RDW_ERASE or RDW_FRAME or RDW_INVALIDATE or RDW_UPDATENOW
      or RDW_ALLCHILDREN );}
end;

function TEditCombo.IsFocused: Boolean;
begin
    Result := FIsFocused;
end;

function TEditCombo.OwnerUniEdit: TUniEdit;
var C: TComponent;
begin
    C := FUniEdit;
    while (C <> nil) and not (C is TUniEdit) do
        C := C.Owner;
    if (C <> nil) and not (C is TUniEdit) then
        Result := nil
    else
        Result := C as TUniEdit;
end;

procedure TEditCombo.WMCloseUp(var M: TMessage);
begin
    if (HIWORD(M.WParam) = CBN_CLOSEUP) then
    begin
        if Assigned(FOnCloseUp) then
            FOnCloseUp(Parent);
    end;
    //else
    inherited;
end;

procedure TEditCombo.WMEnableFocus(var M: TMessage);
begin
    FPreventFocus := False;
end;

procedure TEditCombo.WMEnter(var M: TWMSetFocus);
begin
    FIsFocused := TRUE;
    InvalidateFrame;
    if M.FocusedWnd = GetParentHandle then
    begin
        inherited;
        Exit;
    end;
    FEntering := True;
    inherited;
    //if Assigned( OwnerUniEdit.OnEnter ) then
    //  (Owner as TUniEdit).OnEnter( OwnerUniEdit );
    if FUniEdit <> nil then
        if Assigned(FUniEdit.OnEnter) then
            FUniEdit.OnEnter(FUniEdit);
    fEntering := False;
    Need_InvalidateFrame := TRUE;
end;

procedure TEditCombo.WMKeyDown(var M: TWMKey);
begin
    if Assigned(OwnerUniEdit.OnKeyDown) then
        OwnerUniEdit.OnKeyDown(OwnerUniEdit, M.CharCode, MakeShiftState);
    if (M.CharCode = VK_DOWN) and (GetKeyState(VK_MENU) < 0) and (ItemIndex < 0)
        or (M.CharCode = VK_RETURN) and (FUniEdit.Kind = ekCombo) and
        not (FUniEdit.EllipsisButton in [ebNormal, ebspeed]) then
        if not DroppedDown then
        begin
            PostMessage(Handle, CB_SHOWDROPDOWN, 1, 0);
            M.CharCode := 0;
        end;
    inherited;
end;

procedure TEditCombo.WMKeyPress(var M: TWMChar);
begin
    if Assigned(OwnerUniEdit.OnKeyPress) then
        OwnerUniEdit.OnKeyPress(OwnerUniEdit, PChar(@M.CharCode)^);
    if (M.CharCode = 13)
        and (FUniEdit <> nil)
        and (FUniEdit.EllipsisButton in [ebNormal, ebSpeed])
        and (FUniEdit.FEllipBtn <> nil) then
    begin
        CASE FUniEdit.EllipsisButton OF
            ebNormal: (FUniEdit.FEllipBtn as TButton).Click;
            ebSpeed: (FUniEdit.FEllipBtn as TSpeedKnopka).Click;
        END;
    end;
    inherited;
end;

procedure TEditCombo.WMKeyUp(var M: TWMKey);
begin
    if Assigned(OwnerUniEdit.OnKeyUp) then
        OwnerUniEdit.OnKeyUp(OwnerUniEdit, M.CharCode, MakeShiftState);
    inherited;
end;

procedure TEditCombo.WMLButton(var M: TWMLButtonDown);
begin
    if Assigned(OwnerUniEdit.OnMouseDown) then
        OwnerUniEdit.OnMouseDown(OwnerUniEdit, mbLeft, MakeShiftState, M.XPos, M.YPos);
    inherited;
end;

procedure TEditCombo.WMLDbl(var M: TWMLButtonDblClk);
begin
    if Assigned(OwnerUniEdit.OnDblClick) then
        OwnerUniEdit.OnDblClick(OwnerUniEdit);
    inherited;
end;

procedure TEditCombo.WMLeave(var M: TWMKillFocus);
begin
    if fEntering then
    begin
        Inherited;
        Exit;
    end;
    //FPreventFocus := False;
    if (GetKeyState(VK_SHIFT) < 0) and
        (GetKeyState(VK_TAB) < 0) then
    begin
        OwnerUniEdit.Perform(WM_NEXTDLGCTL, 1, 0);
        inherited;
        if Assigned(OwnerUniEdit.OnLeave) then
            OwnerUniEdit.OnLeave(OwnerUniEdit);
        M.Result := 0;
        Exit;
    end
    else
    begin
        FPreventFocus := True;
        inherited;
    end;
    //Invalidate;
    {if Assigned( OwnerUniEdit.OnLeave ) then
       OwnerUniEdit.OnLeave( OwnerUniEdit );
    PostMessage( Handle, WM_USER+7, 0, 0 );}
end;

procedure TEditCombo.WMLUp(var M: TWMLButtonUp);
begin
    if Assigned(OwnerUniEdit.OnMouseUp) then
        OwnerUniEdit.OnMouseUp(OwnerUniEdit, mbLeft, MakeShiftState, M.XPos, M.YPos);
    inherited;
end;

{procedure TEditCombo.WMNCPaint(var M: TMessage);
var R: TRect;
    dc: HDC;
    Br: TBrush;
begin
    inherited;
    if  IsFocused then
    begin
        R := BoundsRect;
        OffsetRect( R, -R.Left, -R.top );
        dc := GetDCEx(Handle, M.wParam, DCX_WINDOW or DCX_INTERSECTRGN or $10000);
        Br := TBrush.Create;
        try
            Try
                Br.Color := clBlue;
                Windows.FrameRect( dc, R, Br.Handle );
            Except
            end;
        finally
            ReleaseDC(Handle, dc);
            Br.Free;
        end;
    end
end;}

procedure TEditCombo.WMPaint(var M: TMessage);
var R: TRect;
    dc: HDC;
    Br: TBrush;
begin
    inherited;
    {if  Need_InvalidateFrame then
    begin
        Need_InvalidateFrame := FALSE;
        InvalidateFrame;
    end;}
    if not DisableFrameAroundFocusedUniEdit then
        if IsFocused then
        begin
            R := BoundsRect;
            OffsetRect(R, -R.Left, -R.top);
            dc := GetDCEx(Handle, M.wParam, DCX_WINDOW {or DCX_INTERSECTRGN} or $10000);
            Br := TBrush.Create;
            try
                Try
                    Br.Color := clBlue;
                    Windows.FrameRect(dc, R, Br.Handle);
                    //Canvas.Brush.Color := clBlue;
                    //Canvas.FrameRect( R );
                Except
                end;
            finally
                ReleaseDC(Handle, dc);
                Br.Free;
            end;
        end
end;

procedure TEditCombo.WMRButton(var M: TWMRButtonDown);
begin
    if Assigned(OwnerUniEdit.OnMouseDown) then
        OwnerUniEdit.OnMouseDown(OwnerUniEdit, mbRight, MakeShiftState, M.XPos, M.YPos);
    inherited;
end;

procedure TEditCombo.WMRDbl(var M: TWMRButtonDblClk);
begin
    if Assigned(OwnerUniEdit.OnDblClick) then
        OwnerUniEdit.OnDblClick(OwnerUniEdit);
    inherited;
end;

procedure TEditCombo.WMRUp(var M: TWMRButtonUp);
begin
    if Assigned(OwnerUniEdit.OnMouseUp) then
        OwnerUniEdit.OnMouseUp(OwnerUniEdit, mbRight, MakeShiftState, M.XPos, M.YPos);
    inherited;
end;

{ TUniSource }

procedure TUniSource.AddUniEdit(UE: TUniEdit);
begin
    FUniEditList.Add(UE);
    UE.ListField := UE.ListField;
end;

constructor TUniSource.Create(AOwner: TComponent);
begin
    inherited;
    FUniEditList := TList.Create;
end;

destructor TUniSource.Destroy;
var I: Integer;
    UE: TUniEdit;
begin
    if FastListView <> nil then
        FastListView.RemoveUniSource(Self);
    for I := 0 to FUniEditList.Count - 1 do
    begin
        UE := FUniEditList[I];
        UE.ListSourcePresent := FALSE;
    end;
    FUniEditList.Free;
    inherited;
end;

function TUniSource.FieldExists(const AFieldName: String): Boolean;
var I: Integer;
begin
    Result := FALSE;
    if FastListView = nil then Exit;
    I := FastListView.ColumnIndexByName(AFieldName);
    Result := I >= 0;
end;

function TUniSource.GetFastListView: TFastListView;
begin
    Result := FFastListView;
    if not FastListViewExists then
        Result := nil;
end;

function TUniSource.GetLinkedUniEditControls(Idx: Integer): TUniEdit;
begin
    Result := FUniEditList[Idx];
end;

function TUniSource.GetUniEditCount: Integer;
begin
    Result := FUniEditList.Count;
end;

procedure TUniSource.ListItemBeginEdit(LI: TFastListItem);
var I: Integer;
    UE: TUniEdit;
begin
    for I := 0 to LinkedUniEditCount - 1 do
    begin
        UE := LinkedUniEditControls[I];
        if UE.ListField <> '' then
        begin
            if LI <> nil then
                CASE UE.Kind OF
                    ekEditDate: TRY
                            UE.DateTime := StrToDateTime(LI[UE.ListField]);
                        EXCEPT
                            UE.DateTime := Trunc(Now);
                        END;
                else UE.Text := LI[UE.ListField];
                END
            else
                CASE UE.Kind OF
                    ekEditDate: UE.DateTime := 0;
                else UE.Text := '';
                END;
        end;
    end;
end;

procedure TUniSource.ListItemEndEdit(LI: TFastListItem);
var I: Integer;
    UE: TUniEdit;
begin
    Assert(LI <> nil, 'List item is not defined to end edit the set of UniEdits.');
    for I := 0 to LinkedUniEditCount - 1 do
    begin
        UE := LinkedUniEditControls[I];
        if UE.ListField <> '' then
        begin
            if not UE.Enabled then
            begin
                LI[UE.ListField] := '';
            end
            else
            begin
                CASE UE.Kind OF
                    ekEditDate:
                        if UE.DateFormat = dfShort then
                            LI[UE.ListField] := FormatDateTime('dd.mm.yyyy', UE.DateTime)
                        else
                            LI[UE.ListField] := DateTimeTostr(UE.DateTime);
                else LI[UE.ListField] := UE.Text;
                END;
            end;
        end;
    end;
end;

{$IFDEF USE_NEWQUERY}

function TUniSource.QueryInsert_Str(const TableName: String;
    const MoreValues: String = '';
    const MoreFields: String = '';
    const DoBefore: String = '';
    const WhereConditions: String = '';
    NeedIdentity: Boolean = TRUE): Integer;
var Q1: {$IFDEF USE_NEWQUERY}TNewQuery{$ELSE}TQuery{$ENDIF};

    function FieldPresentInDBTable(Q: TQuery; const FieldName: String): Integer;
    var J: Integer;
    begin
        Result := -1;
        {$IFDEF ODBC_DIRECT}
        for J := 0 to Q.FieldCount - 1 do
            if AnsiCompareText(FieldName, Q.FieldNames[J]) = 0 then
                {$ELSE}
        for J := 0 to Q.FieldCount - 1 do
            if AnsiCompareText(FieldName, Q.FieldNames[J]) = 0 then
                {$ENDIF}
            begin
                Result := J;
                Exit;
            end;
    end;

    function ParamValAsStr(Q: TQuery; UE: TUniEdit; const ParamName: String): String;
    var J: Integer;
    begin
        Result := '';
        J := FieldPresentInDBTable(Q1, UE.ListField);
        CASE UE.Kind OF
            ekEditDate:
                Result := StringReplace('''' + FormatDateTime('yyyy/mm/dd', UE.DateTime) + '''',
                    '.', '/', [rfReplaceAll]);
        else
            CASE
                {$IFDEF ODBC_DIRECT}
            Q1.FieldTypes[J]
                {$ELSE}
            Q1.Fieldtypes[J]
                {$ENDIF}
            OF
                ftString, ftWideString, ftFixedChar, ftMemo, ftVariant:
                    Result := StrToSQL(UE.Text);
                ftCurrency, ftFloat, ftDate, ftTime, ftDateTime, ftBCD:
                    Result := StringReplace(Format('%23.9f', [UE.Value]), ',', '.', []);
                ftInteger, ftWord, ftSmallInt:
                    Result := IntToStr(Trunc(UE.Value));
                ftLargeInt:
                    Result := IntToStr(Trunc(UE.Value));
            else raise Exception.Create('Field type is not applicable to insert ' +
                    ' data to the table ' + TableName + ' using QueryInsert method.' +
                    'Field name is: ' +
                    {$IFDEF ODBC_DIRECT}
                    Q1.FieldNames[J] + ', ' +
                    {$ELSE}
                    Q1.FieldNames[J] + ', ' +
                    {$ENDIF}
                    'Param name is: ' + ParamName);
            END;
        END;
    end;

var Q: TQuery;
    FieldNames, ParamVals: String;
    I: Integer;
    UE: TUniEdit;
begin
    Result := -1;
    {$IFDEF ADO_DB}
    Q := TNewQuery.Create(nil);
    Q1 := TNewQuery.Create(nil);
    {$ELSE}
    Q := TQuery.Create(nil);
    Q1 := TQuery.Create(nil);
    {$ENDIF}
    TRY
        TRY
            Q1.SQL.Text := 'select top 1 * from ' + TableName;
            Q1.Open;
        EXCEPT on E: Exception do
            begin
                ShowMessage(': ' + E.ClassName + ' ' + E.message);
                raise;
            end;

        END;

        FieldNames := '';
        ParamVals := '';
        for I := 0 to LinkedUniEditCount - 1 do
        begin
            UE := LinkedUniEditControls[I];
            if UE.Enabled then
                if (UE.ListField <> '') and (FieldPresentInDBTable(Q1, UE.ListField) >= 0) then
                begin
                    FieldNames := FieldNames + ',[' + UE.ListField + ']';
                    ParamVals := ParamVals + ',' + ParamValAsStr(Q, UE, UE.ListField);
                end;
        end;
        Delete(FieldNames, 1, 1);
        Delete(ParamVals, 1, 1);
        if MoreFields <> '' then
        begin
            FieldNames := FieldNames + ', ' + MoreFields;
            ParamVals := ParamVals + ', ' + MoreValues;
        end;
        Assert(FieldNames <> '', '      ' + TableName);
        Q.SQL.Text := DoBefore +
            #13'insert into ' + TableName + '(' + FieldNames + ')';
        if WhereConditions = '' then
            Q.SQL.Text := Q.SQL.Text + 'values(' + ParamVals + ')'
        else
            Q.SQL.Text := Q.SQL.Text + 'select ' + ParamVals + ' ' + WhereConditions;
        if NeedIdentity then
            Q.SQL.Text := Q.SQL.Text + ' select @@identity';
        {for I := 0 to LinkedUniEditCount-1 do
        begin
          UE := LinkedUniEditControls[ I ];
          if UE.Enabled then
          if (UE.ListField <> '') and (FieldPresentInDBTable( Q1, UE.ListField ) >= 0) then
            AssignValueToParam( Q, UE, 'p' + IntToStr( I+1 ) );
        end;}
        (*PIdx := 0;
        while Trim( MoreParams ) <> '' do
        begin
          I := pos( ',', MoreParams );
          if I <= 0 then I := Length( MoreParams ) + 1;
          PName := Trim( Copy( MoreParams, 1, I - 1 ) );
          MoreParams := Copy( MoreParams, I + 1, MaxInt );
          Assert( (Length(PName) > 1) and (PName[ 1 ] = ':'), 'Additional parameter ' +
                  PName + ' has invalid name (must be non-empty identifier with' +
                  ' leading '':''.' );
          PName := Copy( PName, 2, MaxInt );
          Assert( PIdx <= High( MoreValues ), 'Additional parameter ' + PName +
                  ' has no correspondent value defined in call to QueryInsert ' +
                  '(TableName=' + TableName + ').' );

            {$IFDEF ADO_DB}
            Q.Parameters.ParamValues[ PName ]
            {$ELSE ADO_DB}
            Q.ParamByName( PName ).Value
            {$ENDIF ADO_DB} := MoreValues[ PIdx ];
          Inc( PIdx );
        end;*)
        if NeedIdentity then
        begin
            Q.Open;
            if not Q.Eof then
                {$IFDEF USE_NEWQUERY}
                if Q.NullFieldN[0] then
                    {$ELSE}
                if Q.Fields[0].IsNull then
                    {$ENDIF}
                    Result := 0
                else
                    {$IFDEF ODBC_DIRECT}
                    Result := Q.IFieldN[0];
            {$ELSE}
                    Result := Q.IFieldN[0];
            {$ENDIF}
        end
        else
        begin
            Q.ExecSQL;
            Result := 0;
        end;
    FINALLY
        Q.Free;
        Q1.Free;
    END;
end;

function TUniSource.QueryInsert(const TableName: String;
    const MoreValues: array of Variant; const MoreFields: String;
    MoreParams: String; const DoBefore, WhereConditions: String): Integer;
var Q1: TQuery;

    function FieldPresentInDBTable(Q: TQuery; const FieldName: String): Integer;
    var J: Integer;
    begin
        Result := -1;
        {$IFDEF ODBC_DIRECT}
        for J := 0 to Q.FieldCount - 1 do
            if AnsiCompareText(FieldName, Q.FieldNames[J]) = 0 then
                {$ELSE}
        for J := 0 to Q.FieldCount - 1 do
            if AnsiCompareText(FieldName, Q.FieldNames[J]) = 0 then
                {$ENDIF}
            begin
                Result := J;
                Exit;
            end;
    end;

    procedure AssignValueToParam(Q: TQuery; UE: TUniEdit; const ParamName: String);
        {$IFNDEF ODBC_DIRECT}
    var J: Integer;
        {$ENDIF}
    begin
        {$IFDEF ODBC_DIRECT}
        raise Exception.Create('TODBCQuery   ')
            {$ELSE}
        J := FieldPresentInDBTable(Q1, UE.ListField);
        CASE UE.Kind OF
            ekEditDate:
                {$IFDEF ADO_DB}
                Q.DParam[ParamName]
                    {$ELSE}
                Q.ParamByName(ParamName).Value
                    {$ENDIF ADO_DB} := UE.Value;
        else
            CASE Q1.Fieldtypes[J] OF
                ftString, ftWideString, ftFixedChar, ftMemo, ftVariant:
                    {$IFDEF ADO_DB}
                    Q.SParam[ParamName]
                        {$ELSE ADO_DB}
                    Q.ParamByName(ParamName).Value
                        {$ENDIF ADO_DB} := UE.Text;
                ftCurrency, ftFloat, ftDate, ftTime, ftDateTime, ftBCD:
                    {$IFDEF ADO_DB}
                    Q.FParam[ParamName]
                        {$ELSE ADO_DB}
                    Q.ParamByName(ParamName).Value
                        {$ENDIF ADO_DB} := UE.Value;
                ftInteger, ftWord, ftSmallInt:
                    {$IFDEF ADO_DB}
                    Q.IParam[ParamName]
                        {$ELSE ADO_DB}
                    Q.ParamByName(ParamName).Value
                        {$ENDIF ADO_DB} := Integer(Trunc(UE.Value));
                ftLargeInt:
                    {$IFDEF ADO_DB}
                    Q.IParam[ParamName]
                        {$ELSE ADO_DB}
                    Q.ParamByName(ParamName).Value
                        {$ENDIF ADO_DB} := Integer(Trunc(UE.Value));
            else raise Exception.Create('Field type is not applicable to insert ' +
                    ' data to the table ' + TableName + ' using QueryInsert method.' +
                    'Field name is: ' + Q1.FieldNames[J] + ', ' +
                    'Param name is: ' + ParamName);
            END;
        END;
        {$ENDIF}
    end;

var Q: TQuery;
    FieldNames, ParamNames: String;
    I: Integer;
    UE: TUniEdit;
    PName: String;
    PIdx: Integer;
begin
    Result := -1;
    Q := TQuery.Create(nil);
    Q1 := TQuery.Create(nil);
    TRY
        Q1.SQL.Text := 'select top 1 * from ' + TableName;
        Q1.Open;

        FieldNames := '';
        ParamNames := '';
        for I := 0 to LinkedUniEditCount - 1 do
        begin
            UE := LinkedUniEditControls[I];
            if UE.Enabled then
                if (UE.ListField <> '') and (FieldPresentInDBTable(Q1, UE.ListField) >= 0) then
                begin
                    FieldNames := FieldNames + ',' + '[' + UE.ListField + ']';
                    ParamNames := ParamNames + ',:p' + IntToStr(I + 1);
                end;
        end;
        Delete(FieldNames, 1, 1);
        Delete(ParamNames, 1, 1);
        if MoreFields <> '' then
        begin
            FieldNames := FieldNames + ', ' + MoreFields;
            ParamNames := ParamNames + ', ' + MoreParams;
        end;
        Assert(FieldNames <> '', '      ' + TableName);
        Q.SQL.Text := DoBefore +
            #13'insert into ' + TableName + '(' + FieldNames + ')';
        if WhereConditions = '' then
            Q.SQL.Text := Q.SQL.Text + 'values(' + ParamNames + ')'
        else
            Q.SQL.Text := Q.SQL.Text + 'select ' + ParamNames + ' ' + WhereConditions;
        Q.SQL.Text := Q.SQL.Text + 'select @@identity';
        for I := 0 to LinkedUniEditCount - 1 do
        begin
            UE := LinkedUniEditControls[I];
            if UE.Enabled then
                if (UE.ListField <> '') and (FieldPresentInDBTable(Q1, UE.ListField) >= 0) then
                    AssignValueToParam(Q, UE, 'p' + IntToStr(I + 1));
        end;
        PIdx := 0;
        while Trim(MoreParams) <> '' do
        begin
            I := pos(',', MoreParams);
            if I <= 0 then I := Length(MoreParams) + 1;
            PName := Trim(Copy(MoreParams, 1, I - 1));
            MoreParams := Copy(MoreParams, I + 1, MaxInt);
            Assert((Length(PName) > 1) and (PName[1] = ':'), 'Additional parameter ' +
                PName + ' has invalid name (must be non-empty identifier with' +
                ' leading '':''.');
            PName := Copy(PName, 2, MaxInt);
            Assert(PIdx <= High(MoreValues), 'Additional parameter ' + PName +
                ' has no correspondent value defined in call to QueryInsert ' +
                '(TableName=' + TableName + ').');

            {$IFDEF ODBC_DIRECT}
            raise Exception.Create('TODBCQuery   ');
            {$ELSE}
            {$IFDEF ADO_DB}
            Q.SParam[PName]
                {$ELSE ADO_DB}
            Q.ParamByName(PName).Value
                {$ENDIF ADO_DB} := MoreValues[PIdx];
            {$ENDIF}
            Inc(PIdx);
            if PIdx = 0 then ;
        end;
        Q.Open;
        if not Q.Eof then
            {$IFDEF USE_NEWQUERY}
            if Q.NullFieldN[0] then
                {$ELSE}
            if Q.Fields[0].IsNull then
                {$ENDIF}
                Result := 0
            else
                {$IFDEF ODBC_DIRECT}
                Result := Q.IFieldN[0];
        {$ELSE}
                Result := //Q.Fields[ 0 ].Value;
                Q.IFieldN[0];
        {$ENDIF}
    FINALLY
        Q.Free;
        Q1.Free;
    END;
end;

function TUniSource.QueryUpdate(const TableName: String;
    const MoreValues: array of Variant; MoreFields: String;
    MoreParams: String; const DoBefore, WhereConditions: String): Boolean;

    function IfCond(Cond: Boolean; const S: String): String;
    begin
        if Cond then Result := S else Result := '';
    end;

var Q1: TQuery;

    function FieldPresentInDBTable(Q: TQuery; const FieldName: String): Integer;
    var J: Integer;
    begin
        Result := -1;
        {$IFDEF ODBC_DIRECT}
        for J := 0 to Q.FieldCount - 1 do
            if AnsiCompareText(FieldName, Q.FieldNames[J]) = 0 then
                {$ELSE}
        for J := 0 to //Q.FieldDefList.Count-1 do
        Q.FieldCount - 1 do
            if AnsiCompareText(FieldName, //Q.FieldDefList[ J ].Name )=0 then
                Q.FieldNames[J]) = 0 then
                {$ENDIF}
            begin
                Result := J;
                Exit;
            end;
    end;

    procedure AssignValueToParam(Q: TQuery; UE: TUniEdit; const ParamName: String);
        {$IFNDEF USE_NEWQUERY}
    var J: Integer;
        {$ENDIF}
    begin
        {$IFDEF USE_NEWQUERY}
        raise Exception.Create('TODBCQuery   ');
        {$ELSE}
        J := FieldPresentInDBTable(Q1, UE.ListField);
        CASE UE.Kind OF
            ekEditDate:
                {$IFDEF ADO_DB}
                Q.Parameters.ParamValues[ParamName]
                    {$ELSE}
                Q.ParamByName(ParamName).Value
                    {$ENDIF ADO_DB} := UE.Value;
        else
            CASE Q1.FieldDefList[J].DataType OF
                ftString, ftWideString, ftFixedChar, ftMemo, ftVariant:
                    {$IFDEF ADO_DB}
                    Q.SParam[ParamName]
                        {$ELSE ADO_DB}
                    Q.ParamByName(ParamName).Value
                        {$ENDIF ADO_DB} := UE.Text;
                ftCurrency, ftFloat, ftDate, ftTime, ftDateTime:
                    {$IFDEF ADO_DB}
                    Q.Parameters.ParamValues[ParamName]
                        {$ELSE ADO_DB}
                    Q.ParamByName(ParamName).Value
                        {$ENDIF ADO_DB} := UE.Value;
                ftInteger, ftWord, ftSmallInt, ftBCD:
                    {$IFDEF ADO_DB}
                    Q.Parameters.ParamValues[ParamName]
                        {$ELSE ADO_DB}
                    Q.ParamByName(ParamName).Value
                        {$ENDIF ADO_DB} := Integer(Trunc(UE.Value));
                ftLargeInt:
                    {$IFDEF ADO_DB}
                    Q.Parameters.ParamValues[ParamName]
                        {$ELSE ADO_DB}
                    Q.ParamByName(ParamName).Value
                        {$ENDIF ADO_DB} := Integer(Trunc(UE.Value));
            else raise Exception.Create('Field type is not applicable to insert ' +
                    ' data to the table ' + TableName + ' using QueryInsert method.' +
                    'Field name is: ' + Q1.FieldDefList[J].Name + ', ' +
                    'Param name is: ' + ParamName);
            END;
        END;
        {$ENDIF}
    end;

var Q: TQuery;
    FieldNames, ParamNames: TStringList;
    SFields, SParams: String;
    I: Integer;
    UE: TUniEdit;
    PName: String;
    PIdx: Integer;
begin
    {$IFDEF ODBC_DIRECT}
    Result := FALSE;
    {$ENDIF}
    Q := TQuery.Create(nil);
    Q1 := TQuery.Create(nil);
    FieldNames := TStringList.Create;
    ParamNames := TStringList.Create;
    TRY
        Q1.SQL.Text := 'select top 1 * from ' + TableName;
        Q1.Open;

        for I := 0 to LinkedUniEditCount - 1 do
        begin
            UE := LinkedUniEditControls[I];
            if UE.Enabled then
                if (UE.ListField <> '') and (FieldPresentInDBTable(Q1, UE.ListField) >= 0) then
                begin
                    FieldNames.Add(UE.ListField);
                    ParamNames.Add(':p' + IntToStr(I + 1));
                end;
        end;
        if MoreFields <> '' then
        begin
            SFields := MoreFields;
            SParams := MoreParams;
            while (Trim(SFields) <> '') and (Trim(SParams) <> '') do
            begin
                I := pos(',', SFields);
                if I <= 0 then I := Length(SFields) + 1;
                FieldNames.Add(Trim(Copy(SFields, 1, I - 1)));
                SFields := Copy(SFields, I + 1, MaxInt);
                I := pos(',', SParams);
                if I <= 0 then I := Length(SParams) + 1;
                ParamNames.Add(Trim(Copy(SParams, 1, I - 1)));
                SParams := Copy(SParams, I + 1, MaxInt);
            end;
        end;
        Assert(FieldNames.Count > 0, '     ' + TableName);
        Q.SQL.Text := DoBefore +
            #13'update ' + TableName + ' set ';
        for I := 0 to FieldNames.Count - 1 do
        begin
            Q.SQL.Text := Q.SQL.Text + '[' + FieldNames[I] + ']=' + ParamNames[I] +
                IfCond(I < FieldNames.Count - 1, ',');
        end;
        Q.SQL.Text := Q.SQL.Text + ' ' + WhereConditions;
        for I := 0 to LinkedUniEditCount - 1 do
        begin
            UE := LinkedUniEditControls[I];
            if UE.Enabled then
                if (UE.ListField <> '') and (FieldPresentInDBTable(Q1, UE.ListField) >= 0) then
                    AssignValueToParam(Q, UE, 'p' + IntToStr(I + 1));
        end;
        PIdx := 0;
        while Trim(MoreParams) <> '' do
        begin
            I := pos(',', MoreParams);
            if I <= 0 then I := Length(MoreParams) + 1;
            PName := Trim(Copy(MoreParams, 1, I - 1));
            MoreParams := Copy(MoreParams, I + 1, MaxInt);
            Assert((Length(PName) > 1) and (PName[1] = ':'), 'Additional parameter ' +
                PName + ' has invalid name (must be non-empty identifier with' +
                ' leading '':''.');
            PName := Copy(PName, 2, MaxInt);
            Assert(PIdx <= High(MoreValues), 'Additional parameter ' + PName +
                ' has no correspondent value defined in call to QueryInsert ' +
                '(TableName=' + TableName + ').');

            {$IFDEF ODBC_DIRECT}
            raise Exception.Create('TODBCQuery   ');
            {$ELSE}
            {$IFNDEF USE_NEWQUERY}
            {$IFDEF ADO_DB}
            Q.Parameters.ParamValues[PName]
                {$ELSE ADO_DB}
            Q.ParamByName(PName).Value
                {$ENDIF ADO_DB} := MoreValues[PIdx];
            {$ENDIF}
            {$ENDIF}
            Inc(PIdx); if PIdx = 0 then ;
        end;
        Q.ExecSQL;
        Result := TRUE;
    FINALLY
        Q.Free;
        Q1.Free;
        FieldNames.Free;
        ParamNames.Free;
    END;
end;

function TUniSource.QueryUpdate_Str(const TableName: String;
    const MoreValues: array of Variant; MoreFields, MoreParams: String;
    const DoBefore, WhereConditions: String): Boolean;

    function IfCond(Cond: Boolean; const S: String): String;
    begin
        if Cond then Result := S else Result := '';
    end;

var Q1: TQuery;

    function FieldPresentInDBTable(Q: TQuery; const FieldName: String): Integer;
    var J: Integer;
    begin
        Result := -1;
        {$IFDEF ODBC_DIRECT}
        for J := 0 to Q.FieldCount - 1 do
            if AnsiCompareText(FieldName, Q.FieldNames[J]) = 0 then
                {$ELSE}
        for J := 0 to //Q.FieldDefList.Count-1 do
        Q.FieldCount - 1 do
            if AnsiCompareText(FieldName, //Q.FieldDefList[ J ].Name )=0 then
                Q.FieldNames[J]) = 0 then
                {$ENDIF}
            begin
                Result := J;
                Exit;
            end;
    end;

    function ValueToParam(Q: TQuery; UE: TUniEdit): String;
        {$IFNDEF USE_NEWQUERY}
    var J: Integer;
        {$ENDIF}
    begin
        {$IFDEF USE_NEWQUERY}
        raise Exception.Create('TODBCQuery   ');
        {$ELSE}
        Result := UE.Text;
        J := FieldPresentInDBTable(Q1, UE.ListField);
        if J < 0 then Exit;
        CASE Q1.FieldDefList[J].DataType OF
            ftString, ftWideString, ftFixedChar, ftMemo, ftVariant:
                Result := StrToSQL(UE.Text);
            ftCurrency, ftFloat, ftDate, ftTime, ftDateTime, ftBCD:
                Result := StringReplace(Format('%23.9f', [UE.Value]), ',', '.', []);
            ftInteger, ftWord, ftSmallInt:
                Result := IntToStr(Trunc(UE.Value));
            ftLargeInt:
                Result := IntToStr(Trunc(UE.Value));
        else raise Exception.Create('Field type is not applicable to set ' +
                ' data to the table ' + TableName + ' using QueryUpdate method.' +
                'Field name is: ' + Q1.FieldDefList[J].Name + ', ' +
                'Value is: ' + UE.Text);
        END;
        {$ENDIF}
    end;

var Q: TQuery;
    FieldNames, ParamNames: TStringList;
    SFields, SParams: String;
    I: Integer;
    UE: TUniEdit;
    PName: String;
    PIdx: Integer;
    S: String;
begin
    {$IFDEF ODBC_DIRECT}
    Result := FALSE;
    {$ENDIF}
    Q := TQuery.Create(nil);
    Q1 := TQuery.Create(nil);
    FieldNames := TStringList.Create;
    ParamNames := TStringList.Create;
    TRY
        Q1.SQL.Text := 'select top 1 * from ' + TableName;
        Q1.Open;

        for I := 0 to LinkedUniEditCount - 1 do
        begin
            UE := LinkedUniEditControls[I];
            if UE.Enabled then
                if (UE.ListField <> '') and (FieldPresentInDBTable(Q1, UE.ListField) >= 0) then
                begin
                    FieldNames.Add(UE.ListField);
                    ParamNames.Add(':p' + IntToStr(I + 1));
                end;
        end;
        Q.SQL.Text := DoBefore +
            #13'update ' + TableName + ' set ';
        if MoreFields <> '' then
        begin
            SFields := MoreFields;
            SParams := MoreParams;
            while (Trim(SFields) <> '') and (Trim(SParams) <> '') do
            begin
                I := pos(',', SFields);
                if I <= 0 then I := Length(SFields) + 1;
                Q.SQL.Text := Q.SQL.Text + '[' + Trim(Copy(SFields, 1, I - 1)) + ']=';
                //FieldNames.Add( Trim( Copy( SFields, 1, I-1 ) ) );
                SFields := Copy(SFields, I + 1, MaxInt);
                I := pos(',', SParams);
                if I <= 0 then I := Length(SParams) + 1;
                ParamNames.Add(Trim(Copy(SParams, 1, I - 1)));
                //SParams := Copy( SParams, I+1, MaxInt );
                Q.SQL.Text := Q.SQL.Text + Trim(Copy(SParams, 1, I - 1)) + ', ';
            end;
        end;
        Assert(FieldNames.Count > 0, '     ' + TableName);
        for I := 0 to LinkedUniEditCount - 1 do
        begin
            UE := LinkedUniEditControls[I];
            if UE.ListField <> '' then
            begin
                Q.SQL.Text := Q.SQL.Text + '[' + FieldNames[I] + ']=' +
                    ValueToParam(Q, UE) + ',';
            end;
        end;
        S := Trim(Q.SQL.Text);
        if S[Length(S)] = ',' then
            Delete(S, Length(S), 1);
        Q.SQL.Text := S + ' ' + WhereConditions;
        PIdx := 0; If PIdx = 0 then ;
        while Trim(MoreParams) <> '' do
        begin
            I := pos(',', MoreParams);
            if I <= 0 then I := Length(MoreParams) + 1;
            PName := Trim(Copy(MoreParams, 1, I - 1));
            MoreParams := Copy(MoreParams, I + 1, MaxInt);
            Assert((Length(PName) > 1) and (PName[1] = ':'), 'Additional parameter ' +
                PName + ' has invalid name (must be non-empty identifier with' +
                ' leading '':''.');
            PName := Copy(PName, 2, MaxInt);
            Assert(PIdx <= High(MoreValues), 'Additional parameter ' + PName +
                ' has no correspondent value defined in call to QueryInsert ' +
                '(TableName=' + TableName + ').');

            {$IFDEF ODBC_DIRECT}
            raise Exception.Create('TODBCQuery   ');
            {$ELSE}
            {$IFNDEF USE_NEWQUERY}
            {$IFDEF ADO_DB}
            Q.Parameters.ParamValues[PName]
                {$ELSE ADO_DB}
            Q.ParamByName(PName).Value
                {$ENDIF ADO_DB} := MoreValues[PIdx];
            {$ENDIF}
            {$ENDIF}
            Inc(PIdx); if PIdx = 0 then ;
        end;
        Q.SQL.SaveToFile('c:\text.txt');
        Q.ExecSQL;
        Result := TRUE;
    FINALLY
        Q.Free;
        Q1.Free;
        FieldNames.Free;
        ParamNames.Free;
    END;
end;
{$ENDIF USE_NEWQUERY}

procedure TUniSource.RemoveUniEdit(UE: TUniEdit);
begin
    FUniEditList.Remove(UE);
end;

procedure TUniSource.SetFastListView(const Value: TFastListView);
begin
    FFastListView := Value;
    FastListViewExists := Value <> nil;
    if Value <> nil then
        Value.AddUniSource(Self);
end;

procedure TUniSource.SetFastListViewExists(const Value: Boolean);
begin
    FFastListViewExists := Value;
end;

{$IFDEF _D6orHigher}
{$ELSE}

{$IFDEF IN_PACKAGE}
{ TUniSourceEditField }

function TUniSourceEditField.GetAttributes: TPropertyAttributes;
begin
    Result := [paValueList, paSortList];
end;

procedure TUniSourceEditField.GetValues(Proc: TGetStrProc);
var I: Integer;
    UniEdit: TUniEdit;
    S: String;
begin
    //Proc( '' );
    UniEdit := GetComponent(0) as TUniEdit;
    if UniEdit = nil then
    begin
        //ShowMessage( 'UniEdit = nil - no fields' );
        Exit;
    end;
    if not Assigned(UniEdit.ListSource) then
    begin
        //ShowMessage( 'UniEdit.ListSource not present - no fields' );
        Exit;
    end;
    if not Assigned(UniEdit.ListSource.FastListView) then
    begin
        //ShowMessage( 'UniEdit.ListSource.FastListView not assigned - no fields' );
        Exit;
    end;
    //ShowMessage( IntToStr( UniEdit.ListSource.FastListView.Columns.Count ) + ' columns' );
    for I := 0 to UniEdit.ListSource.FastListView.Columns.Count - 1 do
    begin
        S := UniEdit.ListSource.FastListView.ColumnFieldNames[I];
        if S = '' then
            S := UniEdit.ListSource.FastListView.Columns[I].Caption;
        Proc(S);
    end;
end;

{$ENDIF IN_PACKAGE}

{$ENDIF}

{ TEditPeriod }

procedure TEditPeriod.CreateParams(var Params: TCreateParams);
begin
    inherited;
    Params.Style := Params.Style or ES_CENTER;
end;

function TEditPeriod.FUniEdit: TUniEdit;
var U: TComponent;
begin
    U := Owner;
    while U <> nil do
    begin
        if U is TUniEdit then
        begin
            Result := U as TUniEdit;
            Exit;
        end;
        U := U.Owner;
    end;
    Result := nil;
end;

procedure TEditPeriod.SetDateTime(const Value: TDateTime);
var DT: TDateTime;
    Y, M, D: Word;
    WasOnChange, WasCtlOnChange: TNotifyEvent;
begin
    DT := Value;
    if DT <> 0 then
    begin
        DecodeDate(DT, Y, M, D);
        CASE (Owner as TUniEdit).KindPeriod OF
            pkYear: DT := EncodeDate(Y, 1, 1);
            pkQuarterYear,
                pkMonth: DT := EncodeDate(Y, M, 1);
            pkQuarter: DT := EncodeDate(Y, ((M - 1) div 3) * 3 + 1, 1);
            pkDecade: DT := EncodeDate(Y, M, ((D - 1) div 10) * 10 + 1);
            pkDay: DT := EncodeDate(Y, M, D);
        END;
    end;
    WasOnChange := OnChange;
    WasCtlOnChange := (Owner as TUniEdit).OnChange;
    if FDateTime <> DT then
    begin
        FDateTime := DT;
        if Assigned(OnChange) then
        begin
            OnChange(Self);
            OnChange := nil;
            (Owner as TUniEdit).OnChange := nil;
        end;
    end;
    TRY

        if DT = 0 then
            Text := ''
        else
        begin
            DecodeDate(DT, Y, M, D);
            if (Owner as TUniEdit).DateFormat = dfShort then
                CASE (Owner as TUniEdit).KindPeriod OF
                    pkQuarterYear: if M = 12 then
                        begin
                            Text := FormatDateTime('yyyy', DT);
                            Font.Style := Font.Style + [fsBold];
                        end
                        else
                        begin
                            Text := IntToRome((M - 1) div 3 + 1) + '/' +
                                FormatDateTime('yyyy', DT);
                            Font.Style := Font.Style - [fsBold];
                        end;
                    pkYear: Text := FormatDateTime('yyyy', DT);
                    pkMonth: Text := FormatDateTime('mm.yyyy', DT);
                    pkQuarter: Text := IntToRome((M - 1) div 3 + 1) + '/' +
                        FormatDateTime('yyyy', DT);
                    pkDecade: Text := IntToRome((D - 1) div 10 + 1) + '/' +
                        FormatDateTime('mm.yyyy', DT);
                    pkDay: Text := FormatDateTime('dd.mm.yyyy', DT);
                END
            else
                CASE (Owner as TUniEdit).KindPeriod OF
                    pkQuarterYear: if M = 12 then
                        begin
                            Text := FormatDateTime('yyyy', DT) + ' .';
                            Font.Style := Font.Style + [fsBold];
                        end
                        else
                        begin
                            Text := IntToRome((M - 1) div 3 + 1) + '  ' +
                                FormatDateTime('yyyy', DT) + ' .';
                            Font.Style := Font.Style - [fsBold];
                        end;
                    pkYear: Text := FormatDateTime('yyyy', DT) + ' .';
                    pkMonth: Text := FormatDateTime('mmmm yyyy', DT) + ' .';
                    pkQuarter: Text := IntToRome((M - 1) div 3 + 1) + '  ' +
                        FormatDateTime('yyyy', DT) + ' .';
                    pkDecade: Text := IntToRome((D - 1) div 10 + 1) + '  ' +
                        FormatDateTime('mmmm yyyy', DT) + ' .';
                    pkDay: Text := FormatDateTime('d mmmm yyyy', DT) + ' .';
                END
        end;

    FINALLY
        OnChange := WasOnChange;
        (Owner as TUniEdit).OnChange := WasCtlOnChange;
    END;
end;

procedure AdjustRestrictions(UniSource: TUniSource; const TableName: String);
var I, J: Integer;
    U: TUniEdit;
    Q: TQuery;
    M: Integer;
begin
    Q := TQuery.Create(nil);
    TRY
        Q.SQL.Text := 'select * from ' + TableName + ' where 0=1';
        Q.Open;
        for I := 0 to UniSource.LinkedUniEditCount - 1 do
        begin
            U := UniSource.LinkedUniEditControls[I];
            if (U.ListField <> '') then
            begin
                {$IFDEF ODBC_DIRECT}
                J := Q.FindFieldIndex(U.ListField);
                //Q.FieldList.IndexOf( U.ListField );
                {$ELSE}
                J := Q.FieldList.IndexOf(U.ListField);
                //Q.FindFieldIndex( U.ListField );
                {$ENDIF}
                if (J >= 0) and (
                    {$IFDEF USE_NEWQUERY} // ODBC_DIRECT}
                    Q.FieldTypes[J]
                    {$ELSE}
                    Q.FieldList[J].DataType
                    {$ENDIF}
                    in [ftFloat, ftCurrency, ftBCD]) then
                begin
                    U.MaxLength :=
                        {$IFDEF ODBC_DIRECT}255{$ELSE}
                    {$IFDEF USE_NEWQUERY}255{$ELSE}
                    Q.FieldList[J].DisplayWidth{$ENDIF}
                    {$ENDIF};
                    //U.Digits := Q.FieldList[ J ].Precision;
                    M := 0;
                    CASE
                        {$IFDEF USE_NEWQUERY} // ODBC_DIRECT}
                    Q.FieldTypes[J]
                        {$ELSE}
                    Q.FieldList[J].DataType
                        {$ENDIF}
                    OF
                        {$IFDEF ODBC_DIRECT}
                        ftFloat, ftCurrency, ftBCD:
                            M := Q.FieldPrecision[J];
                        {$ELSE}
                        ftFloat: M := (Q.FieldList[J] as TFloatField).Precision;
                        ftCurrency: M := (Q.FieldList[J] as TCurrencyField).Precision;
                        ftBCD: M := (Q.FieldList[J] as TBCDField).Precision;
                        {$ENDIF}
                    END;
                    U.Digits := M;
                end;
                {J := Q.FieldDefList.IndexOf( U.ListField );
                if (J >= 0) and (Q.FieldDefList[ J ].DataType in [ ftFloat, ftCurrency, ftBCD ] ) then
                begin
                  U.Digits := Q.FieldDefList[ J ].Precision;
                  //U.MaxLength := Q.FieldList[ J ].DisplayWidth;
                end;}
            end;
        end;
    FINALLY
        Q.Free;
    END;
end;



procedure TEditPeriod.WM_KeyDown(var M: TWMKey);
begin
    CASE M.CharCode OF
        VK_RETURN: begin
                if (FUniEdit <> nil)
                    and (FUniEdit.EllipsisButton in [ebNormal, ebSpeed])
                    and (FUniEdit.FEllipBtn <> nil) then
                begin
                    CASE FUniEdit.EllipsisButton OF
                        ebNormal: (FUniEdit.FEllipBtn as TButton).Click;
                        ebSpeed: (FUniEdit.FEllipBtn as TSpeedKnopka).Click;
                    END;
                end;
            end;
    else
        inherited;
    END;
end;

{ TCtlPanel }

(*procedure TCtlPanel.WMErase(var Msg: TWMPaint);
{var Rgn, R2: HRgn;
    i: Integer;
    C: TControl;}
begin
    //inherited;
    {Rgn := CreateRectRgn( 0, 0, Width, Height );
    for i := 0 to ControlCount-1 do
    begin
        C := Controls[i];
        R2 := CreateRectRgn( C.Left, C.Top, C.Left + C.Width, C.Top + C.Height );
        CombineRgn( Rgn, Rgn, R2, RGN_DIFF );
        DeleteObject( R2 );
    end;
    Windows.FillRgn( Canvas.Handle, Rgn, Canvas.Brush.Handle );
    DeleteObject( Rgn );}
    //-----------------------------Msg.Result := 1;
    Exit;
end;*)

procedure TCtlPanel.WMPaint(var Msg: TWMPaint);
{var Control: TControl;
    R: TRect;}
{var Rgn, R2: HRgn;
    i: Integer;
    C: TControl;}
begin
    //inherited;
    {Rgn := CreateRectRgn( 0, 0, Width, Height );
    for i := 0 to ControlCount-1 do
    begin
        C := Controls[i];
        R2 := CreateRectRgn( C.Left, C.Top, C.Left + C.Width, C.Top + C.Height );
        CombineRgn( Rgn, Rgn, R2, RGN_DIFF );
        DeleteObject( R2 );
    end;
    Windows.FillRgn( Canvas.Handle, Rgn, Canvas.Brush.Handle );
    DeleteObject( Rgn );}
    inherited;
    //-------------------------------------------Msg.Result := 0;
    Exit;
    {inherited;
    if  ControlCount > 0 then
    begin
        Control := Controls[0];
        if  (Control is TWinControl) and (Control as TWinControl).Focused
        or  (Control is TEditCombo) and (Control as TEditCombo).IsFocused then
        begin
            if  Control is TComboBox then
            begin
                asm
                nop
                end;
            end;
            R := Control.BoundsRect;
            InflateRect( R, 1, 1 );
            Canvas.Brush.Color := clBlue;
            Canvas.FrameRect( R );
        end;
    end;}
end;

{ TTitle }

procedure TTitle.WndProc(var M: TMessage);
var M1: TWMMouse;
    P: TPoint;
begin
    if (csDesigning in ComponentState) then
        inherited
    else
        case M.Msg of
            WM_MOUSEFIRST..WM_MOUSELAST:
                begin
                    if Handling_Mouse then
                    begin
                        Exit; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
                    end;
                    Handling_Mouse := TRUE;
                    TRY
                        P := ClientToScreen(Point(TWMMouse(M).XPos, TWMMouse(M).YPos));
                        P := (Parent as TUniEdit).ScreenToClient(P);
                        M1 := TWMMouse(M);
                        M1.XPos := P.X;
                        M1.YPos := P.Y;
                        Enabled := FALSE;
                        TRY
                            (Parent as TUniEdit).WndProc(TMessage(M1));
                        FINALLY
                            Enabled := TRUE;
                        END;
                    FINALLY
                        Handling_Mouse := FALSE;
                    END;
                end;
            WM_NCHITTEST:
                M.Result := HTTRANSPARENT;
        else inherited;
        end;
end;

initialization

    {$IFDEF DEBG}
    DeleteFile('C:\ooo.txt');
    {$ENDIF}

finalization
    FreeAndNil(PeriodButtons[1]);
    FreeAndNil(PeriodButtons[2]);
    FreeAndNil(PeriodButtons[3]);
    FreeAndNil(PeriodButtons[4]);

end.
