//**  ,     VCL Delphi.
//**  Vladimir Kladov, 2000-2010
//**
//**      .
//**     /     
//**  2          
//**   GNU,  Free Software Foundation.
//**
//**       ,    
//** ,       ,   
//**         
//**   .      
//**     GNU.
//**
//**          
//**   GNU.     ,     Free
//** Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//** MA 02111-1307, USA.
//******************************************************************************

unit UniKnopka;

interface

uses classes, graphics, Knopka;


//{$DEFINE USE_STDBUTTON}

{$IFNDEF USE_STDBUTTONS}
         {$DEFINE USE_KNOPKA}
{$ENDIF}

//{$DEFINE ELLIP_DISABLEFORMWHILECLCIK} - define to allow DisableFormWhileClick on.

type
    TSpeedKnopka = class( {$IFDEF USE_KNOPKA} TKnopka
                          {$ELSE} TSpeedButton {$ENDIF} )
    public
        constructor Create( AOwner: TComponent ); override;
        procedure AssignGlyph( Bmp: TBitmap );
    end;

    TBitKnopka = class( {$IFDEF USE_KNOPKA} TKnopka
                        {$ELSE} TBitBtn {$ENDIF} )
    public
        constructor Create( AOwner: TComponent ); override;
        procedure AssignGlyph( Bmp: TBitmap );
    end;



implementation


{ TSpeedKnopka }

procedure TSpeedKnopka.AssignGlyph(Bmp: TBitmap);
begin
    {$IFDEF USE_KNOPKA}
    Picture.Assign( Bmp );
    {$ELSE}
    Glyph.Assign( Bmp );
    {$ENDIF}
end;

constructor TSpeedKnopka.Create(AOwner: TComponent);
begin
    inherited Create( AOwner );
    {$IFDEF USE_KNOPKA}
    SpeedButton := TRUE;
    MarginsText := 0;
    {$ENDIF}
    {$IFDEF ELLIP_DISABLEFORMWHILECLCIK}
    {$ELSE}
    DisableFormWhileClick := FALSE;
    {$ENDIF}
end;

{ TBitKnopka }

constructor TBitKnopka.Create(AOwner: TComponent);
begin
    inherited Create( AOwner );
    {$IFDEF ELLIP_DISABLEFORMWHILECLCIK}
    {$ELSE}
    DisableFormWhileClick := FALSE;
    {$ENDIF}
end;

procedure TBitKnopka.AssignGlyph(Bmp: TBitmap);
begin
    {$IFDEF USE_KNOPKA}
    Picture.Assign( Bmp );
    {$ELSE}
    Glyph.Assign( Bmp );
    {$ENDIF}
end;


end.
