//**  ,     VCL Delphi.
//**  Vladimir Kladov, 2000-2010
//**
//**      .
//**     /     
//**  2          
//**   GNU,  Free Software Foundation.
//**
//**       ,    
//** ,       ,   
//**         
//**   .      
//**     GNU.
//**
//**          
//**   GNU.     ,     Free
//** Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//** MA 02111-1307, USA.
//******************************************************************************

{************************************************}
{                                                }
{     TUniPic                    }
{   " "                     }
{              }
{   TUniEdit                                     }
{   Copyright (c) 2000-2003 by Vladimir Kladov   }
{                                                }
{************************************************}
unit UniPic;
// +++

interface

{$I VCL_VERSIONS.inc}

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, ExtCtrls, ComCtrls, Commctrl, ImgList;

type
    TStdImage = (histBACK, histFORWARD, histFAVORITES, histADDTOFAVORITES,
        histVIEWTREE,
        stdCUT, stdCOPY, stdPASTE, stdUNDO, stdREDOW, stdDELETE,
        stdFILENEW, stdFILEOPEN, stdFILESAVE, stdPRINTPRE, stdPROPERTIES,
        stdHELP, stdFIND, stdREPLACE, stdPRINT,
        viewLARGEICONS, viewSMALLICONS, viewLIST, viewDETAILS,
        viewSORTNAME, viewSORTSIZE, viewSORTDATE, viewSORTTYPE,
        viewPARENTFOLDER, viewNETCONNECT, viewNETDISCONNECT,
        viewNEWFOLDER, viewVIEWMENU,
        oicSAMPLE, oicHAND, oicQUES, oicBANG, oicNOTE, oicWINLOGO,
        oicWARNING,
        obmLFARROWI, obmRGARROWI, obmDNARROWI, obmUPARROWI,
        obmCOMBO, obmMNARROW, obmLFARROWD, obmRGARROWD, obmDNARROWD,
        obmUPARROWD, obmRESTORED, obmZOOMD, obmREDUCED, obmRESTORE,
        obmZOOM, obmREDUCE, obmLFARROW, obmRGARROW, obmDNARROW,
        obmUPARROW, obmCLOSE, obmOLD_RESTORE, obmOLD_ZOOM, obmOLD_REDUCE,
        obmBTNCORNERS, obmCHECKBOXES, obmCHECK, obmBTSIZE,
        obmOLD_LFARROW, obmOLD_RGARROW, obmOLD_DNARROW, obmOLD_UPARROW,
        obmSIZE, obmOLD_CLOSE,
        addREFRESH, addCHECK, addEXIT
        );

const
    StdImageNames: array[TStdImage] of String = (
        'histBACK', 'histFORWARD', 'histFAVORITES', 'histADDTOFAVORITES',
        'histVIEWTREE', 'stdCUT', 'stdCOPY', 'stdPASTE', 'stdUNDO',
        'stdREDOW', 'stdDELETE', 'stdFILENEW', 'stdFILEOPEN',
        'stdFILESAVE', 'stdPRINTPRE', 'stdPROPERTIES',
        'stdHELP', 'stdFIND', 'stdREPLACE', 'stdPRINT',
        'viewLARGEICONS', 'viewSMALLICONS', 'viewLIST', 'viewDETAILS',
        'viewSORTNAME', 'viewSORTSIZE', 'viewSORTDATE', 'viewSORTTYPE',
        'viewPARENTFOLDER', 'viewNETCONNECT', 'viewNETDISCONNECT',
        'viewNEWFOLDER', 'viewVIEWMENU',
        'oicSAMPLE', 'oicHAND', 'oicQUES', 'oicBANG', 'oicNOTE',
        'oicWINLOGO', 'oicWARNING',
        'obmLFARROWI', 'obmRGARROWI', 'obmDNARROWI', 'obmUPARROWI',
        'obmCOMBO', 'obmMNARROW', 'obmLFARROWD', 'obmRGARROWD', 'obmDNARROWD',
        'obmUPARROWD', 'obmRESTORED', 'obmZOOMD', 'obmREDUCED', 'obmRESTORE',
        'obmZOOM', 'obmREDUCE', 'obmLFARROW', 'obmRGARROW', 'obmDNARROW',
        'obmUPARROW', 'obmCLOSE', 'obmOLD_RESTORE', 'obmOLD_ZOOM', 'obmOLD_REDUCE',
        'obmBTNCORNERS', 'obmCHECKBOXES', 'obmCHECK', 'obmBTSIZE',
        'obmOLD_LFARROW', 'obmOLD_RGARROW', 'obmOLD_DNARROW', 'obmOLD_UPARROW',
        'obmSIZE', 'obmOLD_CLOSE',
        'addREFRESH', 'addCHECK', 'addEXIT'
        );

    {$R add_icons.res}

type
    TOnGetPicture = procedure(Sender: TObject; var P: TPicture) of object;

type
    TUniPic = class(TGraphicControl)
    private
        FImageList: TImageList;
        FImageIndex: Integer;
        FPicture: TPicture;
        FTransparent: Boolean;
        FStretch: Boolean;
        FAutosize: Boolean;
        FDesignTimeBorder: Boolean;
        FMouseTransparent: Boolean;
        FStdImage: TStdImage;
        FStdImgSmall: Boolean;
        procedure SetImageList(const Value: TImageList);
        procedure SetImageIndex(const Value: Integer);
        procedure SetPicture(const Value: TPicture);
        procedure SetTransparent(const Value: Boolean);
        procedure SetStretch(const Value: Boolean);
        procedure Set_Autosize(const Value: Boolean);
        function GetEmpty: Boolean;
        procedure SetDesignTimeBorder(const Value: Boolean);
        procedure SetMouseTransparent(const Value: Boolean);
        procedure SetStdImage(const Value: TStdImage);
        procedure SetStdImgSmall(const Value: Boolean);
        function GetPicture: TPicture;
        //procedure HitTest(var M: TMessage);
    protected
        Handling_Mouse: Boolean;
        procedure Paint; override;
        procedure AdjustSize; override;
        procedure WndProc(var M: TMessage); override;
        //procedure HitTest( var M: TMessage ); message WM_NCHITTEST;
        procedure PrepareStdImageList(var IL: TImageList; var IL_index: Integer;
            var BlackBackground: Boolean);
    public
        FOnGetPicture: TOnGetPicture;
        property OnGetPicture: TOnGetPicture read FOnGetPicture write FOnGetPicture;
        property Empty: Boolean read GetEmpty;
        procedure PaintToCanvas(ToCanvas: TCanvas; const ToR: TRect);
    published
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        property ImageList: TImageList read FImageList write SetImageList;
        property ImageIndex: Integer read FImageIndex write SetImageIndex;
        property Picture: TPicture read GetPicture write SetPicture;
        property Transparent: Boolean read FTransparent write SetTransparent;
        property Stretch: Boolean read FStretch write SetStretch;
        property Autosize: Boolean read FAutosize write Set_Autosize;
        property Align;
        property DesignTimeBorder: Boolean read FDesignTimeBorder write SetDesignTimeBorder;
        property StdImage: TStdImage read FStdImage write SetStdImage;
        property StdImgSmall: Boolean read FStdImgSmall write SetStdImgSmall;
        property Enabled;
        property Color;
        property ParentColor;
        property OnClick;
        property OnContextPopup;
        property OnDblClick;
        property OnDragDrop;
        property OnDragOver;
        property OnEndDock;
        property OnEndDrag;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        property OnStartDock;
        property OnStartDrag;
        property MouseTransparent: Boolean read FMouseTransparent write SetMouseTransparent;
        property OnResize;
    end;

procedure Register;

implementation

uses UniEdit;

procedure Register;
begin
    RegisterComponents('Kladov', [TUniPic]);
end;

var //Toolbar_sm, Toolbar_lg: THandle;
    Images_x: array[0..1, 0..5] of TImageList;


    { TUniPic }

procedure TUniPic.AdjustSize;
begin
    if not AutoSize then Exit;
    if assigned(ImageList) then
    begin
        Width := ImageList.Width;
        Height := ImageList.Height;
    end
    else
        if assigned(Picture.Graphic) and not (Picture.Graphic.Empty) then
        begin
            Width := Picture.Width;
            Height := Picture.Height;
        end;
end;

constructor TUniPic.Create(AOwner: TComponent);
begin
    inherited;
    if csDesigning in ComponentState then
    begin
        Width := 32;
        Height := 32;
        Color := clWindow;
        FTransparent := True;
    end;
    FPicture := TPicture.Create;
end;

destructor TUniPic.Destroy;
begin
    FPicture.Free;
    inherited;
end;

function TUniPic.GetEmpty: Boolean;
begin
    Result := not Assigned(FImageList) and
        not (Assigned(Picture) and Assigned(Picture.Graphic) and
        not Picture.Graphic.Empty);
end;

procedure TUniPic.Paint;
begin
    PaintToCanvas(Canvas, ClientRect);
end;

procedure TUniPic.Set_Autosize(const Value: Boolean);
begin
    if FAutosize = Value then Exit;
    FAutosize := Value;
    AdjustSize;
end;

procedure TUniPic.SetDesignTimeBorder(const Value: Boolean);
begin
    FDesignTimeBorder := Value;
    Invalidate;
end;

procedure TUniPic.SetImageIndex(const Value: Integer);
begin
    if FImageIndex = Value then Exit;
    FImageIndex := Value;
    Invalidate;
end;

procedure TUniPic.SetImageList(const Value: TImageList);
begin
    if FImageList = Value then Exit;
    FImageList := Value;
    if Value <> nil then
    begin
        if Autosize then
        begin
            Width := Value.Width;
            Height := Value.Height;
        end;
    end;
    AdjustSize;
    Invalidate;
end;

procedure TUniPic.SetPicture(const Value: TPicture);
begin
    FPicture.Assign(Value);
    if (Value <> nil) and (Value.Graphic <> nil) and not Value.Graphic.Empty then
        FImageList := nil;
    AdjustSize;
    Invalidate;
end;

procedure TUniPic.SetStretch(const Value: Boolean);
begin
    if FStretch = Value then Exit;
    FStretch := Value;
    Invalidate;
end;

procedure TUniPic.SetTransparent(const Value: Boolean);
begin
    if FTransparent = Value then Exit;
    FTransparent := Value;
    Invalidate;
end;

procedure TUniPic.SetMouseTransparent(const Value: Boolean);
begin
    FMouseTransparent := Value;
end;

{procedure TUniPic.HitTest(var M: TMessage);
begin
  if MouseTransparent and not( csDesigning in ComponentState ) then
    M.Result := HTTRANSPARENT
  else
    inherited;
end;}

procedure TUniPic.SetStdImage(const Value: TStdImage);
begin
    FStdImage := Value;
    Invalidate;
end;

procedure TUniPic.SetStdImgSmall(const Value: Boolean);
begin
    FStdImgSmall := Value;
    Invalidate;
end;

procedure TUniPic.PrepareStdImageList(var IL: TImageList;
    var IL_index: Integer; var BlackBackground: Boolean);
var TB: TToolbar;
    i, j, k, sz: Integer;

    procedure DoTest(const s: String; i, k: Integer);
    var c, j: Integer;
        {h: HIcon;
        Ico: TIcon;}
        Bmp: TBitmap;
        //cx, cy: Integer;
    begin
        //------------------- test: --------------------------
        c := Images_x[i, k].Count;
        //cx := Images_x[i].Width;
        //cy := Images_x[i].Height;
        for j := 0 to c - 1 do
        begin
            {h := ImageList_ExtractIcon( 0, IL_Handle, j );
            Ico := TIcon.Create;
            TRY
                Ico.Width := sz;
                Ico.Height := sz;
                Ico.Handle := h;
                Ico.SaveToFile( 'c:\' + s + '_' + IntToStr( j ) + '.ico' );
            FINALLY
                Ico.Free;
            END;}
            Bmp := TBitmap.Create;
            Bmp.Width := 48;
            Bmp.Height := 48;
            Bmp.PixelFormat := pf32bit;
            Bmp.Canvas.Brush.Color := clBtnFace;
            Bmp.Canvas.FillRect(Rect(0, 0, Bmp.Width, Bmp.Height));
            //Images_x[i, k].DrawingStyle := dsTransparent;
            Images_x[i, k].Draw(Bmp.Canvas, 0, 0, j);
            //Bmp.SaveToFile( 'c:\111\' + s + '_' + IntToStr( j ) + 'img.bmp' );
            {Bmp.Canvas.FillRect( Rect( 0, 0, Bmp.Width, Bmp.Height ) );
            ImageList_Draw( Images_x[i], j, Bmp.Canvas.Handle, 0, 0, ILD_MASK );
            Bmp.SaveToFile( 'c:\111\' + s + '_' + IntToStr( j ) + 'msk.bmp' );}
            Bmp.Free;
        end;
    end;
var Ico: TIcon;
    Bmp: TBitmap;
    TmpForm: TForm;
    w, h: Integer;
begin
    if Images_x[0, 0] = nil then
    begin
        for i := 0 to 1 do
            for k := 0 to 5 do
            begin
                CASE i OF
                    0: sz := 16;
                else if (k = 3) or (k = 5) then
                    sz := 32
                else
                    sz := 24;
                END;
                Images_x[i, k] := TImageList.Create(nil);
                Images_x[i, k].Handle := ImageList_Create(sz, sz, ILC_COLOR32 or ILC_MASK, 32, 1);
                Images_x[i, k].Width := sz;
                Images_x[i, k].Height := sz;
                TmpForm := TForm.Create(nil);
                TRY
                    TmpForm.Visible := FALSE;
                    TB := TToolbar.Create(TmpForm);
                    TB.Parent := TmpForm;
                    TB.Visible := FALSE;
                    TB.Images := Images_x[i, k];
                    TB.HandleNeeded;
                    //TB[i].Perform( TB_SETIMAGELIST, 0, Images_x[i] );
                    CASE k OF
                        0: TB.Perform(TB_LOADIMAGES, IDB_HIST_SMALL_COLOR + i, -1);
                        1: TB.Perform(TB_LOADIMAGES, IDB_STD_SMALL_COLOR + i, -1);
                        2: TB.Perform(TB_LOADIMAGES, IDB_VIEW_SMALL_COLOR + i, -1);
                        3: begin
                                for j := 32512 to 32517 do
                                begin
                                    Ico := TIcon.Create;
                                    TRY
                                        Ico.Width := sz;
                                        Ico.Height := sz;
                                        Ico.Handle := LoadImage(0, PChar(j), IMAGE_ICON,
                                            sz, sz, LR_SHARED);
                                        Images_x[i, k].AddIcon(Ico);
                                        //Ico.ReleaseHandle;
                                    FINALLY
                                        Ico.Free;
                                    END;
                                end;
                            end;
                        4: begin
                                for j := 32734 to 32767 do
                                begin
                                    Bmp := TBitmap.Create;
                                    TRY
                                        Bmp.Handle := LoadImage(0, PChar(j), IMAGE_BITMAP,
                                            sz, sz, 0 {LR_SHARED});
                                        if Bmp.Handle = 0 then
                                            Bmp.Handle := LoadImage(0, PChar(j), IMAGE_BITMAP,
                                                sz, sz, LR_DEFAULTSIZE {LR_SHARED});
                                        Bmp.PixelFormat := pf32bit;
                                        {Bmp.SaveTofile( 'C:\1\' + IntToStr( j ) + '_' +
                                                        IntToStr( Bmp.Width ) + 'x' +
                                                        IntToStr( Bmp.Height ) + '.bmp' );}
                                        if Images_x[i, k].Count = 0 then
                                        begin
                                            Images_x[i, k].Width := Bmp.Width;
                                            Images_x[i, k].Height := Bmp.Height;
                                        end
                                        else
                                            if (Bmp.Width <> Images_x[i, k].Width)
                                                or (Bmp.Height <> Images_x[i, k].Height) then
                                            begin
                                                Bmp.Canvas.Brush.Color := Bmp.Canvas.Pixels[0, Bmp.Height - 1];
                                                w := Bmp.Width;
                                                h := Bmp.Height;
                                                Bmp.Width := Images_x[i, k].Width;
                                                Bmp.Height := Images_x[i, k].Height;
                                                Bmp.Canvas.FillRect(Rect(w, 0, Bmp.Width, Bmp.Height));
                                                Bmp.Canvas.FillRect(Rect(0, h, w, Bmp.Height));
                                            end;
                                        Images_x[i, k].Add(Bmp, nil);
                                        //Bmp.ReleaseHandle;
                                    FINALLY
                                        Bmp.Free;
                                    END;
                                end;
                            end;
                        5: begin
                                for j := 0 to 2 do
                                begin
                                    Ico := TIcon.Create;
                                    TRY
                                        Ico.Width := sz;
                                        Ico.Height := sz;
                                        Ico.Handle := LoadImage(hInstance,
                                            PChar(UpperCase('Z' + StdImageNames[
                                            TStdImage(Integer(addREFRESH) + j)
                                                ])), IMAGE_ICON,
                                                sz, sz, LR_SHARED);
                                        Images_x[i, k].AddIcon(Ico);
                                        //Ico.ReleaseHandle;
                                    FINALLY
                                        Ico.Free;
                                    END;
                                end;
                            end;
                    END;
                    ////DoTest( 'aaa' + IntToStr( i ) + IntToStr( k ), i, k );
                FINALLY
                    TmpForm.Free;
                    //TB.Free;
                END;
            end;
    end;
    IL_index := Integer(StdImage);
    if StdImgSmall then
        i := 0
    else
        i := 1;
    if StdImage <= histVIEWTREE then
        k := 0
    else
        if StdImage <= stdPRINT then
        begin
            dec(IL_index, 5);
            k := 1
        end
        else
            if StdImage <= viewVIEWMENU then
            begin
                dec(IL_index, 5 + 15);
                k := 2;
            end
            else
                if StdImage <= oicWARNING then
                begin
                    dec(IL_index, Integer(oicSAMPLE));
                    k := 3;
                end
                else
                    if StdImage < addREFRESH then
                    begin
                        dec(IL_index, Integer(obmLFARROWI));
                        k := 4;
                    end
                    else
                    begin
                        dec(IL_index, Integer(addREFRESH));
                        k := 5;
                    end;
    IL := Images_x[i, k];
    BlackBackground := k <> 1;
end;

procedure TUniPic.PaintToCanvas(ToCanvas: TCanvas; const ToR: TRect);
var Bmp1: TBitmap;
    Colr: TColor;
    IL: TImageList;
    IL_index: Integer;
    IL_Black: Boolean;
    cx, cy: Integer;
begin
    if Assigned(ImageList) then
    begin
        IL := ImageList;
        IL_index := ImageIndex;
        IL_Black := FALSE;
    end
    else
        if not Assigned(Picture.Graphic) or Picture.Graphic.Empty then
            PrepareStdImageList(IL, IL_index, IL_Black)
        else
            IL := nil;
    if IL <> nil then
    begin
        inherited;
        cx := IL.Width;
        cy := IL.Height;
        if Stretch or Transparent or IL_Black then
        begin
            {Bmp := TBitmap.Create;
            Bmp.Width := Width;
            Bmp.Height := Height;
            Bmp.PixelFormat := pf32bit;}
            Bmp1 := TBitmap.Create;
            TRY
                Bmp1.Width := cx;
                Bmp1.Height := cy;
                Bmp1.PixelFormat := pf32bit;
                Bmp1.Canvas.Brush.Color := ColorToRGB(Color);
                Bmp1.Canvas.FillRect(Rect(0, 0, cx, cy));
                {---}//Bmp1.SaveTofile( 'C:\' + Name + '_Bmp0.bmp' );
                if Transparent then
                    IL.DrawingStyle := dsTransparent
                else
                    IL.DrawingStyle := dsNormal;
                Bmp1.Transparent := false;
                if IL_Black then
                begin
                    Bmp1.Transparent := TRUE;
                    //Bmp1.TransparentColor := ColorToRGB( Color );
                    //IL.DrawingStyle := dsNormal;
                    IL.DrawingStyle := dsTransparent;
                    IL.Masked := TRUE;
                end;
                IL.Draw(Bmp1.Canvas, 0, 0, IL_index, Enabled);
                {---}//Bmp1.SaveTofile( 'C:\' + Name + '_Bmp1.bmp' );
                if Stretch then
                    {Bmp.Canvas.}ToCanvas.StretchDraw(
                        ToR {Rect( 0, 0, Width, Height )}, Bmp1)
                else
                    {Bmp.Canvas.}ToCanvas.Draw({0, 0,}ToR.Left, ToR.Top, Bmp1);
            FINALLY
                Bmp1.Free;
            END;
            {if  Transparent then
            begin
                Bmp.Transparent := Transparent;
                Bmp.TransparentColor := ColorToRGB( Color );
            end;
            Bmp.SaveTofile( 'C:\' + Name + '_Bmp.bmp' );
            ToCanvas.Draw( ToR.Left, ToR.Top, Bmp );}
            //Bmp.Free;
        end
        else
            IL.Draw(ToCanvas, ToR.Left, ToR.Top, IL_index, Enabled);
        if not Stretch then
            if not Transparent then
            begin
                if Width > cx then
                    ToCanvas.FillRect(Rect(ToR.Left + cx, ToR.Top, Width, cy));
                if Height > cy then
                    ToCanvas.FillRect(Rect(ToR.Left, ToR.Top + cy, Width, Height));
            end;
    end
    else
    begin
        inherited;
        if Assigned(Picture.Graphic) then
        begin
            if Stretch then
                ToCanvas.StretchDraw(ToR, Picture.Graphic)
            else
                ToCanvas.Draw(ToR.Left, ToR.Top, Picture.Graphic);
            if not Stretch then
                if not Transparent then
                begin
                    if Width > Picture.Width then
                        ToCanvas.FillRect(Rect(ToR.Left + Picture.Width, ToR.Top,
                            ToR.Left + Width, ToR.Top + Picture.Height));
                    if Height > Picture.Height then
                        ToCanvas.FillRect(Rect(ToR.Left, ToR.Top + Picture.Height,
                            ToR.Left + Width, ToR.Top + Height));
                end;
        end
        else
        begin
            if not Transparent then
                ToCanvas.FillRect(ToR);
        end;
    end;
    if csDesigning in componentState then
        if FDesignTimeBorder then
        begin
            Colr := ToCanvas.Brush.Color;
            ToCanvas.Brush.Color := clWindowText;
            ToCanvas.FrameRect(ToR);
            ToCanvas.Brush.Color := Colr;
        end;
end;

procedure FinalizyImagesX;
var i: Integer;
begin
    if Images_x[0, 0] <> nil then
    begin
        for i := 0 to 5 do
        begin
            FreeAndNil(Images_x[0, i]);
            FreeAndNil(Images_x[1, i]);
        end;
    end;
end;

function TUniPic.GetPicture: TPicture;
begin
    Result := FPicture;
    if Assigned(FOnGetPicture) then
    begin
        FOnGetPicture(Self, Result);
        if (Result <> nil) and (Result.Graphic <> nil)
            and ((Result.Width <> FPicture.Width)
            or (Result.Height <> FPicture.Height)
            ) then
        begin
            FPicture.Assign(Result);
        end;
    end;
end;

procedure TUniPic.WndProc(var M: TMessage);
var P: TPoint;
    M1: TWMMouse;
begin
    CASE M.Msg OF
        WM_MOUSEFIRST..WM_MOUSELAST:
            begin
                if MouseTransparent and not (csDesigning in ComponentState)
                    and Visible then
                begin
                    if Handling_Mouse then Exit; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
                    Handling_Mouse := TRUE;
                    TRY
                        //M.Result := HTTRANSPARENT;
                        P := ClientToScreen(Point(TWMMouse(M).XPos, TWMMouse(M).YPos));
                        P := Parent.ScreenToClient(P);
                        M1 := TWMMouse(M);
                        M1.XPos := P.X;
                        M1.YPos := P.Y;
                        Visible := FALSE;
                        TRY
                            (Parent as TUniEdit).WndProc(TMessage(M1));
                        FINALLY
                            Visible := TRUE;
                        END;
                        Exit; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
                    FINALLY
                        Handling_Mouse := FALSE;
                    END;
                end;
            end;
    END;
    inherited;
end;

initialization
finalization
    FinalizyImagesX;

end.
