//**  ,     VCL Delphi.
//**  Vladimir Kladov, 2000-2010
//**
//**      .
//**     /     
//**  2          
//**   GNU,  Free Software Foundation.
//**
//**       ,    
//** ,       ,   
//**         
//**   .      
//**     GNU.
//**
//**          
//**   GNU.     ,     Free
//** Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//** MA 02111-1307, USA.
//******************************************************************************

unit WhatToReplace;

interface

//{$DEFINE DEBUG_WTR}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, math, Buttons, Knopka {$IFDEF DEBUG_WTR} , utPhotoExc {$ENDIF}; 

type
  TfmWhatToReplace = class(TForm)
    Panel1: TPanel;
    cbNames: TComboBox;
    btnOK: TButton;
    KPanel: TScrollBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Showed: Boolean;
    SelectedList: array of Integer;
    function SelectedAsString: String;
  end;

var
  fmWhatToReplace: TfmWhatToReplace;

implementation

uses ReplaceExistingKnopka;

{$R *.DFM}

type
    TBtn = class( TControl )
    end;

procedure TfmWhatToReplace.FormCreate(Sender: TObject);
begin
    Caption := WhatToReplace_Caption;
    btnOK.Caption := ButtonReplace_Caption;
end;

procedure TfmWhatToReplace.Button1Click(Sender: TObject);
var Chk: TCheckBox;
begin
    Chk := Pointer( (Sender as TControl).Tag );
    Chk.Checked := not Chk.Checked;
    SelectedList[ Chk.Tag ] := Integer( Chk.Checked );
end;

procedure TfmWhatToReplace.CheckBox1Click(Sender: TObject);
var Chk: TCheckBox;
begin
    Chk := Sender as TCheckBox;
    SelectedList[ Chk.Tag ] := Integer( Chk.Checked );
end;

procedure TfmWhatToReplace.FormShow(Sender: TObject);
var x, y, i, next_x: Integer;
    C: TControl;
    Chk: TCheckBox;
    Btn: TControl;
begin
    if  Showed then Exit;
    Showed := TRUE;
    x := 4;
    y := 4;
    next_x := 0;
    SetLength( SelectedList, cbNames.Items.Count+1 );
    for i := 0 to High(SelectedList) do
        SelectedList[i] := 0;
    for i := 1 to cbNames.Items.Count-1 do
    begin
        {$IFDEF DEBUG_WTR}
        LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                       cbNames.Items[i] );
        {$ENDIF}
        SelectedList[i] := 1;
        C := cbNames.Items.Objects[i] as TControl;
        if  (y > 4) and (y + max( 20, C.Height ) > KPanel.Height - 8) then
        begin
            y := 4;
            x := next_x + 4;
        end;
        Btn := nil;
        if  Btn <> nil then;
        if  C is TKnopka then
            Btn := TKnopka.Create( KPanel )
        else if  C is TPnKnopka then
            Btn := TPnKnopka.Create( KPanel )
        else if  C is TGrKnopka then
            Btn := TGrKnopka.Create( KPanel )
        else if  C is TBitBtn then
            Btn := TBitBtn.Create( KPanel )
        else if  C is TButton then
            Btn := TButton.Create( KPanel )
        else if  C is TSpeedButton then
            Btn := TSpeedButton.Create( KPanel )
        else continue;

        {$IFDEF DEBUG_WTR}
        LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                       '*** Button Created' );
        {$ENDIF}
        Chk := TCheckBox.Create( KPanel );
        Chk.Parent := KPanel;
        Chk.Left := x;
        Chk.Top := y;
        Chk.Width := 20;
        Chk.Checked := TRUE;
        Chk.Tag := i;
        Chk.OnClick := CheckBox1Click;

        Btn.Parent := KPanel;
        Btn.Visible := TRUE;
        //Btn.Assign( C );
        Btn.Width := C.Width;
        Btn.Height := C.Height;

        {$IFDEF DEBUG_WTR}
        LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                       '*** Caption assigning start' );
        {$ENDIF}
        if  C is TKnopka then
            (Btn as TKnopka).Caption := (C as TKnopka).Caption
        else
        if  C is TPnKnopka then
            (Btn as TPnKnopka).Caption := (C as TPnKnopka).Caption
        else
        if  C is TGrKnopka then
            (Btn as TGrKnopka).Caption := (C as TGrKnopka).Caption
        else
        if  C is TButton then
            (Btn as TButton).Caption := (C as TButton).Caption
        else
        if  C is TSpeedButton then
            (Btn as TSpeedButton).Caption := (C as TSpeedButton).Caption;

        Btn.Hint := C.Name + ': ' + C.ClassName;

        {$IFDEF DEBUG_WTR}
        LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                       '*** Caption assigning end' );
        {$ENDIF}

        if  C is TBitBtn then
        begin
            {$IFDEF DEBUG_WTR}
            LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                           '*** TBitBtn Glyph assign' );
            {$ENDIF}
            (Btn as TBitBtn).Glyph.Assign( (C as TBitBtn).Glyph );
            (Btn as TBitBtn).NumGlyphs := (C as TBitBtn).NumGlyphs;
        end;
        if  C is TSpeedButton then
        begin
            {$IFDEF DEBUG_WTR}
            LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                           '*** TSpeedButton Glyph assign' );
            {$ENDIF}
            (Btn as TSpeedButton).Glyph.Assign( (C as tSpeedButton).Glyph );
            (Btn as TSpeedButton).NumGlyphs := (C as TSpeedButton).NumGlyphs;
        end;
        if  C is TKnopka then
        begin
            {$IFDEF DEBUG_WTR}
            LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                           '*** TKnopka Picture/ImageList/StdImage assign' );
            {$ENDIF}
            (Btn as TKnopka).Picture.Assign( (C as TKnopka).Picture );
            (Btn as TKnopka).ImageList := (C as TKnopka).ImageList;
            (Btn as TKnopka).ImageIndex := (C as TKnopka).ImageIndex;
            (Btn as TKnopka).StdImage := (C as TKnopka).StdImage;
            (Btn as TKnopka).StdImgShowSize := (C as TKnopka).StdImgShowSize;
        end;
        if  C is TPnKnopka then
        begin
            {$IFDEF DEBUG_WTR}
            LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                           '*** TPnKnopka Picture/ImageList/StdImage assign' );
            {$ENDIF}
            (Btn as TPnKnopka).Picture.Assign( (C as TPnKnopka).Picture );
            (Btn as TPnKnopka).ImageList := (C as TPnKnopka).ImageList;
            (Btn as TPnKnopka).ImageIndex := (C as TPnKnopka).ImageIndex;
            (Btn as TPnKnopka).StdImage := (C as TPnKnopka).StdImage;
            (Btn as TPnKnopka).StdImgShowSize := (C as TPnKnopka).StdImgShowSize;
        end;
        if  C is TGrKnopka then
        begin
            {$IFDEF DEBUG_WTR}
            LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                           '*** TGrKnopka Picture/ImageList/StdImage assign' );
            {$ENDIF}
            (Btn as TGrKnopka).Picture.Assign( (C as TGrKnopka).Picture );
            (Btn as TGrKnopka).ImageList := (C as TGrKnopka).ImageList;
            (Btn as TGrKnopka).ImageIndex := (C as TGrKnopka).ImageIndex;
            (Btn as TGrKnopka).StdImage := (C as TGrKnopka).StdImage;
            (Btn as TGrKnopka).StdImgShowSize := (C as TGrKnopka).StdImgShowSize;
        end;

        {$IFDEF DEBUG_WTR}
        LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                       '*** OnClick assign' );
        {$ENDIF}
        Btn.Left := x + 20;
        Btn.Top := y;
        Btn.Tag := DWORD( Chk );
        TBtn( Btn ).OnClick := Button1Click;
        next_x := max( next_x, x + 20 + Btn.Width );
        y := y + max( 20, Btn.Height ) + 4;
        {$IFDEF DEBUG_WTR}
        LogFileOutPut( 'c:\1\Log_WTR.txt', 'i=' + IntToStr( i ) + '; ' +
                       '+++ FINISH +++' );
        {$ENDIF}
    end;
end;

procedure TfmWhatToReplace.FormDestroy(Sender: TObject);
begin
    {$IFDEF DEBUG_WTR}
    LogFileOutPut( 'c:\1\Log_WTR.txt', 'FormDestroy' );
    {$ENDIF}
    SetLength( SelectedList, 0 );
    {$IFDEF DEBUG_WTR}
    LogFileOutPut( 'c:\1\Log_WTR.txt', 'FormDestroy END' );
    {$ENDIF}
end;

function TfmWhatToReplace.SelectedAsString: String;
var i: Integer;
begin
    Result := '';
    for i := 0 to High(SelectedList) do
        Result := Result + ' [' + IntToStr( i ) + ']=' +
                  IntToStr( SelectedList[i] );
end;

end.

