{************************************************}
{                                                }
{    TPhotographer      }
{          ErrLog  }
{    , ,   , }
{    N ,     }
{    SQL  .. (.  utTraceLog,  }
{   AdoSQLUnit).                                 }
{   Copyright (c) 2004 by Vladimir Kladov        }
{                                                }
{           09.01.2004         }
{                                                }
{************************************************}
{           09.01.2004         }
{        , , , }
{      .                             }
{************************************************}
unit utPhotoExc;
{*
     :
  1.      (    , ,
        )  
     Application.OnException := Photographer.AppException;
          Photographer.AppException.
  2.      Screen.OnActiveFormChange 
     Screen.OnActiveControlChange   
     Photographer.FormChange  Photographer.ControlChange  ,
             :
     Screen.OnActiveFormChange := Photographer.FormChange;
     Screen.OnActiveControlChange := Photographer.ControlChange;
  3.    LoginName  AppVersion,   
       .   ,  
       ,        
     .
  4.    AdoSQLUnit  ,   
             10  SQL-
         .
}

//{$DEFINE SAVE_TO_ERRLOG_DB} //       ErrLog  
//{$DEFINE SAVE_TO_LASTERRLOG} //      c:\LastErrorLog.txt

{$DEFINE METAFILES} //      jpeg

{$IFNDEF SAVE_TO_ERRLOG_DB}
{$IFNDEF SAVE_TO_LASTERRLOG}
{$IFNDEF NOSAVEERRORS}
         {$DEFINE SAVE_TO_LASTERRLOG}
{$ENDIF}
{$ENDIF}
{$ENDIF}

interface

{$I VCL_VERSIONS.INC}

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  comctrls, imglist, commctrl, jpeg, FileCtrl, dbtables, db, utTraceLog, utStr,
  AdoSQLUnit {$IFDEF ADO_DB}, AdoDb {$ENDIF}, StackUnit;

var LastErrorLog_txt: String = 'C:\LastErrorLog.txt';
    ForceCanvas: HDC = 0;

type
  TPhotographer = class
  private
  protected
    FTraceForms: TStringList;
    procedure AddToFormTrace( const S: String );
  public
    constructor Create;
    destructor Destroy; override;
    function PathToUse: String;
    procedure SaveBitmap( Bmp: TBitmap );
    procedure WriteLog( const S: String );
    procedure AppException(Sender: TObject; E: Exception);
    procedure FormChange( Sender: TObject );
    procedure ControlChange( Sender: TObject );
    procedure SnapFormsToStream( Stm: TStream );
  end;

var Photographer: TPhotographer;
    LoginName: String;
    ServerName: String;
    AppVersion: String;
    {$IFDEF ADO_DB}
    ADOTable1: TADOTable;
    {$ELSE}
    ADOTable1: TTable;
    {$ENDIF}
    MaxCrackedStack: Integer = 1000;

type
    TOnMsgForm = function( const MsgText: String ): Integer of object;
var OnMsgForm: TOnMsgForm;

procedure LogFileOutPut( const Filename, Text: String );
function ReplaceExtension( const s, NewExt: String ): String;
function CrackStack( AtAddr: DWORD ): String;
function CrackSoftStack( idx: Integer ): String;

implementation //    !
               //     
               //   entry( )     
               // 

procedure LogFileOutPut( const Filename, Text: String );
var F: TFileStream;
    Flg: DWORD;
begin
  Flg := fmOpenReadWrite;
  if not FileExists( Filename ) then
    Flg := Flg or fmCreate;
  F := TFileStream.Create( Filename, Flg );
  F.Position := F.Size;
  F.Write( (Text + #13#10)[ 1 ], Length( Text ) + 2 );
  F.Free;
end;

function ReplaceExtension( const s, NewExt: String ): String;
var i: Integer;
begin
    Result := s;
    for i := Length( s ) downto 1 do
        if s[ i ] = '.' then
        begin
            Result := Copy( s, 1, i-1 ) + NewExt;
            Exit;
        end;
    Result := s + NewExt;
end;

var CrackedStack: String;
    MapFile: TStringList;
    LineNumbersFrom: Integer;
    BelowBasePtr: PDWORD;

function DoCrackSingleFrame( RetAddr: DWORD; BasePtr: DWORD ): Boolean;
var i, j, R: Integer;
    A, Prev_A, N, Prev_N: DWORD;
    s, CurUnit: String;
    Add_string: String;
    Line_found: Boolean;
begin
    Result := FALSE;
    if Length( CrackedStack ) > MaxCrackedStack then Exit;
    Result := TRUE;
    if RetAddr >= $70000000 then
    begin
        CrackedStack := CrackedStack + #13#10'$' + IntToHex( RetAddr, 8 );
        Exit;
    end;
    Result := FALSE;
    if RetAddr < $400000 then Exit;

    if (BelowBasePtr <> nil) and (BasePtr <> 0) and (DWORD( BelowBasePtr ) < BasePtr) then
    begin
        BelowBasePtr := Pointer( DWORD( BelowBasePtr ) + 4 );
        while DWORD( BelowBasePtr ) < BasePtr do
        begin
            A := BelowBasePtr^;
            if (A > $400000) and (A < $700000) then
                DoCrackSingleFrame( A, 0 );
            BelowBasePtr := Pointer( DWORD( BelowBasePtr ) + 4 );
        end;
    end;
    if BasePtr <> 0 then
        BelowBasePtr := Pointer( BasePtr );

    Add_string := '';

    // 1st: find
    Prev_A := 0;
    for i := 0 to MapFile.Count-1 do
    begin
        s := MapFile[ i ];
        if s = '' then
            Exit;
        R := 0;
        j := 1;
        while (j <= Length( s )) and (s[j] <= ' ') do inc( j );
        while (j <= Length( s )) and (s[j] in ['0'..'9','A'..'F']) do
        begin
            if s[j] <= '9' then R := R * 16 + Ord( s[j] ) - Ord( '0' )
            else R := R * 16 + Ord( s[j] ) - Ord( 'A' ) + 10;
            inc( j );
        end;
        if (j > Length( s )) or (s[ j ] <> ':') then Exit;
        inc( j );
        A := 0;
        while (j <= Length( s )) and (s[j] in ['0'..'9','A'..'F']) do
        begin
            if s[j] <= '9' then A := A * 16 + Ord( s[j] ) - Ord( '0' )
            else A := A * 16 + Ord( s[j] ) - Ord( 'A' ) + 10;
            inc( j );
        end;
        A := A + $401000;
        //if (j > Length( s )) then Exit;
        if (Prev_A <= RetAddr) and (A > RetAddr) and (Prev_A > 0) and (R = 1) then
        begin
            s := MapFile[ i-1 ];
            j := pos( ':', s );
            if j <= 0 then Exit;
            s := Copy( s, j+1, MaxInt );
            for j := 1 to Length( s ) do
                if s[ j ] <= ' ' then
                begin
                    s := Trim( Copy( s, j, MaxInt ) );
                    Add_string := #13#10;
                    if BasePtr = 0 then
                        Add_string := Add_string + '? ' + IntToHex( RetAddr, 8 ) + ':';
                    Add_string := Add_string + s;
                    Result := TRUE;
                    break;
                end;
        end;
        Prev_A := A;
        if Result then break;
    end;
    if not Result then Exit;
    //      ,       

    Line_found := FALSE;
    CurUnit := '';
    Prev_N := 0;
    Prev_A := 0;
    for i := LineNumbersFrom to MapFile.Count-1 do
    begin
        s := MapFile[ i ];
        if Copy( s, 1, 4 ) = 'Line' then
        begin
            j := pos( '(', s );
            if j > 0 then
            begin
                s := Copy( s, j+1, MaxInt );
                j := pos( ')', s );
                if j > 0 then
                    s := Copy( s, 1, j-1 );
            end;
            CurUnit := s;
            Prev_N := 0;
        end
          else
        if s <> '' then
        begin
            j := 1;
            while j < Length( s ) do
            begin
                while (j <= Length( s )) and (s[j] <= ' ') do inc( j );
                N := 0;
                while (j <= Length( s )) and (s[j] in [ '0'..'9' ]) do
                begin
                    N := N * 10 + Ord( s[j] ) - Ord( '0' );
                    inc( j );
                end;
                while (j <= Length( s )) and (s[j] <= ' ') do inc( j );
                R := 0;
                while (j < Length( s )) and (s[j] in [ '0'..'9', 'A'..'F' ]) do
                begin
                    if s[j] <= '9' then
                        R := R * 16 + Ord( s[j] ) - Ord( '0' )
                    else R := R * 16 + Ord( s[j] ) - Ord( 'A' ) + 10;
                    inc( j );
                end;
                while (j <= Length( s )) and (s[j] <= ' ') do inc( j );
                if (j <= Length(s)) and (s[ j ] = ':') then inc( j );
                while (j <= Length( s )) and (s[j] <= ' ') do inc( j );
                A := 0;
                while (j <= Length( s )) and (s[j] in [ '0'..'9', 'A'..'F' ]) do
                begin
                    if s[j] <= '9' then
                        A := A * 16 + Ord( s[j] ) - Ord( '0' )
                    else A := A * 16 + Ord( s[j] ) - Ord( 'A' ) + 10;
                    inc( j );
                end;
                A := A + $401000;
                if (Prev_A <= RetAddr) and (A > RetAddr) then
                begin
                    if (Prev_A > 0) and (Prev_N > 0) then
                    begin
                        Add_string := Add_string + ' in ' + CurUnit + ', line: ' +
                            IntToStr( Prev_N );
                        Line_found := TRUE;
                    end;
                    s := '';
                    break;
                end;
                Prev_N := N;
                Prev_A := A;
                if Line_found then break;
            end;
        end;
        if Line_found then break;
    end;
    if not Line_found and (BasePtr = 0) then Exit;
    CrackedStack := CrackedStack + Add_string;
end;

procedure DoCrackStack;
asm
    mov  edx, ebp
@@loop:
    mov  ecx, [edx]
    mov  eax, [edx+4]
    mov  edx, ecx
    push edx
    call DoCrackSingleFrame
    pop  edx
    test al, al
    jnz  @@loop
end;

function CrackStack( AtAddr: DWORD ): String;
var MapFileName: String;
    i, j: Integer;
    s: String;
begin
    Result := '';
    CrackedStack := '';
    BelowBasePtr := nil;
    TRY
        if MapFile = nil then
        begin
            MapFileName := ReplaceExtension( Application.ExeName, '.map' );
            if FileExists( MapFileName ) then
            begin
                MapFile := TStringList.Create;
                MapFile.LoadFromFile( MapFileName );
                for i := 0 to MapFile.Count-1 do
                begin
                    s := MapFile[ i ];
                    if pos( 'Publics by Value', s ) > 0 then
                    begin
                        j := i;
                        if Trim( MapFile[ j+1 ] ) = '' then
                            inc( j );
                        for j := j downto 0 do
                            MapFile.Delete( j );
                        for j := 0 to MapFile.Count-1 do
                        begin
                            s := Trim( MapFile[ j ] );
                            if (s = '') and (LineNumbersFrom = 0) then
                            begin
                                LineNumbersFrom := j;
                            end;
                            if s = 'Bound resource files' then
                            begin
                                while MapFile.Count > j do
                                    MapFile.Delete( j );
                                break;
                            end;
                        end;
                        break;
                    end;
                end;
            end;
        end;

        if AtAddr <> 0 then
            DoCrackSingleFrame( AtAddr, 0 );
        DoCrackStack;
        if CrackedStack <> '' then
            CrackedStack := #13#10 + CrackedStack;
    EXCEPT
        //// ignore errors which occur while cracking stack ////----------------
    END;
    Result := CrackedStack;
end;

function CrackSoftStack( idx: Integer ): String;
var i: Integer;
begin
    Result := '';
    if  CurFunStack[idx] = 0 then Exit;
    Result := Result + #13#10#13#10;
    for i := 0 to CurFunStack[idx]-1 do
    begin
        Result := Result + IntToHex( FunStack[idx, i].stackVal, 8 ) + ' - ' +
               FunStack[idx, i].fun_name + #13#10;
    end;
    Result := Result + #13#10;
end;

{ TPhotographer }

procedure TPhotographer.AddToFormTrace(const S: String);
begin
  FTraceForms.Add( S );
  if FTraceForms.Count > 10 then
    FTraceForms.Delete( 0 );
end;

procedure TPhotographer.AppException(Sender: TObject; E: Exception);
var DC: HDC;
    Bmp: TBitmap;
    {$IFDEF SAVE_TO_ERRLOG_DB}
    Q: TQuery;
    Jpg: TJPEGImage;
    Stm: TMemoryStream;
    Log: String;
    {$ENDIF}
    ComputerName: array[ 0..MAX_COMPUTERNAME_LENGTH ] of Char;
    L: DWORD;
    P: TPoint;
    S, S2: String;
    {$IFDEF ADO_DB}
    {$IFDEF SAVE_TO_ERRLOG_DB}
    T: TADOTable;
    BS: TADOBlobStream;
    {$ENDIF}
    {$ELSE}
    {$ENDIF}
    SL: TStringList;
    OK: Boolean;
begin
  GetCursorPos( P );
  //WriteLog( ' (' + E.ClassName + '): ' + E.Message );
  DC := GetDC( 0 );
  Bmp := TBitmap.Create;
  SL := TStringList.Create;
  OK := FALSE;
  if  not OK then
  try
    SL.Add( #13#10'---------------------------------------------------' );
    MaxCrackedStack := 20000;
    S := '(' + E.ClassName + '): ' + E.Message +
            CrackSoftStack(0) + CrackSoftStack(1) + CrackStack( 0 );
    SL.Add( LoginName + ' ' + Application.Title + ' ' + AppVersion +
            ' ' + ComputerName + ' ' +
            FormatDateTime( 'dd.mm.yyyy hh:nn:ss', Now ) );
    SL.Add( S );
    S2 := SqlLog.Get; SL.Add( S2 );

    Bmp.Width  := Screen.Width;
    Bmp.Height := Screen.Height;
    BitBlt( Bmp.Canvas.Handle, 0, 0, Bmp.Width, Bmp.Height, DC, 0, 0, SRCCOPY );
    ReleaseDC( 0, DC );
    DC := 0;

    Bmp.Canvas.Pen.Color := clRed;
    Bmp.Canvas.MoveTo( P.x, P.y - 6 );
    Bmp.Canvas.LineTo( P.x, P.y + 7 );
    Bmp.Canvas.MoveTo( P.x - 6, P.y );
    Bmp.Canvas.LineTo( P.x + 7, P.y );

    L := Sizeof( ComputerName );
    GetComputerName( @ ComputerName[ 0 ], L );

    {$IFDEF SAVE_TO_ERRLOG_DB}
    Stm := TMemoryStream.Create;
    Jpg := TJPEGImage.Create;

    try

      {$IFDEF METAFILES}
          SnapFormsToStream( Stm );
      {$ELSE}
          Jpg.Assign( Bmp );
          Jpg.CompressionQuality := 75;
          Jpg.SaveToStream( Stm );
          Jpg.Free;
          Jpg := nil;
      {$ENDIF}



      Bmp.Free;
      Bmp := nil;
      Stm.Position := 0;

      {$IFDEF ADO_DB}

      Q := TQuery.Create( nil );
      if ADOTable1 <> nil then
        T := ADOTable1
      else
      begin
        T := TAdoTable.Create( nil );
        T.Connection := Q.Connection;
        T.TableName := 'ErrLog';
        T.TableDirect := TRUE;
      end;
      TRY
        T.Active := TRUE;
        T.Insert;
        T.FieldByName( 'UserLogin' ).AsString := LoginName;
        T.FieldByName( 'AppName' ).AsString := StrCopy( Application.ExeName, 1, 255 );
        T.FieldByName( 'AppVersion' ).AsString := AppVersion;
        T.FieldByName( 'MachineName' ).AsString := ComputerName;
        T.FieldByName( 'ErrTime' ).AsDateTime := Now;
        BS := TADOBlobStream.Create( T.FieldByName( 'MsgText' ) As TBlobField,
           bmWrite );
        TRY
          BS.Write( S[ 1 ], Length( S ) );
        FINALLY
          BS.Free;
        END;
        BS := TADOBlobStream.Create( T.FieldByName( 'Screen' ) As TBlobField,
           bmWrite );
        TRY
          Stm.Position := 0;
          BS.CopyFrom( Stm, Stm.Size );
        FINALLY
          BS.Free;
        END;
        BS := TADOBlobStream.Create( T.FieldByName( 'Trace' ) As TBlobField,
           bmWrite );
        TRY
          //S2 := SqlLog.Get;
          SL.Add( S2 );
          if S2 <> '' then
          begin
            BS.Write( S2[ 1 ], Length( S2 ) );
          end;
        FINALLY
          BS.Free;
        END;
        TRY
          T.Post;
        EXCEPT on E: Exception do
               begin
                 ShowMessage( '        ' +
                              ' , : ' + E.Message +
                              #13#10#13#10' : ' +
                              S );
               end;
        END;
      FINALLY
        T.Active := FALSE;
        if ADOTable1 = nil then
          T.Free;
        Q.Free;
      END;
      {$ELSE}
      Q := TQuery.Create( nil );
      TRY

        Q.SQL.Text := 'insert into ErrLog( UserLogin, MachineName, ErrTime, MsgText,' +
                   #13'Screen, Trace, AppName, AppVersion' +
                   #13' ) values ( ' +
                   #13'' + StrToSQL( LoginName ) + ', ' + StrToSQL( ComputerName )
                   + ',' +
                   #13'GetDate(), ' +
                   {$IFDEF ODBC_DIRECT}
                   '?, ?, ?' +
                   {$ELSE}
                    ':msg, :scr, :log' +
                   {$ENDIF}
                   #13', ' + StrToSQL( Copy( Application.ExeName, 1, 255 ) ) + ', ' +
                   #13'' + StrToSQL( AppVersion ) + ' )';
        TRY
          S := '(' + E.ClassName + '): ' + E.Message;
          S := S + #13#13 + FTraceForms.Text;
        EXCEPT
        END;
        L := Length( S ) + 1;
        {$IFDEF ADO_DB}
        MS := TMemoryStream.Create;
        TRY
          MS.Write( S[ 1 ], L );
          MS.Position := 0;
          Q.BParam[ 'msg' ] := MS;
        FINALLY
          MS.Free;
        END;
        {$ELSE}
            {$IFDEF ODBC_DIRECT}
            Q.BParam['1'] := S;
            {$ELSE}
            Q.ParamByName( 'msg' ).SetBlobData( @ S[ 1 ], L );
            {$ENDIF}
        {$ENDIF}
        if Stm.Size > 0 then
        begin
          {$IFDEF ADO_DB}
          Stm.Position := 0;
          Q.BParam[ 'scr' ] := Stm;
          {$ELSE}
              {$IFDEF ODBC_DIRECT}
              SetString( S, PChar( Stm.Memory ), Stm.Size );
              Q.BParam['2'] := S;
              {$ELSE}
              Q.ParamByName( 'scr' ).SetBlobData( Stm.Memory, Stm.Size );
              {$ENDIF}
          {$ENDIF}
        end;
        Log := sqlLog.Get +
            CrackSoftStack(0) + CrackSoftStack(1) + CrackStack( DWORD( 0 ) );
        if Log <> '' then
        begin
          {$IFDEF ADO_DB}
          MS := TMemoryStream.Create;
          TRY
            MS.Write( Log[ 1 ], Length( Log ) );
            MS.Position := 0;
            Q.BParam[ 'log' ] := MS;
          FINALLY
            MS.Free;
          END;
          {$ELSE}
              {$IFDEF ODBC_DIRECT}
                  Q.BParam['3'] := Log;
              {$ELSE}
                  Q.ParamByName( 'log' ).SetBlobData( @ Log[ 1 ], Length( Log ) );
              {$ENDIF}
          {$ENDIF}
        end
        else
        begin
          {$IFDEF ODBC_DIRECT}
          Q.BParam['3'] := ' ';
          {$ELSE}
          Q.ParamByName( 'log' ).DataType := ftBlob;
          Q.ParamByName( 'log' ).clear;
          {$ENDIF}
        end;
        Q.ExecSQL;

        //??OK := TRUE;

      FINALLY
        Q.Free;
      END;
      {$ENDIF}
    finally
      Stm.Free;
      Jpg.Free;
    end;

    {$ENDIF SAVE_TO_ERRLOG_DB}

  finally
    if DC <> 0 then
      ReleaseDC( 0, DC );
    Bmp.Free;
    {$IFDEF SAVE_TO_ERRLOG}
      LogFileOutPut( LastErrorLog_txt, SL.Text );
    {$ENDIF}
    MaxCrackedStack := 1000;
    if  Assigned( OnMsgForm ) then
        OnMsgForm( E.Message + CrackSoftStack(0) + CrackSoftStack(1) + CrackStack( DWORD( 0 ) ) )
    else
        MessageBox( Application.Handle, PChar(E.Message +
                    CrackSoftStack(0) + CrackSoftStack(1) + CrackStack( DWORD( 0 ) ) ),
                    nil, MB_OK + MB_ICONSTOP);

    SL.Free;
  end;
end;

procedure TPhotographer.ControlChange(Sender: TObject);
begin
  if Screen.ActiveControl <> nil then
    AddToFormTrace( ' : ' + Screen.ActiveControl.Name );
end;

constructor TPhotographer.Create;
begin
  inherited;
  FTraceForms := TStringList.Create;
end;

destructor TPhotographer.Destroy;
begin
  FTraceForms.Free;
  inherited;
end;

procedure TPhotographer.FormChange(Sender: TObject);
begin
  if Screen.ActiveForm <> nil then
  AddToFormTrace( ' : ' + Screen.ActiveForm.Name + ' (: ' +
                  Screen.ActiveForm.Caption + ')' );
end;

function TPhotographer.PathToUse: String;
begin
  //Result := ExtractFilePath( Application.ExeName );
  Result := '';
  if not DirectoryExists( 'C:\' ) then Exit;
  Result := 'C:\';
  {if not DirectoryExists( Result ) then
    MkDir( Result );}
end;

procedure TPhotographer.SaveBitmap(Bmp: TBitmap);
var S: String;
    I: Integer;
    Jpg: TJPEGImage;
begin
  for I := 1 to MaxInt do
  begin
    S := PathToUse + 'Snap' + IntToStr( I ) + '.jpg';
    if not FileExists( S ) then break;
  end;
  Jpg := TJPEGImage.Create;
  try
    //Jpg.
    Jpg.Assign( Bmp );
    Jpg.SaveToFile( S );
  finally
    Jpg.Free;
  end;
end;

procedure TPhotographer.SnapFormsToStream(Stm: TStream);
var i, L, dx, dy: Integer;
    C: TComponent;
    F: TCustomForm;
    DC0, MDC: HDC;
    R: TRect;
    P: TPoint;
    MF: TMetafile;
    MS: TMemoryStream;
    DBuf: Boolean;
    //B: TBitmap;
begin
    if  Application = nil then Exit;
    for i := 0 to Application.ComponentCount-1 do
    begin
        C := Application.Components[i];
        if  C is TCustomForm then
        begin
            F := C as TCustomForm;
            if  not F.Visible then
                Continue;
            //F.ControlState := F.ControlState + [ csPaintCopy ];
            DC0 := GetDC( 0 );
            TRY
                R := Rect( 0, 0,
                     MulDiv(F.Width, GetDeviceCaps(DC0, HORZSIZE)*100, GetDeviceCaps(DC0, HORZRES)),
                     MulDiv(F.Height, GetDeviceCaps(DC0, VERTSIZE)*100, GetDeviceCaps(DC0, VERTRES)) );
                MDC := CreateEnhMetaFile( DC0, nil, @ R, '' );
            FINALLY
                ReleaseDC( 0, DC0 );
            END;
            MF := TMetafile.Create;
            MS := TMemoryStream.Create;
            TRY
                P := F.ClientToScreen( Point( 0, 0 ) );
                dx := P.X - F.Left;
                dy := P.Y - F.Top;
                //F.Perform( WM_NCPAINT, 1, 0 );
                //SetWindowsHookEx(  );
                SelectClipRgn( MDC, 0 );
                DBuf := F.DoubleBuffered;
                F.DoubleBuffered := FALSE;

                {B := TBitmap.Create;
                B.PixelFormat := pf32bit;
                B.Width := F.Width;
                B.Height := F.Height;
                ForceCanvas := B.Canvas.Handle;
                F.PaintTo( B.Canvas.Handle, 0, 0 );
                B.SaveToFile( 'C:\' + IntToStr( i ) + '.bmp' );
                B.Free;}

                ForceCanvas := MDC;
                F.PaintTo( MDC, dx, dy );

                F.DoubleBuffered := DBuf;
                //F.Perform( WM_PRINT, MDC,
                //    PRF_CHILDREN or PRF_CLIENT or PRF_NONCLIENT );
                //F.Perform( WM_PRINT, MDC,
                //    PRF_NONCLIENT );
                {F.Perform( WM_PRINT, MDC,
                    PRF_CLIENT );}
                MF.Handle := CloseEnhMetaFile( MDC );
                MF.SaveToStream( MS );
                L := MS.Size;
                Stm.Write( L, 4 );
                MS.Position := 0;
                MS.SaveToStream( Stm );
                MS.Position := 0;
                MS.SaveToFile( 'c:\' + IntToStr( i ) + '.emf' );

                MS.Position := 0;
            FINALLY
                MF.Free;
                MS.Free;
                //F.ControlState := F.ControlState - [ csPaintCopy ];
                ForceCanvas := 0;
            END;
        end;
    end;
end;

procedure TPhotographer.WriteLog(const S: String);
var F: TFileStream;
    N: String;
    Mode: DWORD;
    Path: String;
begin
  Path := PathToUse;
  N := Path + 'Log.txt';
  if (Path <> '') and DirectoryExists( Path ) then
  begin
    Mode := fmOpenReadWrite;
    if not FileExists( N ) then
      Mode := fmCreate;
    F := TFileStream.Create( N, Mode );
    F.Position := F.Size;
    N := FormatDateTime( 'd.m.yyyy hh:nn:ss ', Now ) + S + #13#10;
    F.Write( N[ 1 ], Length( N ) );
    F.Position := F.Size;
    F.Free;
  end;
end;

Initialization

  if Photographer = nil then
    Photographer := TPhotographer.Create;

Finalization

  Application.OnException := nil;
  Photographer.Free;
  Photographer := nil;

end.
