//**  ,     VCL Delphi.
//**  Vladimir Kladov, 2000-2010
//**
//**      .
//**     /     
//**  2          
//**   GNU,  Free Software Foundation.
//**
//**       ,    
//** ,       ,   
//**         
//**   .      
//**     GNU.
//**
//**          
//**   GNU.     ,     Free
//** Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//** MA 02111-1307, USA.
//******************************************************************************

unit utTraceLog;

interface

uses windows, classes, sysutils, db;

const
  MaxTraceCount = 2000;

type
  TLog = class
  private
    FLog: TStringList;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    procedure Add( const S: String );
    function Get: String;
  end;

var sqlLog: TLog;

procedure AddToTraceLog( S: String; Params: TParams );

implementation

procedure AddToTraceLog( S: String; Params: TParams );
var I: Integer;
begin
  if sqlLog = nil then Exit;
  if Params <> nil then
  for I := 0 to Params.Count - 1 do
    S := S + #13#10 + Params[ I ].Name + '=' + Params[ I ].AsString;
  sqlLog.Add( S );
end;

{ TLog }

procedure TLog.Add(const S: String);
var ST: TSystemTime;
begin
  GetSystemTime( ST );
  FLog.Add( #13#10'--' +
            Format( '%.02d.%.02d.%.04d %.02d:%.02d:%.02d ',
            [ ST.wDay, ST.wMonth, ST.wYear, ST.wHour, ST.wMinute, ST.wSecond ] ) +
            S );
  while FLog.Count > MaxTraceCount do
    FLog.Delete( 0 );
end;

constructor TLog.Create;
begin
  inherited;
  FLog := TStringList.Create;
end;

destructor TLog.Destroy;
begin
  FLog.Free;
  FLog := nil;
  inherited;
end;

function TLog.Get: String;
begin
  Result := FLog.Text;
  FLog.Text := '';
end;

initialization
  sqlLog := TLog.Create;

finalization
  sqlLog.Free;
  sqlLog := nil;

end.
